/*  A simple animator
   
*/
#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>
#include "xpplim.h"

#include "toons.h"
#include "animate.h"
#include "structs.h"
#define MAX_ANI_LINES 500

#define MAX_LEN_SBOX 25
double atof();
#define LINE 0
#define RLINE 1
#define CIRC 2
#define FCIRC 3
#define ARECT 4
#define FRECT 5
#define ATEXT 6
#define VTEXT 7
#define ELLIP 9
#define FELLIP 10
/*  not for drawing */

#define SETTEXT 8

/*  Not in command list   */

#define TRANSIENT 20
#define PERMANENT 21
#define END 50
#define DIMENSION 22
#define COMMENT 30
#define SPEED 23

#define MAX_ANI_LINES 500

#define FIRSTCOLOR 12
int firsttime=0;

extern char color_list[12][20];
extern int colorline[];

extern int color_total,screen;
extern int DCURX,DCURXs,DCURY,DCURYs,CURY_OFFs,CURY_OFF,NODE;

extern HINSTANCE hInst;
HPEN a_pen,a_oldpen;
HBRUSH a_brush,a_oldbrush;
HFONT a_font,a_oldfont;

 BOOL CALLBACK AnimateDialogFunc(HWND,UINT,WPARAM,LPARAM); 
double evaluate();

int aniflag;

int ani_line;

int ani_speed=50;
int ani_speed_inc=5;

double ani_xlo=0,ani_xhi=1,ani_ylo=0,ani_yhi=1;
double ani_lastx,ani_lasty;

int AniLineColor,AniTextColor,AniLineWidth,AniTextSize,AniTextFont;


typedef struct {
  int type, flag;
  int *col,*x1,*y1,*x2,*y2;
  double zcol,zx1,zy1,zx2,zy2,zrad,zval;
  int zthick,tfont,tsize,tcolor;  
} ANI_COM;

ANI_COM my_ani[MAX_ANI_LINES];


typedef struct {
HWND w;    
int hgt,wid,iexist,ok;
int pos,inc,running;
char file[256];
char title[256];
} VCR;

VCR vcr; 


int n_anicom;


int ani_text_size;
int ani_text_color;
int ani_text_font;

HDC ani_gc;

extern BROWSER my_browser;

HBITMAP anibitmap;

char *get_first(/* char *string,char *src */);
char *get_next(/* char *src */);


/* Colors 
  no color given is default black on white background or white on black
  $name is named color -- red ... purple
  otherwise evaluated - if between 0 and 1 a spectral color
*/

/* scripting language is very simple:
 dimension xlo;ylo;xhi;yh
 transient
 permanent
 line x1;y1;x2;y2;col;thick --  last two optional   
 rline x2;y2;col;thick  -- last two optional
 circle x1;x2;r;col;thick   -- last optional
 fcircle x1;x2;r;col  -- last 2 optional
 rect x1;y1;x2;y2;col;thick -- last 2 optional
 frect x1;y1;x2;y2;col -- last optional
 ellip x1;y1;rx;ry;col;thick 
 fellip x1;y1;rx;ry;col;thick 
 text x1;y1;s      
 vtext x1;y1;s;v
 settext size;font;color -- size 1-5,font roman symbol,color as above
 speed delay in msec
 *****
 rline is relative to end of last point
 fcircle filled circle
 rect rectangle
 frect filled rect
 text  string s at (x,y)  if v included then a number

 eg   text .3;.3;t=%g;t
 
 will do a sprintf(string,"t=%g",t);

 and put text at .3,.3
*/

HandleToonMsg(m)
UINT *m;
{
    if(vcr.iexist==0)return 0;
    return IsDialogMessage(vcr.w,m);

}


new_vcr()
{
 clock_t tt;
 int i;
  if(vcr.iexist==1)return;
  ani_zero();
  tt=clock();
  i=(10+(((int)tt%10)))%10;
  if(i>=0&&i<10)
     strcpy(vcr.title,toons[i]);
     else
     strcpy(vcr.title,"Wanna be a member");
 create_vcr();
}

create_vcr()
 {
     vcr.w=CreateDialog(hInst,"ANIMATEDIALOG",NULL,AnimateDialogFunc);
     vcr.iexist=1;
 }    

render_frame()
{
    double y[MAXODE];
 double t;
 int i,row;
 float **ss;
       
 ss=my_browser.data;
 row=vcr.pos;
 t=(double)ss[0][row];
 for(i=0;i<NODE;i++)
   y[i]=(double)ss[i+1][row];
 set_fix_rhs(t,y,NODE);


 /* now draw the stuff  */

 render_ani();
 vcr.pos=vcr.pos+vcr.inc;

   
 }   




ani_zero()
{
  vcr.iexist=0;
  vcr.ok=0;
  vcr.inc=1;
  vcr.pos=0;
  n_anicom=0;
  vcr.running=0;
  ani_speed=50;
  aniflag=TRANSIENT;
  strcpy(vcr.file,"foo.ani");
}


get_ani_file()
{
 int err;
 char bob[256];
 opensave(0,hInst,vcr.file,"Load animation file");
 if(strlen(vcr.file)==0)
 {
     err_msg("No file");
     return;
 }
  err=ani_new_file(vcr.file);
  if(err>=0){
    vcr.ok=1; /* loaded and compiled */
    sprintf(bob,"Loaded %d lines successfully!",n_anicom);
    err_msg(bob);
}
}

ani_new_file(filename)
     char *filename;
{
  FILE *fp;
  char bob[100];
  fp=fopen(filename,"r");
  if(fp==NULL){
    err_msg("Couldn't open ani-file");
    return -1;
  }
  if(n_anicom>0)
    free_ani();
  if(load_ani_file(fp)==0){
    sprintf(bob,"Bad ani-file at line %d",ani_line);
    err_msg(bob);
    return -1;
  }
  return 0;
}
  


load_ani_file(fp)
FILE *fp;
{
  char old[300],new[300],big[300];
  int notdone=1,jj1,jj2,jj;
  int done,ans;
  ani_line=1;
  while(notdone){
    read_ani_line(fp,old);
    search_array(old,new,&jj1,&jj2);
    for(jj=jj1;jj<=jj2;jj++){
      subsk(new,big,jj);
      /* strupr(big); */
/*      printf(" %s \n",big); */
      ans=parse_ani_string(big);
    }

    if(ans==0||feof(fp))break;
    if(ans<0){ /* error occurred !! */
      printf(" error at line %d\n",ani_line);
      free_ani();
      return 0;
    }
    ani_line++;

      
  }
 return 1;
}


parse_ani_string(s)
     char *s;
{
 char x1[300],x2[300],x3[300],x4[300],col[300],thick[300];
 char *ptr,*nxt;
 char *command;
 int type=-1;
 int ok=1;
 x1[0]=0;
 x2[0]=0;
 x3[0]=0;
 x4[0]=0;
 col[0]=0;
 thick[0]=0;
 ptr=s;
 type=COMMENT;
 command=get_first(ptr,"; ");
 strupr(command);
 if(msc("LI",command))
   type=LINE;
 if(msc("RL",command))
   type=RLINE;
 if(msc("RE",command))
   type=ARECT;
 if(msc("FR",command))
   type=FRECT;
 if(msc("EL",command))
   type=ELLIP;
 if(msc("FE",command))
   type=FELLIP;
 if(msc("CI",command))
   type=CIRC;
 if(msc("FC",command))
   type=FCIRC;
 if(msc("VT",command))
   type=VTEXT;
 if(msc("TE",command))
   type=ATEXT;
 if(msc("SE",command))
   type=SETTEXT;
 if(msc("TR",command))
   type=TRANSIENT;
 if(msc("PE",command))
   type=PERMANENT;
 if(msc("DI",command))
   type=DIMENSION;
 if(msc("EN",command))
   type=END;
 if(msc("SP",command))
   type=SPEED;
 switch(type){
 case LINE:
 case ARECT:
 case ELLIP:
 case FELLIP:
 case FRECT:
   nxt=get_next(";");
   if(nxt==NULL)return -1;
  strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x3,nxt);
   nxt=get_next(";\n");
  if(nxt==NULL)return -1;
   strcpy(x4,nxt);
   nxt=get_next(";\n");
   if((nxt==NULL)||strlen(nxt)==0)break;
   strcpy(col,nxt);
   nxt=get_next("\n");
   if((nxt==NULL)||strlen(nxt)==0)break;
   strcpy(thick,nxt);
   break;   
 case RLINE:
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";\n");
  if((nxt==NULL)||strlen(nxt)==0)break;
   strcpy(col,nxt);
   nxt=get_next("\n");
  if((nxt==NULL)||strlen(nxt)==0)break;
   strcpy(thick,nxt);
   break;  
 case CIRC:
 case FCIRC:
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x3,nxt);
   nxt=get_next(";\n");
   if((nxt==NULL)||strlen(nxt)==0)break;
   strcpy(col,nxt);
   break;
 case SETTEXT:
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(col,nxt);
   break;
 case ATEXT:
    nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x4,nxt);
   break;
 case VTEXT:
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x4,nxt);
   nxt=get_next(";\n");
   if(nxt==NULL)return -1;
   strcpy(x3,nxt);
   break;
 case SPEED:
   nxt=get_next(" \n");
   if(nxt==NULL)return -1;
   ani_speed=atoi(nxt);
   if(ani_speed<0)ani_speed=0;
   if(ani_speed>1000)ani_speed=1000;
   return 1;
 case DIMENSION:
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x1,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x2,nxt);
   nxt=get_next(";");
  if(nxt==NULL)return -1;
   strcpy(x3,nxt);
   nxt=get_next(";\n");
  if(nxt==NULL)return -1;
   strcpy(x4,nxt);
   break;
 
 }
 
 if(type==END)return 0;
 if(type==TRANSIENT){
   aniflag=TRANSIENT;
   return 1;
 }
 if(type==COMMENT)
   return 1;
 if(type==PERMANENT){
   aniflag=PERMANENT;
   return 1;
 }

 if(type==DIMENSION){
   set_ani_dimension(x1,x2,x3,x4);
   return 1;
 }
   /* lprintf(" %d %s %s %s %s %s %s\n",
        type,x1,x2,x3,x4,col,thick); */
 return(add_ani_com(type,x1,x2,x3,x4,col,thick));

     
}

set_ani_dimension(x1,y1,x2,y2)
     char *x1,*y1,*x2,*y2;
{
  double xx1,yy1,xx2,yy2;
  xx1=atof(x1);
  xx2=atof(x2);
  yy1=atof(y1);
  yy2=atof(y2);
  
  if((xx1<xx2)&&(yy1<yy2)){
    ani_xlo=xx1;
    ani_xhi=xx2;
    ani_ylo=yy1;
    ani_yhi=yy2;
  }

}
    
add_ani_com(type,x1,y1,x2,y2,col,thick)
     int type;
     char *x1,*x2,*y1,*y2,*col,*thick;
{
  int err;
  if(type==COMMENT||type==DIMENSION||type==PERMANENT||
     type==TRANSIENT||type==END||type==SPEED)
    return 1;
  my_ani[n_anicom].type=type;
  my_ani[n_anicom].flag=aniflag;
  my_ani[n_anicom].x1=(int *)malloc(256*sizeof(int));
  my_ani[n_anicom].y1=(int *)malloc(256*sizeof(int));
  my_ani[n_anicom].x2=(int *)malloc(256*sizeof(int));
  my_ani[n_anicom].y2=(int *)malloc(256*sizeof(int));
  my_ani[n_anicom].col=(int *)malloc(256*sizeof(int));
  switch(type){
  case LINE:
    err=add_ani_line(&my_ani[n_anicom],x1,y1,x2,y2,col,thick);
    break;
  case RLINE:
    err=add_ani_rline(&my_ani[n_anicom],x1,y1,col,thick);
    break;
  case ARECT:
    err=add_ani_rect(&my_ani[n_anicom],x1,y1,x2,y2,col,thick);
    break;
  case FRECT:
    err=add_ani_frect(&my_ani[n_anicom],x1,y1,x2,y2,col,thick);
    break;
  case ELLIP:
    err=add_ani_ellip(&my_ani[n_anicom],x1,y1,x2,y2,col,thick);
    break;
  case FELLIP:
    err=add_ani_fellip(&my_ani[n_anicom],x1,y1,x2,y2,col,thick);
    break;  
  case CIRC:
    err=add_ani_circle(&my_ani[n_anicom],x1,y1,x2,col,thick);
    break;
  case FCIRC:
    err=add_ani_circle(&my_ani[n_anicom],x1,y1,x2,col,thick);
    break;
  case ATEXT:
    err=add_ani_text(&my_ani[n_anicom],x1,y1,y2);
    break;
  case VTEXT:
    err=add_ani_vtext(&my_ani[n_anicom],x1,y1,x2,y2);
    break;
  case SETTEXT:
    err=add_ani_settext(&my_ani[n_anicom],x1,y1,col);
    break;
  }
  if(err<0){
    free_ani();
    return -1;
  }
  n_anicom++;
  return 1;
}

init_ani_stuff()
{
  
  ani_text_size=1;
  ani_text_font=0;
  ani_text_color=0;
  ani_xlo=0.0;
  ani_ylo=0.0;
  ani_xhi=1.0;
  ani_yhi=1.0;
  aniflag=TRANSIENT;
  n_anicom=0;
  ani_lastx=0.0;
  ani_lasty=0.0;
  vcr.pos=0;
  vcr.running=0;
}

free_ani()
{
  int i;
  for(i=0;i<n_anicom;i++){
    free(my_ani[i].x1);
    free(my_ani[i].y1);
    free(my_ani[i].x2);
    free(my_ani[i].y2);
    free(my_ani[i].col);
  }
  n_anicom=0;
  init_ani_stuff();
}

chk_ani_color(s,index)
     char *s;
     int *index;
{
  int j;
  char *s2;

  *index=-1;
  de_space(s);
  strupr(s);
  
  if(strlen(s)==0){
    *index=0;

    return 1;
  }
  if(s[0]=='$'){

    s2=&s[1];

    for(j=0;j<12;j++){
      if(stricmp(s2,color_list[j])==0){
        *index=j;

        return 1;
      }
    }
  }
    return 0;
}

add_ani_expr(x,c)
     char *x;
     int *c;
{
  int i,n;
  int com[300];
  int err;
  double z;
  /* printf(" n_ani=%d exp=%s \n",n_anicom,x); */
  err=add_expr(x,com,&n);
  if(err==1)return 1;
  for(i=0;i<n;i++){
    c[i]=com[i];
    /* printf(" %d %d \n",i,c[i]); */
  }
 /*  z=evaluate(c);
 printf(" evaluated to %g \n",z); */
  return 0;
}
  
/*  the commands  */   
    
add_ani_rline(a,x1,y1,col,thick)
     char *x1,*y1,*col,*thick;
     ANI_COM *a;
{

 int com[300];
 double z;
 int err,n,index;
 err=chk_ani_color(col,&index);
 if(err==1)
   {
     a->col[0]=-index;
   }
 else
   {
     err=add_ani_expr(col,a->col);
     if(err==1)return -1;
   }
 a->zthick=atoi(thick);
 if(a->zthick <=0)
   a->zthick=1;

 err=add_ani_expr(x1,a->x1);
 if(err)return -1;
 err=add_ani_expr(y1,a->y1);
 if(err)return -1;
 return 0;
  
}

add_ani_line(a,x1,y1,x2,y2,col,thick)
     char *x1,*x2,*y1,*y2,*col,*thick;
     ANI_COM *a;
{

 int com[300];
 double z;
 int err,n,index;
 err=chk_ani_color(col,&index);
 if(err==1)
   {
     a->col[0]=-index;
   }
 else
   {
     err=add_ani_expr(col,a->col);
     if(err==1)return -1;
   }
 a->zthick=atoi(thick);
 if(a->zthick <=0)
   a->zthick=1;

 err=add_ani_expr(x1,a->x1);
 if(err)return -1;
 err=add_ani_expr(y1,a->y1);
 if(err)return -1;
 err=add_ani_expr(x2,a->x2);
 if(err)return -1;
 err=add_ani_expr(y2,a->y2);
 if(err)return -1;
/*  printf(" added line %s %s %s %s \n",
        x1,y1,x2,y2); */
 
 return 0;
 
  
}


add_ani_rect(a,x1,y1,x2,y2,col,thick)
     char *x1,*x2,*y1,*y2,*col,*thick;
     ANI_COM *a;
{
return(add_ani_line(a,x1,y1,x2,y2,col,thick));
}

add_ani_frect(a,x1,y1,x2,y2,col,thick)
     char *x1,*x2,*y1,*y2,*col,*thick;
     ANI_COM *a;
{
return(add_ani_line(a,x1,y1,x2,y2,col,thick));
}

add_ani_ellip(a,x1,y1,x2,y2,col,thick)
     char *x1,*x2,*y1,*y2,*col,*thick;
     ANI_COM *a;
{
return(add_ani_line(a,x1,y1,x2,y2,col,thick));
}

add_ani_fellip(a,x1,y1,x2,y2,col,thick)
     char *x1,*x2,*y1,*y2,*col,*thick;
     ANI_COM *a;
{
return(add_ani_line(a,x1,y1,x2,y2,col,thick));
}



add_ani_circle(a,x1,y1,x2,col,thick)
     char *x1,*y1, *x2,*col,*thick;
     ANI_COM *a;
{

 int com[300];
 double z;
 int err,n,index;
 err=chk_ani_color(col,&index);
 if(err==1)
   {
     a->col[0]=-index;
   }
 else
   {
     err=add_ani_expr(col,a->col);
     if(err==1)return -1;
   }
 a->zthick=atoi(thick);
 if(a->zthick <=0)
   a->zthick=1;

 err=add_ani_expr(x1,a->x1);
 if(err)return -1;
 err=add_ani_expr(y1,a->y1);
 if(err)return -1;
 err=add_ani_expr(x2,a->x2);
 if(err)return -1;

 return 0;
  
}

add_ani_fcircle(a,x1,y1,x2,col,thick)
     char *x1,*y1, *x2,*col,*thick;
     ANI_COM *a;
{
 return(add_ani_circle(a,x1,y1,x2,col,thick));
}
   
add_ani_text(a,x1,y1,y2)
     char *x1,*y1,*y2;
     ANI_COM *a;
{
  int err;
  char *s;
  err=add_ani_expr(x1,a->x1);
  if(err)return -1;
  err=add_ani_expr(y1,a->y1);
  if(err)return -1;
  s=(char *)(a->y2);
  strcpy(s,y2);
  return 0;
}

add_ani_vtext(a,x1,y1,x2,y2)
     char *x1,*x2,*y1,*y2;
     ANI_COM *a;
{
  int err;
  char *s;
  err=add_ani_expr(x1,a->x1);
  if(err)return -1;
  err=add_ani_expr(y1,a->y1);
  if(err)return -1;
  err=add_ani_expr(x2,a->x2);
  /* printf(" txt=%s com1=%d \n",x2,a->x2[0]); */
  if(err)return -1;
  s=(char *)(a->y2);
  strcpy(s,y2);
  return 0;
}

add_ani_settext(a,x1,y1,col)
     char *x1,*y1,*col;
     ANI_COM *a;
{
  int size=atoi(x1);
  int font=0;
  int index=0,err;
  de_space(y1);
  if(y1[0]=='s'||y1[0]=='S')
    font=1;
  err=chk_ani_color(col,&index);
  if(err!=1)index=0;
  if(size<0)size=0;
  if(size>4)size=4;
  a->tsize=size;
  a->tfont=font;
  a->tcolor=index;
  return 0;
}

render_ani()
{
  int i;
  int type,flag;
  ClearAniBits(vcr.wid,vcr.hgt);
  for(i=0;i<n_anicom;i++){
    type=my_ani[i].type;
    flag=my_ani[i].flag;
   /* printf("type=%d flag=%d i=%d \n",
          type,flag,i); */
    if(type==LINE||type==RLINE||type==ARECT||type==FRECT||type==CIRC||
       type==FCIRC||type==ELLIP||type==FELLIP)
      eval_ani_color(i);
    switch(type){
    case SETTEXT:
     set_ani_font_stuff(my_ani[i].tsize,my_ani[i].tfont,my_ani[i].tcolor); 
     break;
    case ATEXT:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_text(i);
      break;
    case VTEXT:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_vtext(i);
      break;
    case LINE:
      
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_line(i);
      break;
    case RLINE:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_rline(i);
      break;
    case ARECT:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_rect(i);
      break;
    case FRECT:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_frect(i);
      break;
     case ELLIP:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_ellip(i);
      break;
    case FELLIP:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_fellip(i);
      break;
    case CIRC:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_circ(i);
      break;
    case FCIRC:
      if(flag==TRANSIENT)
        eval_ani_com(i);
      draw_ani_fcirc(i);
      break;
    }
  }
}   
     
      
set_ani_perm()
{
  double t;
  double y[MAXODE];
  float **ss;
  int i,type;
  ss=my_browser.data;
   t=(double)ss[0][0];
 for(i=0;i<NODE;i++)
   y[i]=(double)ss[i+1][0];
 set_fix_rhs(t,y,NODE);
 for(i=0;i<n_anicom;i++){
   type=my_ani[i].type;
   if(my_ani[i].flag==PERMANENT){
     if(my_ani[i].type!=SETTEXT)
       eval_ani_com(i);
     if(type==LINE||type==RLINE||type==ARECT||type==FRECT||type==CIRC||
        type==FCIRC||type==ELLIP||type==FELLIP)
       eval_ani_color(i);
   }
 }    
}

eval_ani_color(j)
     int j;
{
  double z;
        
    if(my_ani[j].col[0]>0){
      z=evaluate(my_ani[j].col);
      if(z>1)z=1.0;
      if(z<0)z=0.0;
      my_ani[j].zcol=z;
    }
}
eval_ani_com(j)
     int j;
{
    int i;
    double z;
        
     my_ani[j].zx1=evaluate(my_ani[j].x1);
    /* printf(" %d %g \n",my_ani[j].x1[0],my_ani[j].zx1); */
        
    my_ani[j].zy1=evaluate(my_ani[j].y1);
    switch(my_ani[j].type)
      {
      case LINE:
      case ARECT:
      case FRECT:
      case ELLIP:
      case FELLIP:
        my_ani[j].zx2=evaluate(my_ani[j].x2);
        my_ani[j].zy2=evaluate(my_ani[j].y2);
        break;
      case CIRC:
      case FCIRC:
        my_ani[j].zrad=evaluate(my_ani[j].x2);
        break;
      case VTEXT:
        my_ani[j].zval=evaluate(my_ani[j].x2);
        break;
      }
  
  }


set_ani_thick(t)
     int t;
{
  if(t<0)t=0;
  AniLineWidth=t;
}

set_ani_font_stuff(size,font,color)
     int size,font,color;
{
 AniTextColor=color;

 AniTextSize=size;
 AniTextFont=font;
}


set_ani_col(j)
     int j;
{
  int c=my_ani[j].col[0];
  int icol;
 
  if(c<=0)
    icol=-c;
  else
    icol=(int)(color_total*my_ani[j].zcol)+FIRSTCOLOR;
  /* printf(" t=%d j=%d col=%d \n",vcr.pos,j,icol); */
  AniLineColor=icol;
}







ani_rad2scale(rx,ry,ix,iy)
     double rx,ry;
     int *ix,*iy;
{
  double dx=(double)vcr.wid/(ani_xhi-ani_xlo),
  dy=(double)vcr.hgt/(ani_yhi-ani_ylo);
  double r1=rx*dx,r2=ry*dy;
  *ix=(int)r1;
  *iy=(int)r2;
}


ani_radscale(rad,ix,iy)
     double rad;
     int *ix,*iy;
{
  double dx=(double)vcr.wid/(ani_xhi-ani_xlo),
  dy=(double)vcr.hgt/(ani_yhi-ani_ylo);
  double r1=rad*dx,r2=rad*dy;
  *ix=(int)r1;
  *iy=(int)r2;
}
ani_xyscale(x,y,ix,iy)
     double x,y;
     int *ix,*iy;
{
  double dx=(double)vcr.wid/(ani_xhi-ani_xlo),
         dy=(double)vcr.hgt/(ani_yhi-ani_ylo);
  double xx=(x-ani_xlo)*dx;
  double yy=vcr.hgt-dy*(y-ani_ylo);
  *ix=(int)xx;
  *iy=(int)yy;
  if(*ix<0)*ix=0;
  if(*ix>=vcr.wid)*ix=vcr.wid-1;
  if(*iy<0)*iy=0;
  if(*iy>=vcr.hgt)*iy=vcr.hgt-1;
}
  
read_ani_line(fp,s)
     char *s;
     FILE *fp;
{
  char temp[256];
  int i,n,nn,ok,ihat;
  s[0]=0;
  ok=1;
  while(ok){
    ok=0;
    fgets(temp,256,fp);
     nn=strlen(temp)+1;
    n=strlen(temp);
    for(i=n-1;i>=0;i--){
      if(temp[i]=='\\'){
        ok=1;
        ihat=i;
      }
    }
    if(ok==1)
      temp[ihat]=0;
    strcat(s,temp);
  }
  n=strlen(s);
  if(s[n-1]=='\n')s[n-1]=' ';
  s[n]=' ';
  s[n+1]=0;
}
  


de_space(s)
     char *s;
{
  int n=strlen(s);
  int i,j=0;
  char ch;
  for(i=0;i<n;i++){
    ch=s[i];
    if(!isspace(ch)){
      s[j]=ch;
      j++;
    }
  }
  s[j]=0;
}


set_penbrush(color,fill)
int color,fill;
{
    a_pen=CreatePen(0,AniLineWidth,PALETTEINDEX(color));
 a_oldpen=SelectObject(ani_gc,a_pen);
  if(fill>0){
    a_brush=CreateSolidBrush(PALETTEINDEX(color));
    a_oldbrush=SelectObject(ani_gc,a_brush);
  }
  else
     a_oldbrush=SelectObject(ani_gc,(HBRUSH) GetStockObject(WHITE_BRUSH));
}

unset_penbrush(int fill)
{
     SelectObject(ani_gc,a_oldpen);
     DeleteObject(a_pen);
     SelectObject(ani_gc,a_oldbrush);
     if(fill)DeleteObject(a_brush);
}
 

/**************   DRAWING ROUTINES   *******************/

draw_ani_line(j)
     int j;
{
 
  double x1=my_ani[j].zx1,x2=my_ani[j].zx2,y1=my_ani[j].zy1,y2=my_ani[j].zy2;
  int i1,j1,i2,j2;

  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_xyscale(x2,y2,&i2,&j2);
 set_penbrush(AniLineColor,0);
 MoveToEx(ani_gc,i1,j1,NULL);
 LineTo(ani_gc,i2,j2);
 unset_penbrush(0);
  ani_lastx=x2;
  ani_lasty=y2;
 
}

draw_ani_rline(j)
     int j;
{
 
  double x1=ani_lastx+my_ani[j].zx1,y1=ani_lasty+my_ani[j].zy1;
  int i1,j1,i2,j2;
  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(ani_lastx,ani_lasty,&i1,&j1);
  ani_xyscale(x1,y1,&i2,&j2);
 set_penbrush(AniLineColor,0);
 MoveToEx(ani_gc,i1,j1,NULL);
 LineTo(ani_gc,i2,j2);
 unset_penbrush(0);
  ani_lastx=x1;
  ani_lasty=y1;
}


draw_ani_circ(j)
     int j;
{
 
   
  double x1=my_ani[j].zx1,y1=my_ani[j].zy1,rad=my_ani[j].zrad;
  int i1,j1,i2,j2,ir;
  int color;
  set_ani_col(j);
  set_ani_thick(my_ani[j].zthick);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_radscale(rad,&i2,&j2);
  set_penbrush(AniLineColor,0);
  Ellipse(ani_gc,i1-i2,j1-j2,i1+i2,j1+j2);
  unset_penbrush(0);
}

draw_ani_fcirc(j)
     int j;
{
  double x1=my_ani[j].zx1,y1=my_ani[j].zy1,rad=my_ani[j].zrad;
  int i1,j1,i2,j2,ir;
  int color;
  set_ani_col(j);
  set_ani_thick(my_ani[j].zthick);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_radscale(rad,&i2,&j2);
 set_penbrush(AniLineColor,1);
   Ellipse(ani_gc,i1-i2,j1-j2,i1+i2,j1+j2);
   unset_penbrush(1);
}


draw_ani_rect(j)
     int j;
{
  double x1=my_ani[j].zx1,x2=my_ani[j].zx2,y1=my_ani[j].zy1,y2=my_ani[j].zy2;
  int i1,j1,i2,j2;
  int h,w;
  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_xyscale(x2,y2,&i2,&j2);
  set_penbrush(AniLineColor,0);
  Rectangle(ani_gc,i1,j1,i2,j2);
  unset_penbrush(0);
  
}

draw_ani_frect(j)
     int j;
{
  double x1=my_ani[j].zx1,x2=my_ani[j].zx2,y1=my_ani[j].zy1,y2=my_ani[j].zy2;
  int i1,j1,i2,j2;
  int h,w;
  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_xyscale(x2,y2,&i2,&j2);
  set_penbrush(AniLineColor,1);
  Rectangle(ani_gc,i1,j1,i2,j2);
  unset_penbrush(1);
  
}



draw_ani_ellip(j)
     int j;
{
  double x1=my_ani[j].zx1,x2=my_ani[j].zx2,y1=my_ani[j].zy1,y2=my_ani[j].zy2;
  int i1,j1,i2,j2;
  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_rad2scale(x2,y2,&i2,&j2);
  set_penbrush(AniLineColor,0);
   Ellipse(ani_gc,i1-i2,j1-j2,i1+i2,j1+j2);
  unset_penbrush(0);  
}

draw_ani_fellip(j)
     int j;
{
  double x1=my_ani[j].zx1,x2=my_ani[j].zx2,y1=my_ani[j].zy1,y2=my_ani[j].zy2;
  int i1,j1,i2,j2;
  set_ani_thick(my_ani[j].zthick);
  set_ani_col(j);
  ani_xyscale(x1,y1,&i1,&j1);
  ani_rad2scale(x2,y2,&i2,&j2);
   set_penbrush(AniLineColor,1);
   Ellipse(ani_gc,i1-i2,j1-j2,i1+i2,j1+j2);
  unset_penbrush(1); 
}

set_anifont()
{
 int size=AniTextSize;
 SetTextColor(ani_gc,PALETTEINDEX(AniTextColor));
 if(AniTextFont==1) a_font=CreateFont(12+3*size,6+3*size/2,0,0,FW_NORMAL,0,0,0,
    SYMBOL_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,FIXED_PITCH,"Symbol");
 if(AniTextFont==0)a_font=CreateFont(12+3*size,6+3*size/2,0,0,FW_NORMAL,0,0,0,
    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,FIXED_PITCH,"Times New Roman");
 a_oldfont=SelectObject(ani_gc,a_font);   

}

unset_anifont()
{
  
  SelectObject(ani_gc,a_oldfont);
  DeleteObject(a_font);     

}        
draw_ani_text(j)
     int j;
{
  int n;
  char *s;
  double x1=my_ani[j].zx1,y1=my_ani[j].zy1;
  int i1,j1;
  ani_xyscale(x1,y1,&i1,&j1);
  s=(char *)my_ani[j].y2;
  n=strlen(s);
  set_anifont();
  TextOut(ani_gc,i1,j1,s,n);
  unset_anifont();
}

draw_ani_vtext(j)
     int j;
{
  char s2[256];
  int n;
  char *s;
  double x1=my_ani[j].zx1,y1=my_ani[j].zy1;
  int i1,j1;
  s=(char *)my_ani[j].y2;
 
  sprintf(s2,"%s%g",s,my_ani[j].zval);
  n=strlen(s2);
  ani_xyscale(x1,y1,&i1,&j1);
   set_anifont();

  TextOut(ani_gc,i1,j1,s2,n);
  unset_anifont();
}


 ani_to_clip(HWND pix)
{
    RECT rect;
    HDC memdc;
    HBITMAP hbm;
    int w,h;
    GetClientRect(pix,&rect);
    w=rect.right;
    h=rect.bottom;
    memdc=CreateCompatibleDC(ani_gc);
    hbm=CreateCompatibleBitmap(ani_gc,w,h);
    SelectObject(memdc,hbm);
    BitBlt(memdc,0,0,w,h,ani_gc,0,0,SRCCOPY);
    if(OpenClipboard(NULL)!=0){
         EmptyClipboard();
         SetClipboardData(CF_BITMAP,hbm);
         CloseClipboard(); }
    else {
        err_msg("Couldn't open clipboard!");
    }
    DeleteDC(memdc);
  
}     
         
 
 BOOL CALLBACK AnimateDialogFunc(HWND hwnd,UINT message,
                     WPARAM wparam,LPARAM lparam)
 {
     static HWND pix;
     static int speed;
     static int minwid,minhgt,p_left,p_top;
     int p_bord=8;
     int cx,cy;
     char bob[256];
     RECT r;
     HDC hdc;
     switch(message){
         case WM_INITDIALOG:
          pix=GetDlgItem(hwnd,IDPIX_AN);
          SetWindowText(hwnd,vcr.title);
          GetClientRect(pix,&r);
          p_left=10;
          p_top=80;
         minhgt=100;
         minwid=200;
          speed=10;
          GetWindowDimensions(pix,&cx,&cy);
          hdc=GetDC(pix);
          ani_gc=CreateCompatibleDC(hdc);
          set_palette(ani_gc);
          anibitmap=CreateCompatibleBitmap(hdc,cx,cy);
          ReleaseDC(pix,hdc);
          SelectObject(ani_gc,anibitmap);
          ClearAniBits(cx,cy);
          draw_test_pat(cx,cy);
          vcr.wid=cx;
          vcr.hgt=cy;
          vcr.iexist=1;
        
          return 1;
        case WM_SIZE:
            GetWindowDimensions(hwnd,&cx,&cy);
          if(anibitmap)DeleteObject(anibitmap);
          
           MoveWindow(pix,p_left,p_top,cx-20,cy-90,TRUE);
           GetWindowDimensions(pix,&cx,&cy);
           hdc=GetDC(pix);
           anibitmap=CreateCompatibleBitmap(hdc,cx,cy);
          ReleaseDC(pix,hdc);
          SelectObject(ani_gc,anibitmap);
           ClearAniBits(cx,cy);
          draw_test_pat(cx,cy);
            vcr.wid=cx;
          vcr.hgt=cy;
           return 1;
        case WM_PAINT:
         redraw_ani(pix);
          return 0;

        case WM_TIMER:
          if(vcr.running==0||vcr.iexist==0||vcr.ok==0)return 0;
          if(vcr.pos>=my_browser.maxrow){
              KillTimer(vcr.w,1);
              vcr.pos=0;
              return 1;
          }
            render_frame();
            redraw_ani(pix);
            sprintf(bob,"%d",vcr.pos);
            SetDlgItemText(hwnd,IDFRAME_AN,bob);
            return 1;
        case WM_COMMAND:
           switch(LOWORD(wparam)){
               case IDPLAY_AN:
               if(vcr.iexist==0||vcr.ok==0)return 1;
               if(n_anicom==0)return 1;
                if(my_browser.maxrow<2)return 1;
                
               if(vcr.running==1)KillTimer(vcr.w,1);
               vcr.running=0;
               if(!SetTimer(vcr.w,1,ani_speed,NULL)){
                   err_msg("Sorry - too many timers!");
                   return 1;
               }
               vcr.running=1;
               set_ani_perm();
               return 1;
               case IDFAST_AN:
                if(vcr.running==1)return 1;
                if(vcr.pos>=my_browser.maxrow)return 1;
                render_frame();
            redraw_ani(pix);
            sprintf(bob,"%d",vcr.pos);
            SetDlgItemText(hwnd,IDFRAME_AN,bob);
              return 1;
              case IDSLOW_AN:
                if(vcr.running==1)return 1;
                if(vcr.pos<=1)return 1;
                vcr.pos=vcr.pos-2;
                render_frame();
            redraw_ani(pix);
            sprintf(bob,"%d",vcr.pos);
            SetDlgItemText(hwnd,IDFRAME_AN,bob);
              return 1;
               case IDSTOP_AN:          
                if(vcr.running==0)return 1;
                KillTimer(vcr.w,1);
                vcr.running=0;
                return 1;
               case IDTOP_AN:
               if(vcr.running==1)return 1;
               vcr.pos=my_browser.row0;
               return 1;
               case IDREWIND_AN:
               if(vcr.running==1)return 1;
               vcr.pos=0;
               return 1;
               case IDNEW_AN:
                get_ani_file();
                return 1;
               case IDCOPY_AN:
                ani_to_clip(pix);
                return 1;
               case IDBYE_AN:
                if(vcr.running==1)return 1;
                vcr.iexist=0;
                free_ani();
                DeleteObject(anibitmap);
                DeleteDC(ani_gc);
                vcr.ok=0;
                DestroyWindow(vcr.w);
                return 1;
           }
     }   
      return 0;
 }     

    redraw_ani(HWND wn)
    {
        int h,w;
        HDC dc;

        if(anibitmap){
                InvalidateRect(wn,NULL,TRUE);
                UpdateWindow(wn);
                GetWindowDimensions(wn,&w,&h);
                dc=GetDC(wn);
                BitBlt(dc,0,0,w,h,ani_gc,0,0,SRCCOPY);
     
                ReleaseDC(wn,dc);
        }
    }

   ClearAniBits(int w,int h)
   {
        HBRUSH hb;
        hb= SelectObject(ani_gc,(HBRUSH)GetStockObject(WHITE_BRUSH));
        Rectangle(ani_gc,-1,-1,w+1,h+1);
        SelectObject(ani_gc,hb);
   }     
        
        
    draw_test_pat(int w,int h)
    {
        HBRUSH hb;
        int x1=0,y1=0,x2=w/8,y2=h/8,x3=w/4,y3=h/4;
        
        hb=SelectObject(ani_gc,(HBRUSH)GetStockObject(DKGRAY_BRUSH));
        Ellipse(ani_gc,0,0,w,h);
        SelectObject(ani_gc,(HBRUSH)GetStockObject(GRAY_BRUSH));
        Ellipse(ani_gc,w/8,h/8,7*w/8,7*h/8);
         SelectObject(ani_gc,(HBRUSH)GetStockObject(LTGRAY_BRUSH));
        Ellipse(ani_gc,w/4,h/4,6*w/8,6*h/8);
         SelectObject(ani_gc,(HBRUSH)GetStockObject(BLACK_BRUSH));
        Ellipse(ani_gc,3*w/8,3*h/8,5*w/8,5*h/8);
        SelectObject(ani_gc,hb);
    }
