#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "structs.h"

#define MAXUFUN 50

#define IDRESET_RHS 106
#define IDCANCEL_RHS 101
#define IDOK_RHS 100
#define IDVAR_RHS 102
#define IDRHS_RHS 105

char *get_next(),*get_first();


extern char uvar_names[MAXODE][12];
extern char *ode_names[MAXODE];
extern int METHOD,NEQ,NODE,NMarkov,FIX_VAR,NKernel;


extern int *my_ode[];
extern int NUPAR;
extern double last_ic[MAXODE];

extern char upar_names[200][11],this_file[100];
extern int EqType[MAXODE];

extern char *ufun_def[MAXUFUN];
extern char ufun_names[MAXUFUN][12];
extern int narg_fun[MAXUFUN], *ufun[MAXUFUN];

typedef struct {
  int narg;
  char args[10][11];
} UFUN_ARG;

extern HINSTANCE hInst;
extern UFUN_ARG ufun_arg[MAXUFUN];
extern BC_STRUCT my_bc[MAXODE];

char **ed_names,**ed_values;
/* int **ed_command; */
BOOL CALLBACK RHSDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );

int RHSChanged=0;
BOOL CALLBACK RHSDialogFunc(HWND hdwnd,UINT message,
        WPARAM wparam,LPARAM lparam)
{
int i;
static int iold;

switch(message){
         case WM_INITDIALOG:
             iold=0;
             for(i=0;i<NEQ;i++)
              SendDlgItemMessage(hdwnd,IDVAR_RHS,LB_ADDSTRING,0,
              (LPARAM)ed_names[i]);
             SendDlgItemMessage(hdwnd,IDVAR_RHS,LB_SETCURSEL,0,0L);
             fill_new_rhs(hdwnd,iold);
             return 1;
                case WM_COMMAND:
                       switch(LOWORD(wparam)){
                  
                    case IDVAR_RHS:
                   
                       switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                          save_new_rhs(hdwnd,iold);
                          iold=SendDlgItemMessage(hdwnd,IDVAR_RHS,LB_GETCURSEL,0,0L);
                          fill_new_rhs(hdwnd,iold);  
                        
                              return 1;
                       }
                       return 1;
                    case IDRESET_RHS:
                        rhs_reset(hdwnd,iold);
                        return 1;
                    case IDCANCEL_RHS:
                        cleanup_rhs();
                        EndDialog(hdwnd,0);
                        return 1;
                    case IDOK_RHS:
                       save_new_rhs(hdwnd,iold);
                       EndDialog(hdwnd,0);
                       save_all_rhs();
                       return 1;
                       }
}            
return 0;
}

save_new_rhs(HWND w,int i)
{
    GetDlgItemText(w,IDRHS_RHS,ed_values[i],250);
}
rhs_reset(HWND w,int i)
{
    SetDlgItemText(w,IDRHS_RHS,ode_names[i]);
}    
fill_new_rhs(HWND w,int i)
{
    SetDlgItemText(w,IDRHS_RHS,ed_values[i]);
}       
edit_rhs(HWND w)
{
    
 int i;
 int n=NEQ;
 char fstr[20],msg[200];
 if(NMarkov>0||NKernel>0){
     err_msg("Sorry, can't edit Markov or Volterra!");
     return;
 }   
     
 ed_names=(char **)malloc(n*sizeof(char*));
 /* ed_command=(int **)malloc(n*sizeof(int*)); */
 ed_values=(char **)malloc(n*sizeof(char*));
 for(i=0;i<n;i++){
   ed_names[i]=(char *)malloc(20*sizeof(char));
  /*  ed_command[i]=(int *)malloc(256*sizeof(int)); */
   ed_values[i]=(char *)malloc(256*sizeof(char));
   if(i<NODE &&METHOD>0)strcpy(fstr,"d%s/dT");
   if(i<NODE &&METHOD==0)strcpy(fstr,"%s(n+1)");
   if(i<NODE &&EqType[i]==1)strcpy(fstr,"%s(T)");
   if(i>=NODE)strcpy(fstr,"%s");
   sprintf(ed_names[i],fstr,uvar_names[i]);
   strcpy(ed_values[i],ode_names[i]);
 }
 DialogBox(hInst,"RHSDIALOG",w,RHSDialogFunc);
}

save_one_rhs(int i,char *sn,char *s)
{
   int com[256];
   int err,len,i0,j;
   char msg[256];
   err=add_expr(s,com,&len);
     if(err==1){
       sprintf(msg,"Bad rhs->%s : %s",sn,s);
       err_msg(msg);
     }
     else {
       RHSChanged=1;
       strcpy(ode_names[i],s);
       i0=i;
       if(i>=NODE)i0+=FIX_VAR;
       for(j=0;j<len;j++)
         my_ode[i0][j]=com[j];
     }
}
save_all_rhs()
{
  
  int n=NEQ,i;
  
  for(i=0;i<n;i++){
     save_one_rhs(i,ed_names[i],ed_values[i]);
     
   }
 cleanup_rhs();
}
     

cleanup_rhs()
{
    int i,n=NEQ;
   for(i=0;i<n;i++){
    free(ed_values[i]);
    free(ed_names[i]);
    /* free(ed_command[i]); */
   }
 free(ed_values);
 free(ed_names);
/* free(ed_command); */
}
  
