#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "structs.h"
#include "grafpar.h"
#include "globals.h"
#include "mousey.h"
#define mmax(a,b) ((a>b) ? a : b)
#define REAL_SMALL 1.e-6

double atof();
#define IDMAX_COL 1310
#define IDMIN_COL 1311
#define IDUSER_COL 1312
#define IDVEL_COL 1313
#define IDOFF_COL 1314
#define IDUSE_COL 1315
#define IDSCALE_COL 1316
#define IDOK_COL 1317

extern CURVE frz[MAXFRZ];
extern int LookingForMouse;
int AutoFreezeFlag=0;
extern HWND mainwnd,draw_win;
extern char uvar_names[MAXODE][12];
extern int NEQ,NODE;
extern GRAPH *MyGraph;
extern int storind;
extern BROWSER my_browser;

extern int NJMP;
extern double DELTA_T;

extern char color_list[12][20];

#define MB(a) MessageBox(mainwnd,a,"",MB_OK)


BOOL CALLBACK XvstDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
int i,ok;
char temp[256];
switch(message){
         case WM_INITDIALOG:
        
          for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp); 
            SendDlgItemMessage(hdwnd,IDPLOT_XVST,LB_ADDSTRING,0,
             (LPARAM)temp);
          }
            i=MyGraph->yv[0];
            if(i>0)i=i-1;
            else i=0;
            SendDlgItemMessage(hdwnd,IDPLOT_XVST,LB_SETCURSEL,i,0L);
            return 1;
         case WM_COMMAND:
                switch(LOWORD(wparam)){
                  
                    case IDPLOT_XVST:
                   
                       switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                           i=SendDlgItemMessage(hdwnd,IDPLOT_XVST,LB_GETCURSEL,0,0L);
                           EndDialog(hdwnd,0);
                           if(i>=0&&i<NEQ){
                               MyGraph->yv[0]=i+1;
                               MyGraph->xv[0]=0;
                               MyGraph->grtype=0;
                               check_flags();
                                fit_window();
                                redraw_the_graph();
                           }
                          return 1;
                       }
                }
}
return 0;
}                
BOOL CALLBACK NewGraphDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
int i;
static int iold,inew;
char temp[50];
switch(message){
         case WM_INITDIALOG:
         iold=0;
          for(i=0;i<12;i++)
    SendDlgItemMessage(hdwnd,IDCOLOR_NG,LB_ADDSTRING,0,
             (LPARAM)color_list[i]);
    for(i=0;i<MyGraph->nvars;i++){
       sprintf(temp,"Curve %d",i+1);
       SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_ADDSTRING,0,
              (LPARAM)temp); }
              
              
    SendDlgItemMessage(hdwnd,IDXAX_NG,CB_ADDSTRING,0,
             (LPARAM)"t");          
         SendDlgItemMessage(hdwnd,IDYAX_NG,CB_ADDSTRING,0,
             (LPARAM)"t");
         SendDlgItemMessage(hdwnd,IDZAX_NG,CB_ADDSTRING,0,
             (LPARAM)"t");    
         for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp);
            SendDlgItemMessage(hdwnd,IDXAX_NG,CB_ADDSTRING,0,
             (LPARAM)temp);
             SendDlgItemMessage(hdwnd,IDYAX_NG,CB_ADDSTRING,0,
             (LPARAM)temp);
              SendDlgItemMessage(hdwnd,IDZAX_NG,CB_ADDSTRING,0,
             (LPARAM)temp);
             } 
         fill_new_curve(hdwnd,0);  
         return 1;
         break;
          case WM_COMMAND:
                switch(LOWORD(wparam)){
                  
                    case IDGRAPH_NG:
                   
                       switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                          save_new_curve(hdwnd,iold);
                          iold=SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_GETCURSEL,0,0L);
                          fill_new_curve(hdwnd,iold);  
                        
                              return 1;
                       }
                      return 1;
                    case IDOK_NG:
                     i=SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_GETCURSEL,0,0L);
                     save_new_curve(hdwnd,i);
                     check_flags();
                        EndDialog(hdwnd,0);
                        return 1;
                    case IDDEL_NG:
                        if(MyGraph->nvars<2)
                        return 1;
                        MyGraph->nvars=(MyGraph->nvars)-1;
                        SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_DELETESTRING,
                        (WPARAM)MyGraph->nvars,0L);
                        iold=0;
                        fill_new_curve(hdwnd,iold);
                        return 1;
                    case IDALL_NG:
                         if(MyGraph->nvars<2)
                        return 1;
                        i=1;
                        while(i){
                            MyGraph->nvars=(MyGraph->nvars)-1;
                        SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_DELETESTRING,
                        (WPARAM)MyGraph->nvars,0L);
                        if(MyGraph->nvars<2)i=0;
                        }
                        iold=0;
                        fill_new_curve(hdwnd,iold);
                        return 1;
                    case IDNEW_NG:
                       if(MyGraph->nvars>=MAXPERPLOT){
                           MB("Can't add any more!");
                           return 1;
                           
                       }
                       MyGraph->nvars++;
                       sprintf(temp,"Curve %d",MyGraph->nvars);
                       SendDlgItemMessage(hdwnd,IDGRAPH_NG,LB_ADDSTRING,
                       0,(LPARAM)temp);
                       
                       save_new_curve(hdwnd,iold);
                       
                       iold=(MyGraph->nvars)-1;
                       fill_new_curve(hdwnd,iold);
                      
                      return 1;
                           
                }
                
}
return 0;

}

save_new_curve(HWND w,int j)
{
     int i;
     int ix,iy,iz,ic;
     char tst[200];
    if(j<0||j>=MAXPERPLOT) return 0;
    i=SendDlgItemMessage(w,
                    IDXAX_NG,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->xv[j]=i;
                    ix=i;
                   i=SendDlgItemMessage(w,
                    IDYAX_NG,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->yv[j]=i;
                    iy=i;
                    i=SendDlgItemMessage(w,
                    IDZAX_NG,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->zv[j]=i;
                    iz=i;
  i=SendDlgItemMessage(w,IDCOLOR_NG,LB_GETCURSEL,0,0L);
  if(i>=0)MyGraph->color[j]=i;
  ic=i;
  if(SendDlgItemMessage(w,IDLINE_NG,BM_GETCHECK,0,0L))
  MyGraph->line[j]=1;
  else
  MyGraph->line[j]=0;
 
 /* sprintf(tst,"%d: %d %d %d %d",j,ix,iy,iz,ic);
   MB(tst); */
  return 1;
                    
}
    
fill_new_curve(HWND w,int i)
{
   char tst[200];
   /* sprintf(tst,"Color=%d\n",MyGraph->color[i]);
   MB(tst); */
   SendDlgItemMessage(w,IDGRAPH_NG,LB_SETCURSEL,i,0L);
   SendDlgItemMessage(w,IDXAX_NG,CB_SETCURSEL,MyGraph->xv[i],0L);
   SendDlgItemMessage(w,IDYAX_NG,CB_SETCURSEL,MyGraph->yv[i],0L);
   SendDlgItemMessage(w,IDZAX_NG,CB_SETCURSEL,MyGraph->zv[i],0L);
   SendDlgItemMessage(w,IDCOLOR_NG,LB_SETCURSEL,MyGraph->color[i],0L);
   if(MyGraph->line[i]==1){
     SendDlgItemMessage(w,IDLINE_NG,BM_SETCHECK,1,0L);
     SendDlgItemMessage(w,IDPOINT_NG,BM_SETCHECK,0,0L);
     }
     else {
     SendDlgItemMessage(w,IDLINE_NG,BM_SETCHECK,0,0L);
     SendDlgItemMessage(w,IDPOINT_NG,BM_SETCHECK,1,0L);
     }
 }    
     
         
BOOL CALLBACK ViewDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
 {
     static int i,old3d,f3d;
     int ascale;
     char junk[50];
     GRAPH g;
     char temp[20];
     switch(message){
         case WM_INITDIALOG:
         SetDlgItemText(hdwnd,IDXLAB_VIEW,MyGraph->xlabel);
         SetDlgItemText(hdwnd,IDYLAB_VIEW,MyGraph->ylabel);
         SetDlgItemText(hdwnd,IDZLAB_VIEW,MyGraph->zlabel);
         set_enabled_stuff(hdwnd,MyGraph->ThreeDFlag);
         SendDlgItemMessage(hdwnd,IDXORG_VIEW,BM_SETCHECK,MyGraph->xorgflag,0L);
         SendDlgItemMessage(hdwnd,IDYORG_VIEW,BM_SETCHECK,MyGraph->yorgflag,0L);
         SendDlgItemMessage(hdwnd,IDZORG_VIEW,BM_SETCHECK,MyGraph->zorgflag,0L);
         
         f3d=MyGraph->ThreeDFlag;
         old3d=f3d;
         SendDlgItemMessage(hdwnd,IDXAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)"t");
         SendDlgItemMessage(hdwnd,IDYAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)"t");
         SendDlgItemMessage(hdwnd,IDZAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)"t");    
         for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp);
            SendDlgItemMessage(hdwnd,IDXAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)temp);
             SendDlgItemMessage(hdwnd,IDYAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)temp);
              SendDlgItemMessage(hdwnd,IDZAX_VIEW,CB_ADDSTRING,0,
             (LPARAM)temp);
             }
         SendDlgItemMessage(hdwnd,IDXAX_VIEW,CB_SETCURSEL,MyGraph->xv[0],0L);
         SendDlgItemMessage(hdwnd,IDYAX_VIEW,CB_SETCURSEL,MyGraph->yv[0],0L);
         SendDlgItemMessage(hdwnd,IDZAX_VIEW,CB_SETCURSEL,MyGraph->zv[0],0L);                      
         fill_viewdialog(hdwnd);         
         
         
              
         break;
         case WM_COMMAND:
            switch(LOWORD(wparam)){ 
                   case ID2D_VIEW:
                   case ID3D_VIEW:
                    f3d=SendDlgItemMessage(hdwnd,
                    ID3D_VIEW,BM_GETCHECK,0,0);
                    set_enabled_stuff(hdwnd,f3d);
                    if(f3d==1){
                        MyGraph->ThreeDFlag=1;
                        MyGraph->grtype=5;
                    }
                    else
                    {
                        MyGraph->ThreeDFlag=0;
                        MyGraph->grtype=0;
                    }   
                  
                    break;
                   case IDOK_VIEW:
                  
                    
                    GetDlgItemText(hdwnd,IDXLAB_VIEW,MyGraph->xlabel,29);
                    GetDlgItemText(hdwnd,IDYLAB_VIEW,MyGraph->ylabel,29);
                    GetDlgItemText(hdwnd,IDZLAB_VIEW,MyGraph->zlabel,29);
                    
                    i=SendDlgItemMessage(hdwnd,
                    IDXAX_VIEW,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->xv[0]=i;
                    
                   i=SendDlgItemMessage(hdwnd,
                    IDYAX_VIEW,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->yv[0]=i;
                    
                    i=SendDlgItemMessage(hdwnd,
                    IDZAX_VIEW,CB_GETCURSEL,0,0L);
                    if(i>-1) MyGraph->zv[0]=i;
                    ascale=SendDlgItemMessage(hdwnd,IDAUTOSCALE_VIEW,
                    BM_GETCHECK,0,0);
                    if(ascale==1){
                    fit_window();
                    do_origin(hdwnd);
                    /* fill_viewdialog(hdwnd); */
                    }
                     else fill_viewgraph(hdwnd);
                     if(MyGraph->ThreeDFlag==0){
                         MyGraph->xmin=MyGraph->xlo;
                         MyGraph->ymin=MyGraph->ylo;
                         MyGraph->xmax=MyGraph->xhi;
                         MyGraph->ymax=MyGraph->yhi;
                     }
                    check_flags();
                    check_windows();
                      EndDialog(hdwnd,0);
                    redraw_the_graph(); 
                  
                   return 1; /* do nothing */
                   case IDCANCEL_VIEW:
                   
                   MyGraph->ThreeDFlag=old3d;
                   if(old3d==1){
                       MyGraph->grtype=5;
                   }
                   else {
                       MyGraph->grtype=0;
                   }
                     EndDialog(hdwnd,0); 
                   return 1; /* do nothing */
                   case IDAUTOSCALE_VIEW:
                    
                    break;
                    
            }
     }
     return 0;
 }



set_enabled_stuff(HWND hdwnd,int type)
{
 switch(type){
 case 0:    /* 2 d window */
     EnableWindow(GetDlgItem(hdwnd,IDXMIN_VIEW),FALSE); 
     EnableWindow(GetDlgItem(hdwnd,IDXMAX_VIEW),FALSE);    
     EnableWindow(GetDlgItem(hdwnd,IDYMIN_VIEW),FALSE);
     EnableWindow(GetDlgItem(hdwnd,IDYMAX_VIEW),FALSE);
     EnableWindow(GetDlgItem(hdwnd,IDZMIN_VIEW),FALSE);
     EnableWindow(GetDlgItem(hdwnd,IDZMAX_VIEW),FALSE);
     EnableWindow(GetDlgItem(hdwnd,IDZPHI_VIEW),FALSE);
          EnableWindow(GetDlgItem(hdwnd,IDZTHETA_VIEW),FALSE);
    /* EnableWindow(GetDlgItem(hdwnd,IDSBPHI),FALSE);
          EnableWindow(GetDlgItem(hdwnd,IDSBTHETA),FALSE);  */   
     EnableWindow(GetDlgItem(hdwnd,IDZAX_VIEW),FALSE);
      EnableWindow(GetDlgItem(hdwnd,IDZLAB_VIEW),FALSE);
      EnableWindow(GetDlgItem(hdwnd,IDZORGV_VIEW),FALSE);
      EnableWindow(GetDlgItem(hdwnd,IDZORG_VIEW),FALSE);
      SendDlgItemMessage(hdwnd,ID2D_VIEW,BM_SETCHECK,1,0);
            SendDlgItemMessage(hdwnd,ID3D_VIEW,BM_SETCHECK,0,0);
      break;
    case 1:    /* 3 d window */
     EnableWindow(GetDlgItem(hdwnd,IDXMIN_VIEW),TRUE); 
     EnableWindow(GetDlgItem(hdwnd,IDXMAX_VIEW),TRUE);    
     EnableWindow(GetDlgItem(hdwnd,IDYMIN_VIEW),TRUE);
     EnableWindow(GetDlgItem(hdwnd,IDYMAX_VIEW),TRUE);
     EnableWindow(GetDlgItem(hdwnd,IDZMIN_VIEW),TRUE);
     EnableWindow(GetDlgItem(hdwnd,IDZMAX_VIEW),TRUE);
     EnableWindow(GetDlgItem(hdwnd,IDZPHI_VIEW),TRUE);
          EnableWindow(GetDlgItem(hdwnd,IDZTHETA_VIEW),TRUE);
  /*    EnableWindow(GetDlgItem(hdwnd,IDSBPHI),TRUE); 
          EnableWindow(GetDlgItem(hdwnd,IDSBTHETA),TRUE);  */       
     EnableWindow(GetDlgItem(hdwnd,IDZAX_VIEW),TRUE);
      EnableWindow(GetDlgItem(hdwnd,IDZLAB_VIEW),TRUE);
       EnableWindow(GetDlgItem(hdwnd,IDZORGV_VIEW),TRUE);
      EnableWindow(GetDlgItem(hdwnd,IDZORG_VIEW),TRUE);
       SendDlgItemMessage(hdwnd,ID2D_VIEW,BM_SETCHECK,0,0);
            SendDlgItemMessage(hdwnd,ID3D_VIEW,BM_SETCHECK,1,0);
      break;  
      }
      }


check_flags()
{
  if(MyGraph->grtype>4)MyGraph->ThreeDFlag=1;
  else MyGraph->ThreeDFlag=0;
  if((MyGraph->xv[0]==0)||(MyGraph->yv[0]==0)||
     ((MyGraph->zv[0]==0)&&(MyGraph->ThreeDFlag==1)))MyGraph->TimeFlag=1;
  else MyGraph->TimeFlag=0;
}
  
check_val(x1,x2,xb,xd)
 double *x1,*x2,*xb,*xd;
{
 double temp;

/* 
  see get_max for details
*/   
      
 if(*x1==*x2){
   temp=.05*mmax(fabs(*x1),1.0);
   *x1=*x1-temp;
   *x2=*x2+temp;
 }
 if(*x1>*x2){
             temp=*x2;
             *x2=*x1;
             *x1=temp;
             
            }
            *xb=.5*(*x1+*x2);
            *xd=2.0/(*x2-*x1);

}

BOOL CALLBACK ColorDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM
lparam)
{
 int i;
 char temp[256];
 switch(message){
         case WM_INITDIALOG:
            SendDlgItemMessage(hdwnd,IDUSER_COL,CB_ADDSTRING,0,
             (LPARAM)"t");
             for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp);
            SendDlgItemMessage(hdwnd,IDUSER_COL,CB_ADDSTRING,0,
             (LPARAM)temp);
             }
             fill_colorize(hdwnd);
             return 1;
         case WM_COMMAND:
           switch(LOWORD(wparam)){
             case IDOFF_COL:
                MyGraph->ColorFlag=0;
                return 1;
              case IDVEL_COL:
                MyGraph->ColorFlag=1;
                return 1;
              case IDUSE_COL:
                MyGraph->ColorFlag=2;
                return 1;  
              case IDSCALE_COL:
                 optimum_color(hdwnd);
                 break;
              case IDOK_COL:
                get_color_info(hdwnd);
               /* sprintf(temp,"fl=%d,fv=%d,min=%g,max=%g",
                MyGraph->ColorFlag,MyGraph->ColorValue,MyGraph->min_scale,MyGraph->color_scale);
                MB(temp); */
                EndDialog(hdwnd,0);
                return 1;
                }

          }
          return 0;
}


fill_colorize(HWND w)
{
 char bob[100];
 SendDlgItemMessage(w,IDOFF_COL,BM_SETCHECK,0,0);
 SendDlgItemMessage(w,IDUSE_COL,BM_SETCHECK,0,0);
 SendDlgItemMessage(w,IDVEL_COL,BM_SETCHECK,0,0);
  switch(MyGraph->ColorFlag){
  case 0:
    SendDlgItemMessage(w,IDOFF_COL,BM_SETCHECK,1,0);
    break;
   case 1:
    SendDlgItemMessage(w,IDVEL_COL,BM_SETCHECK,1,0);
    break;
    case 2:
    SendDlgItemMessage(w,IDUSE_COL,BM_SETCHECK,1,0);
    break;
    }
  set_color_floats(w);
   SendDlgItemMessage(w,IDUSER_COL,CB_SETCURSEL,MyGraph->ColorValue,0L);
 }
 
 
 get_color_info(HWND w)
 {
  int i;
  double vmin,vmax;
  char bob[256];
  if(SendDlgItemMessage(w,IDUSE_COL,BM_GETCHECK,0,0L)==1){
   MyGraph->ColorFlag=2;
   i=SendDlgItemMessage(w,IDUSER_COL,CB_GETCURSEL,0,0L);
   if(i>=0)
   MyGraph->ColorValue=i;
   }
   if(SendDlgItemMessage(w,IDOFF_COL,BM_GETCHECK,0,0L)==1)
   MyGraph->ColorFlag=0;
   if(SendDlgItemMessage(w,IDVEL_COL,BM_GETCHECK,0,0L)==1)
    MyGraph->ColorFlag=1;
   if(MyGraph->ColorFlag>0){
    GetDlgItemText(w,IDMAX_COL,bob,250);
    vmax=atof(bob);
   GetDlgItemText(w,IDMIN_COL,bob,250);
    vmin=atof(bob);
    if(vmax>vmin){
     MyGraph->min_scale=vmin;
     MyGraph->color_scale=vmax-vmin;
     }
   }
   }
   
    
    
   


optimum_color(HWND w)
{
     int i,j;
     int type=MyGraph->ColorValue;
    
       double sum;
     double vmin,vmax;
    
    if(my_browser.maxrow<=2||MyGraph->ColorFlag==0){
    
        return;
    }
       
    if(MyGraph->ColorFlag==1){
    vmin=1e20;
    vmax=-1.0;
    for(i=1;i<my_browser.maxrow;i++){
        sum=0.0;
        for(j=0;j<NODE;j++)
        sum+=(float)fabs((double)(my_browser.data[1+j][i]-my_browser.data[1+j][i-1]));
        if(sum<vmin)vmin=sum;
        if(sum>vmax)vmax=sum;
    }
      if(vmax>vmin){
       MyGraph->color_scale=(vmax-vmin)/(fabs(DELTA_T*NJMP));
       MyGraph->min_scale=vmin/(fabs(DELTA_T*NJMP));
       }
       
    }
    else {
            if(type>=0)        
            get_max(type,&vmin,&vmax);
        MyGraph->min_scale=vmin;
        MyGraph->color_scale=(vmax-vmin);
        if(MyGraph->color_scale==0.0)MyGraph->color_scale=1.0;
        }
    set_color_floats(w);        
    
}       
        
   set_color_floats(HWND w)
   {
    char bob[256];
    sprintf(bob,"%g",MyGraph->min_scale);
    SetDlgItemText(w,IDMIN_COL,bob);
    sprintf(bob,"%g",MyGraph->min_scale+MyGraph->color_scale);
    SetDlgItemText(w,IDMAX_COL,bob);
    }
    
    
get_max(index, vmin,vmax)
  double *vmax,*vmin;
  int index;
  {
   float x0,x1,z;
   double temp;
   int i;
   x0=my_browser.data[index][0];
   x1=x0;
   for(i=0;i<my_browser.maxrow;i++)
   {
    z=my_browser.data[index][i];
    if(z<x0)x0=z;
    if(z>x1)x1=z;
   }
   *vmin=(double)x0;
   *vmax=(double)x1;
    if(fabs(*vmin-*vmax)<REAL_SMALL){
      temp=.05*mmax(fabs(*vmin),1.0);
     *vmin=*vmin-temp;
     *vmax=*vmax+temp;
    }
 
 }

 
 
 corner_cube(xlo,xhi,ylo,yhi)
 double *xlo,*ylo,*xhi,*yhi;
{
 float x,y;
 float x1,x2,y1,y2;
 threedproj(-1.,-1.,-1.,&x,&y);
 x1=x;
 x2=x;
 y1=y;
 y2=y;
 threedproj(-1.,-1.,1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(-1.,1.,-1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(-1.,1.,1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(1.,-1.,-1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(1.,-1.,1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(1.,1.,1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 threedproj(1.,1.,-1.,&x,&y);
 if(x<x1)x1=x;
 if(x>x2)x2=x;
 if(y<y1)y1=y;
 if(y>y2)y2=y;
 *xlo=x1;
 *ylo=y1;
 *xhi=x2;
 *yhi=y2;
}
 
fit_window()
{
  double Mx=-1.e25,My=-1.e25,Mz=-1.e25,mx=-Mx,my=-My,mz=-Mz;
  int i,n=MyGraph->nvars;
  if(storind<2)return;
  if(MyGraph->ThreeDFlag){
    for(i=0;i<n;i++){
      
      get_max(MyGraph->xv[i],&(MyGraph->xmin),&(MyGraph->xmax));
      Mx=mmax(MyGraph->xmax,Mx);
      mx=-mmax(-MyGraph->xmin,-mx);
      
      get_max(MyGraph->yv[i],&(MyGraph->ymin),&(MyGraph->ymax));
      My=mmax(MyGraph->ymax,My);
      my=-mmax(-MyGraph->ymin,-my);
      
      get_max(MyGraph->zv[i],&(MyGraph->zmin),&(MyGraph->zmax));
      Mz=mmax(MyGraph->zmax,Mz);
      mz=-mmax(-MyGraph->zmin,-mz);
      
    }
    MyGraph->xmax=Mx;
    MyGraph->ymax=My;
    MyGraph->zmax=Mz;
    MyGraph->xmin=mx;
    MyGraph->ymin=my;
    MyGraph->zmin=mz;
    
    

    corner_cube(&(MyGraph->xlo),&(MyGraph->xhi),&(MyGraph->ylo),&(MyGraph->yhi));

    check_windows();
  }
  else  
    {
      for(i=0;i<n;i++){
        get_max(MyGraph->xv[i],&(MyGraph->xmin),&(MyGraph->xmax));
        Mx=mmax(MyGraph->xmax,Mx);
        mx=-mmax(-MyGraph->xmin,-mx);
        
       get_max(MyGraph->yv[i],&(MyGraph->ymin),&(MyGraph->ymax));
        My=mmax(MyGraph->ymax,My);
        my=-mmax(-MyGraph->ymin,-my);
        
      }
      MyGraph->xmax=Mx;
      MyGraph->ymax=My;
      
      MyGraph->xmin=mx;
      MyGraph->ymin=my;
      
      

      MyGraph->xlo=MyGraph->xmin;
      MyGraph->ylo=MyGraph->ymin;
      MyGraph->xhi=MyGraph->xmax;
      MyGraph->yhi=MyGraph->ymax;
      check_windows();
    }
  
}
get_vi(HWND w,int id,int *z)
{
 char bob[256];
 GetDlgItemText(w,id,bob,250);
 *z=atoi(bob);
} 
set_vi(HWND w,int id,int x)
{
  char bob[256];
  sprintf(bob,"%d",x);
  SetDlgItemText(w,id,bob);
}

get_vd(HWND w,int id,double *z)
{
 char bob[256];
 GetDlgItemText(w,id,bob,250);
 *z=atof(bob);
} 
set_vd(HWND w,int id,double x)
{
  char bob[256];
  sprintf(bob,"%g",x);
  SetDlgItemText(w,id,bob);
}

fill_viewdialog(HWND w)
{
set_vd(w,IDXMIN_VIEW,MyGraph->xmin);
set_vd(w,IDXMAX_VIEW,MyGraph->xmax);
set_vd(w,IDXHI_VIEW,MyGraph->xhi);
set_vd(w,IDXLO_VIEW,MyGraph->xlo);
set_vd(w,IDXORGV_VIEW,MyGraph->xorg);

set_vd(w,IDYMIN_VIEW,MyGraph->ymin);
set_vd(w,IDYMAX_VIEW,MyGraph->ymax);
set_vd(w,IDYHI_VIEW,MyGraph->yhi);
set_vd(w,IDYLO_VIEW,MyGraph->ylo);
set_vd(w,IDYORGV_VIEW,MyGraph->yorg);

set_vd(w,IDZMIN_VIEW,MyGraph->zmin);
set_vd(w,IDZMAX_VIEW,MyGraph->zmax);
set_vd(w,IDZPHI_VIEW,MyGraph->Phi);
set_vd(w,IDZTHETA_VIEW,MyGraph->Theta);
set_vd(w,IDZORGV_VIEW,MyGraph->zorg);
}

fill_viewgraph(HWND w)
{
get_vd(w,IDXMIN_VIEW,&MyGraph->xmin);
get_vd(w,IDXMAX_VIEW,&MyGraph->xmax);
get_vd(w,IDXHI_VIEW,&MyGraph->xhi);
get_vd(w,IDXLO_VIEW,&MyGraph->xlo);


get_vd(w,IDYMIN_VIEW,&MyGraph->ymin);
get_vd(w,IDYMAX_VIEW,&MyGraph->ymax);
get_vd(w,IDYHI_VIEW,&MyGraph->yhi);
get_vd(w,IDYLO_VIEW,&MyGraph->ylo);


get_vd(w,IDZMIN_VIEW,&MyGraph->zmin);
get_vd(w,IDZMAX_VIEW,&MyGraph->zmax);
get_vd(w,IDZPHI_VIEW,&MyGraph->Phi);
get_vd(w,IDZTHETA_VIEW,&MyGraph->Theta);

do_origin(w);
}

do_origin(HWND w)
{
    get_vd(w,IDXORGV_VIEW,&MyGraph->xorg);
get_vd(w,IDZORGV_VIEW,&MyGraph->zorg);
get_vd(w,IDYORGV_VIEW,&MyGraph->yorg);
MyGraph->xorgflag=SendDlgItemMessage(w,IDXORG_VIEW,BM_GETCHECK,0,0L);
MyGraph->yorgflag=SendDlgItemMessage(w,IDYORG_VIEW,BM_GETCHECK,0,0L);
MyGraph->zorgflag=SendDlgItemMessage(w,IDZORG_VIEW,BM_GETCHECK,0,0L);
}    
check_windows()
{
 double zip,zap;
 check_val(&MyGraph->xmin,&MyGraph->xmax,&MyGraph->xbar,&MyGraph->dx);
 check_val(&MyGraph->ymin,&MyGraph->ymax,&MyGraph->ybar,&MyGraph->dy);
 check_val(&MyGraph->zmin,&MyGraph->zmax,&MyGraph->zbar,&MyGraph->dz);
 check_val(&MyGraph->xlo,&MyGraph->xhi,&zip,&zap);
 check_val(&MyGraph->ylo,&MyGraph->yhi,&zip,&zap);
}



BOOL CALLBACK FreezeDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,ic;
 static int iold,inew,nfrz,crvs[MAXFRZ];
char temp[50];
 switch(message){
     case WM_INITDIALOG:
        nfrz=0;
        iold=-1;
     for(i=0;i<12;i++)
        SendDlgItemMessage(hdwnd,IDCOLOR_FRZ,LB_ADDSTRING,0,
             (LPARAM)color_list[i]);
       iold=get_frz_curve_list(crvs,&nfrz,hdwnd);
        SendDlgItemMessage(hdwnd,IDMOUSE_FRZ,BM_SETCHECK,0,0L);
        SendDlgItemMessage(hdwnd,IDAUTO_FRZ,BM_SETCHECK,AutoFreezeFlag,0L);
        SendDlgItemMessage(hdwnd,IDSHOWKEY_FRZ,BM_SETCHECK,MyGraph->legend_flag,0L);
            
                
        return 1;
     case WM_COMMAND:
        switch(LOWORD(wparam)){
            case IDCURVE_FRZ:
                   
                       switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                          save_frz_select(hdwnd,iold);
                          ic=SendDlgItemMessage(hdwnd,IDCURVE_FRZ,LB_GETCURSEL,0,0L);
                          if(ic>=0)iold=crvs[ic];
                          load_frz_select(hdwnd,iold);  
                        
                              return 1;
                       }
                      return 1;
            case IDADD_FRZ:
            inew=create_crv(0,0,"");
            if(inew>=0){
               iold=get_frz_curve_list(crvs,&nfrz,hdwnd); 
            }
            return 1;
            case IDDEL_FRZ:
                if(nfrz==0)return 1;
                i=SendDlgItemMessage(hdwnd,IDCURVE_FRZ,LB_GETCURSEL,0,0L);
                if(i>=0){
                    ic=crvs[i];
                    delete_frz_crv(i);
                    iold=get_frz_curve_list(crvs,&nfrz,hdwnd);
                    return 1;
                }
                        
                return 1;
            case IDDELALL_FRZ:
                   if(nfrz==0)return 1;
                   kill_frz();
                   iold=get_frz_curve_list(crvs,&nfrz,hdwnd);
                   return 1;
                    
            case IDOKAY_FRZ:
             save_frz_select(hdwnd,iold);
             ic=SendDlgItemMessage(hdwnd,IDMOUSE_FRZ,BM_GETCHECK,0,0L);
             MyGraph->legend_flag=SendDlgItemMessage(hdwnd,IDSHOWKEY_FRZ,BM_GETCHECK,0,0L);
             AutoFreezeFlag=SendDlgItemMessage(hdwnd,IDAUTO_FRZ,BM_GETCHECK,0,0L);
            EndDialog(hdwnd,0);
            redraw_the_graph();
            if(ic==1){
                  LookingForMouse=MOUSE_KEY;
                    SelfKill("Position Legend");
            }
            return 1;
            case IDCANCEL_FRZ:
                EndDialog(hdwnd,0);
                 redraw_the_graph();
                return 1;
        }
 }
 return 0;
}   

load_frz_select(HWND w,int i)
{
    char bob[50];
    int c;
    SetDlgItemText(w,IDKEY_FRZ,frz[i].key);
    SendDlgItemMessage(w,IDCOLOR_FRZ,LB_SETCURSEL,frz[i].color,0L);
}
save_frz_select(HWND w,int i)
{
    char bob[50];
    int c;
    GetDlgItemText(w,IDKEY_FRZ,bob,49);
    strcpy(frz[i].key,bob);
    c=SendDlgItemMessage(w,IDCOLOR_FRZ,LB_GETCURSEL,0,0L);
    if(c>=0)
     frz[i].color=c;
}
get_frz_curve_list(crv,n,w)
int *n,*crv;
HWND w;
{
    int i,ilast=-1;
    *n=0;
    SendDlgItemMessage(w,IDCURVE_FRZ,LB_RESETCONTENT,0,0L);
    for(i=0;i<MAXFRZ;i++){
        if(frz[i].use&&frz[i].w==draw_win){
         crv[*n]=i;
         *n=*n+1;
         ilast=i;
         SendDlgItemMessage(w,IDCURVE_FRZ,LB_ADDSTRING,0,(LPARAM)frz[i].name);
        }
    }
    if(ilast>=0){
        SendDlgItemMessage(w,IDCURVE_FRZ,LB_SETCURSEL,*n-1,0L);
            SendDlgItemMessage(w,IDCOLOR_FRZ,LB_SETCURSEL,frz[ilast].color,0L);
            SetDlgItemText(w,IDKEY_FRZ,frz[ilast].key);
    }
 return ilast;   
}

  
