#include <math.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <stdarg.h>
#include "structs.h"


#define MAXPOP 11
#define MAXPERPLOT 10
#define MAXPLOTS 20
#define DEGTORAD .0174532
#define EP1 1.000001
#define TAXIS 2
/* #define max(a,b) ((a>b) ? a : b)
#define min(a,b) ((a<b) ? a : b) */
#define PS_XMAX 7200
#define PS_YMAX 5040
#define SYMSIZE .00175

#define MAX_COLORS 256
#define MIN_COLORDEF 21
#define COL_TOTAL 100
extern int current_pop;
int color_min,color_total,color_max;


extern int AutoFreezeFlag;

extern CURVE frz[MAXFRZ];

char color_list[12][20];
       
HFONT smallfont,stdfont;
HFONT helv8font;
extern double x_3d[2],y_3d[2],z_3d[2];
extern int IXPLT,IYPLT,IZPLT;
extern int AXES,TIMPLOT,PLOT_3D;
extern double MY_XLO,MY_YLO,MY_XHI,MY_YHI;

 int DCURXs,DCURYs;
 int DCURX8,DCURY8;
extern int PSFlag;
unsigned int GrFore,GrBack;
int SCALEX,SCALEY,DCURX,DCURY,xor_flag;
extern GRAPH graph[MAXPOP];
extern GRAPH *MyGraph;





int DX_0,DY_0,D_WID,D_HGT;
int D_FLAG;
int PointRadius=0;
extern HWND win;
extern HWND draw_win;

extern float **storage;
extern int storind;
extern BROWSER my_browser;
extern HDC gc_graph; /*  This should always be the gc  */
int WinFont=1,WinColor,WinLineWid,WinDash;
extern HINSTANCE hInst;
LPLOGPALETTE logpal;
HPALETTE hpal;

/*  This is an improved graphics driver for XPP  
    It requires only a few commands
    All positions are integers
   
    point(x,y)        Draws point to (x,y) with pointtype PointStyle
    line(x1,y1,x2,y2) Draws line with linetype LineStyle
    put_text(x1,y,text)  Draws text with TextAngle, Justify
    init_device()     Sets up the default for tics, plotting area,
                      and anything else 
                      

    close_device()  closes files, etc

    The device is assumed to go from (0,0) to (XDMax,YDMax)
    
    DLeft,DRight,DTop,DBottom are the actual graph areas
    VTic Htic are the actual sizes of the tics in device pixels
    VChar HChar are the height and width used for character spacing
 
    linetypes   -2  thick plain lines
                -1  thin plain lines
                   
    
*/


int DLeft,DRight,DTop,DBottom,VTic,HTic,VChar,HChar,XDMax,YDMax;
double XMin,YMin,XMax,YMax;
int LineType=0,PointType=-1,TextJustify,TextAngle;

char errbuffer[256];

create_ps(int color)
{
 char filename[100];
 filename[0]=0;
 opensave(1,hInst,filename,"Save postscript file");
   if(strlen(filename)==0)
   {
      err_msg("No file!");
      return;
   }    
 if(ps_init(filename,color)){
   ps_restore(); 
   
 }
}


ps_restore()
{
 do_axes();
 restore(0,my_browser.maxrow);
 restore_nullclines();
 redraw_dfield();
 /* draw_label(draw_win); */
 draw_freeze(draw_win); 
 ps_end();
}
redraw_the_graph()
{
 HDC olddc=gc_graph;
 gc_graph=GetDC(draw_win);
 set_palette(gc_graph);
 clear_window();
 get_draw_area();
 redraw_dfield();
 redraw();
  draw_freeze(draw_win);
/*  draw_label(draw_win);
 

 if(MyGraph->Nullrestore)restore_nullclines(); */
 ReleaseDC(draw_win,gc_graph);
 gc_graph=olddc;
}
        

zoom_in(i1,j1,i2,j2)
int i1,j1,i2,j2;
{
 float x1,y1,x2,y2;
 scale_to_real(i1,j1,&x1,&y1);
 scale_to_real(i2,j2,&x2,&y2);
             
              MyGraph->xlo=x1;
              MyGraph->ylo=y1;
              MyGraph->xhi=x2;
              MyGraph->yhi=y2;
              if(MyGraph->grtype<5){
              MyGraph->xmin=MyGraph->xlo;
              MyGraph->xmax=MyGraph->xhi;
              MyGraph->ymin=MyGraph->ylo;
              MyGraph->ymax=MyGraph->yhi;
              }
              check_windows();
              redraw_the_graph();
             
}

zoom_out(i1,j1,i2,j2)
{
 float x1,y1,x2,y2;
 float bx,mux,by,muy;
 float dx=MyGraph->xhi-MyGraph->xlo;
 float dy=MyGraph->yhi-MyGraph->ylo;
 scale_to_real(i1,j1,&x1,&y1);
 scale_to_real(i2,j2,&x2,&y2);
 if(x1>x2){bx=x1;x1=x2;x2=bx;}
 if(y1>y2){by=y1;y1=y2;y2=by;}
 if(x1==x2||y1==y2)return;
 /*
 printf("%f %f %f %f \n ",x1,y1,x2,y2);
 printf("%f %f %f %f \n",MyGraph->xlo,MyGraph->ylo,MyGraph->xhi,MyGraph->yhi);

 */
 bx=dx*dx/(x2-x1);
 mux=(x1-MyGraph->xlo)/dx;
 MyGraph->xlo=MyGraph->xlo-bx*mux;
 MyGraph->xhi=MyGraph->xlo+bx;
 
 by=dy*dy/(y2-y1);
 muy=(y1-MyGraph->ylo)/dy;
 MyGraph->ylo=MyGraph->ylo-by*muy;
 MyGraph->yhi=MyGraph->ylo+by;

    if(MyGraph->grtype<5){
              MyGraph->xmin=MyGraph->xlo;
              MyGraph->xmax=MyGraph->xhi;
              MyGraph->ymin=MyGraph->ylo;
              MyGraph->ymax=MyGraph->yhi;
              }
              check_windows();
              redraw_the_graph();
            
}
 

clear_window()
{
 HDC dc,odc;
 dc=GetDC(draw_win);
 ClearWindow(draw_win,dc);
 odc=gc_graph;
 gc_graph=dc;
 get_draw_area_i(current_pop);
 do_axes();
 gc_graph=odc;
 ReleaseDC(draw_win,dc);
 
 
  
}
/*
WPrintf(char *fmt,...)
{
 va_list arglist;
 va_start(arglist,fmt);
 vsprintf(&errbuffer[0],fmt,arglist);
 va_end(arglist);
 err_msg(errbuffer);
 
}
*/
Err_Exit(char *fmt,...)
{
 va_list arglist;
 va_start(arglist,fmt);
 vsprintf(&errbuffer[0],fmt,arglist);
 va_end(arglist);
 lprintf("%s\n",errbuffer);
 err_msg(errbuffer);
 Lexit(0);
}

err_msg(a)
char *a;
{
    MessageBox(NULL,a,"",MB_OK);
}

create_std_fonts(HWND hwnd,int BCSize)
{
  HDC hdc;
 smallfont=CreateFont(14,7,0,0,FW_MEDIUM,0,0,0,
    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,FIXED_PITCH,"Quick Type"); 
    hdc=GetDC(hwnd);
    stdfont=SelectObject(hdc,smallfont);
     helv8font=CreateFont(-MulDiv(BCSize,GetDeviceCaps(hdc,LOGPIXELSY),72),0,0,0,
    FW_MEDIUM,0,0,0,
    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    PROOF_QUALITY,FIXED_PITCH,"Helvetica"); 
    /* helv8font=smallfont; */
    if(helv8font==NULL)err_msg("no helv 8");

    ReleaseDC(hwnd,hdc);
    get_pix_size(&DCURX,&DCURY,stdfont,hwnd);
    get_pix_size(&DCURXs,&DCURYs,smallfont,hwnd);
     get_pix_size(&DCURX8,&DCURY8,helv8font,hwnd);
     lprintf("H8:%d %d; NRM:%d %d; SML:%d %d \n",
	     DCURX8,DCURY8,DCURX,DCURY,DCURXs,DCURYs);
    }
    
get_pix_size(int *curx,int *cury, HFONT hf,HWND hwnd)
{
  HDC hdc;
  SIZE s;
  hdc=GetDC(hwnd);
  SelectObject(hdc,hf);
  SwapBuffers(hdc);
  GetTextExtentPoint32(hdc,"W",1,&s);
  *cury=s.cy;
  *curx=s.cx;
  ReleaseDC(hwnd,hdc);
} 

get_pix_size_ok(int *curx,int *cury, HFONT hf,HWND hwnd)
{
  HDC hdc;
  TEXTMETRIC tm;
  hdc=GetDC(hwnd);
  SelectObject(hdc,hf);
  SwapBuffers(hdc);
  GetTextMetrics(hdc,&tm);
  *cury=tm.tmHeight+tm.tmExternalLeading;
  *curx=tm.tmAveCharWidth;
  ReleaseDC(hwnd,hdc);
} 

int rfun(y)
  double y;

{  
  double x;
  x=y;
 

  if(x>.33333333333)return(0);
  return((int)(3.*255*sqrt((.333334-x)*(x+.33334))));
}

int gfun(y)
 double y;
{
 if(y>.666666)return(0);
 return( (int)(3.*255*sqrt((.6666667-y)*(y))));
}
 
int bfun(y)
double y;
{
 if(y<.333334)return(0);
 return((int)(2.79*255*sqrt((1.05-y)*(y-.333333333))));
}

make_std_colors()
{
    int i,size;
    double z;
     color_min =MIN_COLORDEF;
    color_max = MAX_COLORS -1;
    color_total = color_max - color_min +1;
    
   
        
    for (i = color_min; i <= color_max; i++) {
         z=(double)(i-color_min)/(double)color_total;
          /*  col_tab[i]=RGB(rfun(z),gfun(z),bfun(z)); 
          
         col_tab[i]=RGB(255-i,0,i); 
         */       
    }
}
    

add_pal_entry(LPLOGPALETTE p,int i,int r,int g,int b)
{

     p->palPalEntry[i].peRed=r;
     p->palPalEntry[i].peGreen=g;
     p->palPalEntry[i].peBlue=b;
     p->palPalEntry[i].peFlags=PC_RESERVED;
}    
    
make_palette(int n)
{
    int ctot=n+12,i;
    double z;
    char bob[256];
    logpal=HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,
                      sizeof(LOGPALETTE)+(ctot*sizeof(PALETTEENTRY)));
    logpal->palVersion    = 0x300;
    logpal->palNumEntries = ctot;                  
    add_pal_entry(logpal,0,0,0,0);
    strcpy(color_list[0],"Black");
    add_pal_entry(logpal,1,255,255,255);
        strcpy(color_list[1],"White");
    add_pal_entry(logpal,2,255,0,0);
        strcpy(color_list[2],"Red");
    add_pal_entry(logpal,3,240,100,0);
        strcpy(color_list[3],"RedOrange");
    add_pal_entry(logpal,4,255,165,0);
        strcpy(color_list[4],"Orange");       
    add_pal_entry(logpal,5,255,205,0);
        strcpy(color_list[5],"YellowOrange");
    add_pal_entry(logpal,6,255,255,0);
        strcpy(color_list[6],"Yellow");
    add_pal_entry(logpal,7,154,50,205);
        strcpy(color_list[7],"YellowGreen");
    add_pal_entry(logpal,8,0,255,0);
        strcpy(color_list[8],"Green");
    add_pal_entry(logpal,9,0,255,255);
        strcpy(color_list[9],"BlueGreen");
    add_pal_entry(logpal,10,0,0,255);
        strcpy(color_list[10],"Blue");
    add_pal_entry(logpal,11,160,32,240);
        strcpy(color_list[11],"Purple");
    for(i=0;i<n;i++){
         z=1.-((double)i)/((double)(n-1));
         add_pal_entry(logpal,12+i,rfun(z),gfun(z),bfun(z));
       
    }
                      
    hpal=CreatePalette(logpal);
    if(hpal==NULL){
        sprintf(bob, "Failed to add palette -- error %d",GetLastError());
        MessageBox(NULL,bob,NULL,MB_OK);
    }
    color_min=12;
    color_max=ctot;
    color_total=n;
}                     

SmallGr()
{
 WinFont=0;
}

GrCol()
{
 WinFont=1;
} 


set_scale(x1,y1,x2,y2)
     double x1,y1,x2,y2;
{
  XMin=x1;
  YMin=y1;
  XMax=x2;
  YMax=y2;
}

scale_dxdy(x,y,i,j)
     float x,y;
     double *i,*j;
{
  float dx=(DRight-DLeft)/(XMax-XMin);
  float dy=(DTop-DBottom)/(YMax-YMin);
  *i=x*dx;
  *j=y*dy;
}  
get_draw_area_i(i)
    int i;
{
 int cp=current_pop;
 current_pop=i;
  MyGraph=&graph[i];
  draw_win=graph[i].w;
  get_draw_area();
  current_pop=cp;
  draw_win=graph[cp].w;
     MyGraph=&graph[cp];
     get_draw_area();              
 
} 


copy_to_clip()
{
    RECT rect;
    HDC memdc;
    HBITMAP hbm;
    int w,h;
    GetClientRect(draw_win,&rect);
    w=rect.right;
    h=rect.bottom;
    set_gc(1);
    memdc=CreateCompatibleDC(gc_graph);
    hbm=CreateCompatibleBitmap(gc_graph,w,h);
    SelectObject(memdc,hbm);
    BitBlt(memdc,0,0,w,h,gc_graph,0,0,SRCCOPY);
    if(OpenClipboard(NULL)!=0){
         EmptyClipboard();
         SetClipboardData(CF_BITMAP,hbm);
         CloseClipboard(); }
    else {
        err_msg("Couldn't open clipboard!");
    }
    DeleteDC(memdc);
    set_gc(0);
}     
         
    
    
get_draw_area()
{
 int w,h;
  RECT rect;
  
 GetClientRect(draw_win,&rect);
  w=rect.right;
  h=rect.bottom;
  XDMax=w;
  YDMax=h;
  VTic=max(h/100,1);
  HTic=max(w/150,1);
  VChar=DCURYs;  /*max(h/25,1);*/
  HChar=DCURXs; /* max(w/80,1); */
  
  DLeft=12*HChar;
  DRight=XDMax-3*HChar-HTic;
  DBottom=YDMax-1-VChar*7/2;
  DTop=VChar*5/2+1;
  h=DBottom-DTop;
  w=DRight-DLeft;
  if(h>0&&w>0)D_FLAG=1;
 else D_FLAG=0;
 MyGraph->Width=w;
 MyGraph->Height=h;
 MyGraph->x0=DLeft;
 MyGraph->y0=DTop;
 set_normal_scale();
}

set_normal_scale()
{
XMin=MyGraph->xlo;
 YMin=MyGraph->ylo;
 XMax=MyGraph->xhi;
 YMax=MyGraph->yhi;
}
point(x,y)
     int x,y;
{
  if(PSFlag)ps_point(x,y);
  else point_x11(x,y);
}

frect(x1,y1,w,h)
     int  x1,y1,w,h;
{
  if(PSFlag)ps_frect(x1,y1,w+1,h+1);
  else rect_x11(x1,y1,w,h);
}
line(x1,y1,x2,y2)
     int x1,y1,x2,y2;
{
  /* printf("l %d %d %d %d \n",x1,y1,x2,y2); */
  if(PSFlag)ps_line(x1,y1,x2,y2);
  else line_x11(x1,y1,x2,y2);
}


put_text(x,y,str)
     int x,y;
     char *str;
{
  if(PSFlag)ps_text(x,y,str);
  else put_text_x11(x,y,str);
}


init_x11()
{
 get_draw_area();
}

init_ps()
{
 XDMax=7200;
 YDMax=5040;
 VTic=63;
 HTic=63;
 VChar=140;
 HChar=84;
 DLeft=12*HChar;
 DRight=XDMax-3*HChar-HTic;
 DTop=YDMax-1-VChar*7/2;
 DBottom=VChar*5/2+1;

}
/* tst_gr()
{
    int i;
    for(i=0;i<100;i++){
        graph_xor(3*i,3*i);

       delay(10);
        graph_xor(3*i,3*i); 
    }
}  */  
graph_xor(int x,int y)
{
 
  HPEN pen,oldpen;
  pen=CreatePen(PS_SOLID,1,RGB(255,0,0));

  gc_graph=GetDC(draw_win);
  oldpen=SelectObject(gc_graph,pen);  
  
  SetROP2(gc_graph,R2_NOT); 
   MoveToEx(gc_graph,x-6,y,NULL);
   LineTo(gc_graph,x+6,y);
   MoveToEx(gc_graph,x,y-6,NULL);
   LineTo(gc_graph,x,y+6);
  SetROP2(gc_graph,R2_COPYPEN); 
   SelectObject(gc_graph,oldpen);
   DeleteObject(pen);
   ReleaseDC(draw_win,gc_graph);

    
}
point_x11(xp,yp)
     int xp,yp;
{
  int r=PointRadius;
  int  r2 = (int) (r / 1.41421356 + 0.5);
  int wh = 2 * r2;
  HPEN pen,oldpen;
  pen=CreatePen(PS_SOLID,1,RGB(0,0,0));
  
  oldpen=SelectObject(gc_graph,pen);
  if(PointRadius==0){
  MoveToEx(gc_graph,xp,yp,NULL);
  LineTo(gc_graph,xp+1,yp+1);
  }
  else {
  Ellipse(gc_graph,xp-r2,yp-r2,xp+r2,yp+r2);
  
  }
  SelectObject(gc_graph,oldpen);
  DeleteObject(pen);
  
}

set_linestyle(ls)
     int ls;
{
  if(PSFlag)ps_linetype(ls);
  else set_line_style_x11(ls);
}


set_line_style_x11(ls)
     int ls;
{
  int width=0;
  if(ls==-2){  /*  Border  */
    set_color(0);
    set_width(2);
    set_dash(0);
    return;
  }
 width=0;
 if(ls==-1){
   set_color(0);
   set_dash(1);
   set_width(1);
   return;
 }
 
 /* color system  */
  if(ls>=0)
  {
  ls=ls%12;
  if(ls==0)set_color(0);
  else set_color(ls);
  set_width(0);
  set_dash(0);
  }
  

 
}

set_width(wid)
int wid;
{
    WinLineWid=wid;
}
set_dash(dash)
int dash;
{
 if(dash==0)WinDash=PS_SOLID;
 else WinDash=PS_DOT;
 
}      
set_color(col)
int col;
{
   WinColor=col;
}        


set_palette(dc)
HDC dc;
{
 int i;
 /* if(*i==1)return;
 *i=1; */
 SelectPalette(dc,hpal,FALSE);
 i=RealizePalette(dc);
 /* lprintf("pal=%d\n",i); */
} 

rect_x11(x,y,w,h)
     int x,y,w,h;
{
  RECT r;
  HBRUSH hb,hbold;
  r.left=x;
  r.top=y;
  r.bottom=y+h+1;
  r.right=x+w+1;
  /* lprintf(" %d: %d %d %d %d \n",WinColor,x,y,h,w); */
  hb=CreateSolidBrush(PALETTEINDEX(WinColor));
  if(hb==NULL)lprintf("no brush\n");
  hbold=SelectObject(gc_graph,hb);
    FillRect(gc_graph,&r,hb);
  SelectObject(gc_graph,hbold);
  DeleteObject(hb);
}

line_x11(xp1,yp1,xp2,yp2)
     int xp1,yp1,xp2,yp2;
{
 HPEN pen;
 HPEN oldpen;
 
 pen=CreatePen(WinDash,WinLineWid,PALETTEINDEX(WinColor));
 if(pen==NULL)lprintf("no pen created \n");
 oldpen=SelectObject(gc_graph,pen);
 MoveToEx(gc_graph,xp1,yp1,NULL);
 LineTo(gc_graph,xp2,yp2);
 SelectObject(gc_graph,oldpen);
 DeleteObject(pen);

}           

  


put_text_x11(x,y,str)
     int x,y;
     char *str;
{
  int sw=strlen(str)*DCURXs;
    if(WinFont==1)
        sw=strlen(str)*DCURX;
  SetBkMode(gc_graph,TRANSPARENT);
  if(WinFont==0)SelectObject(gc_graph,smallfont);
    else
        SelectObject(gc_graph,stdfont);
  switch(TextJustify){
  case 0: sw=0; break;
  case 1: sw=-sw/2; break;
  case 2: sw=-sw; break;
  }
  
  TextOut(gc_graph,x+sw,y+DCURYs/3,str,strlen(str));

}
  
fancy_put_text_x11(x,y,str,size,font)
     int x,y,size,font;
     char *str;
{
  
  HFONT hfont,oldf;

  SetBkMode(gc_graph,TRANSPARENT);
  switch(font){
  
  case 1: 
    hfont=CreateFont(12+3*size,6+3*size/2,0,0,FW_NORMAL,0,0,0,
    SYMBOL_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,FIXED_PITCH,"Symbol");
    oldf=SelectObject(gc_graph,hfont);
    TextOut(gc_graph,x,y,str,strlen(str));
    SelectObject(gc_graph,oldf);
    DeleteObject(hfont);
    break;
  default: 
     hfont=CreateFont(12+3*size,6+3*size/2,0,0,FW_NORMAL,0,0,0,
    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
    DEFAULT_QUALITY,FIXED_PITCH,"Times New Roman");
    oldf=SelectObject(gc_graph,hfont);
    TextOut(gc_graph,x,y,str,strlen(str));
    SelectObject(gc_graph,oldf);
    DeleteObject(hfont);
    break;
  }

}

scale_to_screen(x,y,i,j)  /* not really the screen!  */
     float x,y;
     int *i,*j;
{
  float dx=(DRight-DLeft)/(XMax-XMin);
  float dy=(DTop-DBottom)/(YMax-YMin);
  *i=(int)((x-XMin)*dx)+DLeft;
  *j=(int)((y-YMin)*dy)+DBottom;
}

scale_to_real_i(in,i,j,x,y)
 float *x,*y;
 int i,j,in;
 {
  int i1,j1;
  float x1,y1;
  float x2,y2;
  get_draw_area_i(in);
  i1=i-graph[in].x0;
  j1=j-graph[in].y0-graph[in].Height;
  x1=(float)i1;
  y1=(float)j1;
  
  
  x2=(graph[in].xhi-graph[in].xlo)*x1/((float)graph[in].Width)+graph[in].xlo;
  y2=(graph[in].yhi-graph[in].ylo)*y1/(-(float)graph[in].Height)+graph[in].ylo;
  *x=x2;
  *y=y2;
 }

scale_to_real(i,j,x,y) /* Not needed except for X */
 float *x,*y;
 int i,j;
 {
  int i1,j1;
  float x1,y1;
  get_draw_area();
  i1=i-DLeft;
  j1=j-DBottom;
  x1=(float)i1;
  y1=(float)j1;
  *x=(MyGraph->xhi-MyGraph->xlo)*x1/((float)(DRight-DLeft))+MyGraph->xlo;
  *y=(MyGraph->yhi-MyGraph->ylo)*y1/((float)(DTop-DBottom))+MyGraph->ylo;
  
 }



ClearWindow(HWND hwnd,HDC hdc)
{
    HBRUSH hbr=(HBRUSH)GetStockObject(WHITE_BRUSH);
    RECT rect;
    GetClientRect(hwnd,&rect);
    FillRect(hdc,&rect,hbr);
}   

        
init_all_graph()
{
 int i;
 
 for(i=0;i<MAXPOP;i++)
 init_graph(i);
 MyGraph=&graph[0];
 set_normal_scale();
  init_freeze();
}

init_graph(i)
int i;
{
 int j,k;
 if(AXES<=3)AXES=0;
 for(j=0;j<3;j++)
  for(k=0;k<3;k++)
        if(k==j)graph[i].rm[k][j]=1.0;
        else graph[i].rm[k][j]=0.0;
  graph[i].nvars=1;
  for(j=0;j<MAXPERPLOT;j++){
        graph[i].xv[j]=IXPLT;
        graph[i].yv[j]=IYPLT;
        graph[i].zv[j]=IZPLT;
        graph[i].line[j]=1;
        graph[i].color[j]=0;
        }
     
    sprintf(graph[i].xlabel,"");
    sprintf(graph[i].ylabel,"");
    sprintf(graph[i].zlabel,"");
    graph[i].Use=0;
    graph[i].Restore=1;
    graph[i].Nullrestore=0;
    graph[i].ZPlane=-1000.0;
    graph[i].ZView=1000.0;
    graph[i].PerspFlag=0;
    graph[i].ThreeDFlag=PLOT_3D;
    graph[i].TimeFlag=TIMPLOT;
    graph[i].ColorFlag=0;
    graph[i].ColorValue=1;
    
    graph[i].grtype=AXES;
    graph[i].color_scale=1.0;
    graph[i].min_scale=0.0;
    graph[i].xmax=x_3d[1];
    graph[i].ymax=y_3d[1];
    graph[i].zmax=z_3d[1];
    graph[i].xbar=.5*(x_3d[1]+x_3d[0]);
    graph[i].ybar=.5*(y_3d[1]+y_3d[0]);
    graph[i].zbar=.5*(z_3d[1]+z_3d[0]);
    graph[i].dx=2./(x_3d[1]-x_3d[0]);
    graph[i].dy=2./(y_3d[1]-y_3d[0]);
    graph[i].dz=2./(z_3d[1]-z_3d[0]);
    graph[i].xmin=x_3d[0];
    graph[i].ymin=y_3d[0];
    graph[i].zmin=z_3d[0];
     graph[i].xorg=0.0;
    graph[i].yorg=0.0;
    graph[i].yorg=0.0;
    graph[i].xorgflag=1;
    graph[i].yorgflag=1;
    graph[i].zorgflag=1;
    graph[i].Theta=45;
    graph[i].Phi=45;
    graph[i].xshft=0;
    graph[i].yshft=0;
    graph[i].zshft=0;
    graph[i].xlo=MY_XLO;
    graph[i].ylo=MY_YLO;
    graph[i].oldxlo=MY_XLO;
    graph[i].oldylo=MY_YLO;
    graph[i].xhi=MY_XHI;
    graph[i].yhi=MY_YHI;
    graph[i].oldxhi=MY_XHI;
    graph[i].oldyhi=MY_YHI;
    graph[i].legend_flag=0;
    graph[i].legend_x=0.0;
    graph[i].legend_y=0.0;
    MyGraph=&graph[i];
    make_rot(45.0,45.0);
    
  }



copy_graph(i,l)  /*  Graph[i]=Graph[l]  */
int i,l;
{
 int j,k;
 graph[i].Use=graph[l].Use;
 graph[i].Restore=graph[l].Restore;
 graph[i].Nullrestore=graph[l].Nullrestore;
 for(j=0;j<3;j++)
  for(k=0;k<3;k++)
        graph[i].rm[k][j]=graph[l].rm[k][j];
  graph[i].nvars=graph[l].nvars;
  for(j=0;j<MAXPERPLOT;j++){
        graph[i].xv[j]=graph[l].xv[j];
        graph[i].yv[j]=graph[l].yv[j];
        graph[i].zv[j]=graph[l].zv[j];
        graph[i].line[j]=graph[l].line[j];
        graph[i].color[j]=graph[l].color[j];
        }

    graph[i].ZPlane=graph[l].ZPlane;
    graph[i].ZView=graph[l].ZView;
    graph[i].PerspFlag=graph[l].PerspFlag;
    graph[i].ThreeDFlag=graph[l].ThreeDFlag;
    graph[i].TimeFlag=graph[l].TimeFlag;
    graph[i].ColorFlag=graph[l].ColorFlag;
    graph[i].ColorValue=graph[l].ColorValue;
    graph[i].grtype=graph[l].grtype;
    graph[i].color_scale=graph[l].color_scale;
    graph[i].min_scale=graph[l].min_scale;

    graph[i].xmax=graph[l].xmax;
    graph[i].xmin=graph[l].xmin;
    graph[i].ymax=graph[l].ymax;
    graph[i].ymin=graph[l].ymin;
    graph[i].zmax=graph[l].zmax;
    graph[i].zmin=graph[l].zmin;
    graph[i].xbar=graph[l].xbar;
    graph[i].dx  =graph[l].dx  ;
    graph[i].ybar=graph[l].ybar;
    graph[i].dy  =graph[l].dy  ;
    graph[i].zbar=graph[l].zbar;
    graph[i].dz  =graph[l].dz  ;

    graph[i].Theta=graph[l].Theta;
    graph[i].Phi=graph[l].Phi;
    graph[i].xshft=graph[l].xshft;
    graph[i].yshft=graph[l].yshft;
    graph[i].zshft=graph[l].zshft;
    graph[i].xlo=graph[l].xlo;
    graph[i].ylo=graph[l].ylo;
    graph[i].oldxlo=graph[l].oldxlo;
    graph[i].oldylo=graph[l].oldylo;
    graph[i].xhi=graph[l].xhi;
    graph[i].yhi=graph[l].yhi;
    graph[i].oldxhi=graph[l].oldxhi;
    graph[i].oldyhi=graph[l].oldyhi;
  }




make_rot(theta,phi)
double theta,phi;
{
 double ct=cos(DEGTORAD*theta),st=sin(DEGTORAD*theta);
 double sp=sin(DEGTORAD*phi),cp=cos(DEGTORAD*phi);
 MyGraph->Theta=theta;
 MyGraph->Phi=phi;
 MyGraph->rm[0][0]=ct;
 MyGraph->rm[0][1]=st;
 MyGraph->rm[0][2]=0.0;
 MyGraph->rm[1][0]=-cp*st;
 MyGraph->rm[1][1]=cp*ct;
 MyGraph->rm[1][2]=sp;
 MyGraph->rm[2][0]=st*sp;
 MyGraph->rm[2][1]=-sp*ct;
 MyGraph->rm[2][2]=cp;
}

scale3d(x,y,z,xp,yp,zp)
float x,y,z,*xp,*yp,*zp;
{
 *xp=(x-MyGraph->xbar)*MyGraph->dx;
 *yp=(y-MyGraph->ybar)*MyGraph->dy;
 *zp=(z-MyGraph->zbar)*MyGraph->dz;
}


threedproj(x2p,y2p,z2p,xp,yp)
float x2p,y2p,z2p,*xp,*yp;
{
  float x1p,y1p,z1p,s;
 /*  if(fabs(x2p)>1||fabs(y2p)>1||fabs(z2p)>1)return(0); */
 rot_3dvec(x2p,y2p,z2p,&x1p,&y1p,&z1p);

 if(MyGraph->PerspFlag==0){
 *xp=x1p;
 *yp=y1p;
  return(1);
 }
  if((z1p>=(float)(MyGraph->ZView))||(z1p<(float)(MyGraph->ZPlane)))return(0);
  s=(float)(MyGraph->ZView-MyGraph->ZPlane)/((float)(MyGraph->ZView)-z1p);
  x1p=s*x1p;
  y1p=s*y1p;
  *xp=x1p;
 *yp=y1p;
  return(1);
}


text3d(x,y,z,s)    
float x,y,z;
char *s;
{
 float xp,yp;
if(threedproj(x,y,z,&xp,&yp)) text_abs(xp,yp,s);
}




text_3d(x,y,z,s)    
float x,y,z;
char *s;
{
 float xp,yp;
if(threed_proj(x,y,z,&xp,&yp)) text_abs(xp,yp,s);
}


threed_proj(x,y,z,xp,yp)
float x,y,z,*xp,*yp;
{
  float x1p,y1p,z1p,s;
 float x2p,y2p,z2p;
 scale3d(x,y,z,&x2p,&y2p,&z2p);  /* scale to a cube  */
 /* if(fabs(x2p)>1||fabs(y2p)>1||fabs(z2p)>1)return(0); */
 rot_3dvec(x2p,y2p,z2p,&x1p,&y1p,&z1p);

 if(MyGraph->PerspFlag==0){
 *xp=x1p;
 *yp=y1p;
  return(1);
 }
  if((z1p>=(float)(MyGraph->ZView))||(z1p<(float)(MyGraph->ZPlane)))return(0);
  s=(float)(MyGraph->ZView-MyGraph->ZPlane)/((float)(MyGraph->ZView)-z1p);
  x1p=s*x1p;
  y1p=s*y1p;
  *xp=x1p;
 *yp=y1p;
  return(1);
}

point_3d( x, y, z)
float x,y,z;
{
 float xp,yp;
 if(threed_proj(x,y,z,&xp,&yp))point_abs(xp,yp);
}

line3dn(xs1,ys1,zs1,xsp1,ysp1,zsp1)  /* unscaled version  unclipped   */
float xs1,ys1,zs1,xsp1,ysp1,zsp1;
{
 float xs,ys,zs;
 float xsp,ysp,zsp;
 rot_3dvec(xs1,ys1,zs1,&xs,&ys,&zs);   /* rotate the line */
 rot_3dvec(xsp1,ysp1,zsp1,&xsp,&ysp,&zsp);
 if(MyGraph->PerspFlag)pers_line(xs,ys,zs,xsp,ysp,zsp);
 else
     line_nabs(xs,ys,xsp,ysp);
 }




line3d(x01,y01,z01,x02,y02,z02)  /* unscaled version     */
float x01,x02,y01,y02,z01,z02;
{
 float xs,ys,zs;
 float xs1,ys1,zs1;
 float xsp,ysp,zsp;
 float xsp1,ysp1,zsp1;
if(!clip3d(x01,y01,z01,x02,y02,z02,&xs1,&ys1,&zs1,&xsp1,&ysp1,&zsp1))return;
 rot_3dvec(xs1,ys1,zs1,&xs,&ys,&zs);   /* rotate the line */
 rot_3dvec(xsp1,ysp1,zsp1,&xsp,&ysp,&zsp);
 if(MyGraph->PerspFlag)pers_line(xs,ys,zs,xsp,ysp,zsp);
 else
     line_abs(xs,ys,xsp,ysp);
 }




line_3d(x,y,z,xp,yp,zp)
float x,y,z;
float xp,yp,zp;
{
 float xs,ys,zs;
float xs1,ys1,zs1;
 float xsp,ysp,zsp;
 float xsp1,ysp1,zsp1;
 float x01,x02,y01,y02,z01,z02;
 scale3d(x,y,z,&x01,&y01,&z01);          /* scale to a cube  */
 scale3d(xp,yp,zp,&x02,&y02,&z02);
 if(!clip3d(x01,y01,z01,x02,y02,z02,&xs1,&ys1,&zs1,&xsp1,&ysp1,&zsp1))return;
 rot_3dvec(xs1,ys1,zs1,&xs,&ys,&zs);   /* rotate the line */
 rot_3dvec(xsp1,ysp1,zsp1,&xsp,&ysp,&zsp);
 if(MyGraph->PerspFlag)pers_line(xs,ys,zs,xsp,ysp,zsp);
 else
     line_abs(xs,ys,xsp,ysp);
 }

 pers_line(x,y,z,xp,yp,zp)
 float x,y,z,xp,yp,zp;

 {
 float Zv=(float)MyGraph->ZView,Zp=(float)MyGraph->ZPlane;
 float d=Zv-Zp,s;
 float eps=.005*d;

 if(((zp>=Zv)&&(z>=Zv))||((zp<Zp)&&(z<Zp)))return;
 if(zp>Zv)
 {
  s=(Zv-eps-z)/(zp-z);
  zp=Zv-eps;
  yp=y+s*(yp-y);
  xp=x+s*(xp-x);
 }
 if(z>Zv)
 {
  s=(Zv-eps-zp)/(z-zp);
  z=Zv-eps;
  y=yp+s*(y-yp);
  x=xp+s*(x-xp);
 }
 if(zp<Zp)
 {
  s=(Zp-z)/(zp-z);
  zp=Zp;
  yp=y+s*(yp-y);
  xp=x+s*(xp-x);
 }
 if(z<Zp)
 {
  s=(Zp-zp)/(z-zp);
  z=Zp;
  y=yp+s*(y-yp);
  x=xp+s*(x-xp);
 }
 s=d/(Zv-zp);
 xp=xp*s;
 yp=yp*s;
 s=d/(Zv-z);
 x=s*x;
 y=s*y;
 line_abs(x,y,xp,yp);
}





rot_3dvec( x,y, z,
            xp,yp,zp)
float x,y,z,*xp,*yp,*zp;
{
 int i,j;
 double vt[3],vnew[3];
 vt[0]=x;
 vt[1]=y;
 vt[2]=z;

 for(i=0;i<3;i++){
        vnew[i]=0.0;
        for(j=0;j<3;j++)vnew[i]=vnew[i]+MyGraph->rm[i][j]*vt[j];
        }
        *xp=vnew[0];
        *yp=vnew[1];
        *zp=vnew[2];

}






scale_em(float x1,float y1,int *ix,int *iy)
{
float x_left=XMin;
  float x_right=XMax;
  float y_top=YMax;
  float y_bottom=YMin;
   if((x1>x_right)||(x1<x_left)||(y1>y_top)||(y1<y_bottom))return 0; 
  scale_to_screen(x1,y1,ix,iy);
  return 1;
} 
point_abs(x1, y1)
float x1,y1;
{
  int xp,yp;
 
  float x_left=XMin;
  float x_right=XMax;
  float y_top=YMax;
  float y_bottom=YMin;
   if((x1>x_right)||(x1<x_left)||(y1>y_top)||(y1<y_bottom))return; 
  scale_to_screen(x1,y1,&xp,&yp);
  point(xp,yp);
}

line_nabs(x1_out, y1_out, x2_out, y2_out)
float x1_out,y1_out,x2_out,y2_out;
{
  
  
  int xp1,yp1,xp2,yp2;

    scale_to_screen(x1_out,y1_out,&xp1,&yp1);
    scale_to_screen(x2_out,y2_out,&xp2,&yp2);
    line(xp1,yp1,xp2,yp2);
  }

frect_abs(x1,y1,w,h)
     float x1,y1,w,h;
{
 int i1,i2,j1,j2;
 int ih,iw;
 
 float x2=x1+w;
 float y2=y1+h;
/* lprintf(" %g %g %g %g  \n",x1,y1,w,h); */
 scale_to_screen(x1,y1,&i1,&j1);
 scale_to_screen(x2,y2,&i2,&j2);
 /* lprintf(" %g %g %d %d %d %d  \n",x2,y2,i1,j1,i2,j2); */
 iw=abs(i2-i1);
 ih=abs(j2-j1);
 frect(i1,j1,iw,ih);
}


line_abs(x1, y1, x2, y2)
float x1,x2,y1,y2;
{
  float x1_out,y1_out,x2_out,y2_out;
  float x1pl,y1pl,x2pl,y2pl;
  float xfp1,xfp2,yfp1,yfp2;
  float tolr=.1,err;
  int xp1,yp1,xp2,yp2;
  if(clip(x1,x2,y1,y2,&x1_out,&y1_out,&x2_out,&y2_out)){
    scale_to_screen(x1_out,y1_out,&xp1,&yp1);
    scale_to_screen(x2_out,y2_out,&xp2,&yp2);
    line(xp1,yp1,xp2,yp2);
  }
}

text_abs(x,y,text)
float x,y;
char *text;
{
 int xp,yp;
 scale_to_screen(x,y,&xp,&yp);
 put_text(xp,yp,text);
}

fancy_text_abs(x,y,text,size,font)
     float x,y;
     int size,font;
     char *text;
{
  int xp,yp;
  scale_to_screen(x,y,&xp,&yp);
  if(PSFlag)fancy_ps_text(xp,yp,text,size,font);
  else fancy_put_text_x11(xp,yp,text,size,font);
}





clip3d( x1, y1, z1, x2, y2, z2,
          x1p, y1p, z1p, x2p, y2p, z2p)
float x1, y1, z1, x2, y2, z2,
         *x1p, *y1p,*z1p,*x2p, *y2p, *z2p;


{
  int istack,ix1=0,ix2=0,iy1=0,iy2=0,iz1=0,iz2=0,
        isum,iflag=0;
  float wh,wv,wo,xhat,yhat,zhat,del;

  istack=1;
  *x1p=x1;
  *y1p=y1;
  *z1p=z1;
  *x2p=x2;
  *y2p=y2;
  *z2p=z2;
  if(x1<-1.)ix1=-1;
  if(x1>1.)ix1=1;
  if(x2<-1.)ix2=-1;
  if(x2>1.)ix2=1;
  if(y1<-1.)iy1=-1;
  if(y1>1.)iy1=1;
  if(y2<-1.)iy2=-1;
  if(y2>1.)iy2=1;
   if(z1<-1.)iz1=-1;
  if(z1>1.)iz1=1;
  if(z2<-1.)iz2=-1;
  if(z2>1.)iz2=1;

  if((abs(ix1)+abs(ix2)+abs(iy1)+abs(iy2)+abs(iz1)+abs(iz2))==0)return(1);

/*  Both are outside the cube  */

if((ix1==ix2)&&(ix1!=0))return(0);
if((iy1==iy2)&&(iy1!=0))return(0);
 if((iz1==iz2)&&(iz1!=0))return(0);

if(ix1==0)goto C2;
wv=-1;
if(ix1>0)wv=1;
*x1p=wv;
del=(wv-x2)/(x1-x2);
yhat=(y1-y2)*del+y2;
zhat=(z1-z2)*del+z2;
if(fabs(zhat)<=EP1&&fabs(yhat)<=EP1){
*y1p=yhat;
*z1p=zhat;
iflag=1;
goto C3;
 }
istack=0;
C2:
if(iy1==0)goto C22;
  wh=-1;
  if(iy1>0)wh=1;
  *y1p=wh;
 del=(wh-y2)/(y1-y2);
 xhat=(x1-x2)*del+x2;
 zhat=(z1-z2)*del+z2;
 if(fabs(zhat)<=EP1&&fabs(xhat)<=EP1){
 *x1p=xhat;
 *z1p=zhat;
 iflag=1;
 goto C3;
}
istack=0;
C22:
if(iz1==0)goto C3;
wo=-1;
if(iz1>0)wo=1;
*z1p=wo;

del=(wo-z2)/(z1-z2);
xhat=del*(x1-x2)+x2;
yhat=del*(y1-y2)+y2;

if(fabs(xhat)<=EP1&&fabs(yhat)<=EP1){
*x1p=xhat;
*y1p=yhat;
iflag=1;}
else istack=0;
C3:
istack+=iflag;
if((ix2==0)||(istack==0))goto C44;
wv=-1;
if(ix2>0)wv=1;
*x2p=wv;
del=(wv-x1)/(x2-x1);
yhat=(y2-y1)*del+y1;
zhat=(z2-z1)*del+z1;
if(fabs(yhat)<=EP1&&fabs(zhat)<=EP1){
*y2p=yhat;
*z2p=zhat;
return(1);
 }
C44:
 if(iy2==0||istack==0)goto C4;
wh=-1;
if(iy2>0)wh=1;
*y2p=wh;
del=(wh-y1)/(y2-y1);
xhat=(x2-x1)*del+x1;
zhat=(z2-z1)*del+z1;
if(fabs(xhat)<=EP1&&fabs(zhat)<=EP1){
 *z2p=zhat;
 *x2p=xhat;
 return(1);
 }
C4:
 if(iz2==0||istack==0)return(iflag);
 wo=-1;
 if(iz2>0)wo=1;
 *z2p=wo;
 del=(wo-z1)/(z2-z1);
 xhat=(x2-x1)*del+x1;
 yhat=(y2-y1)*del+y1;
 if(fabs(xhat)<=EP1&&fabs(yhat)<=EP1){
 *x2p=xhat;
 *y2p=yhat;
 return(1);
 }
 return(iflag);
}


clip(x1,x2,y1, y2,
x1_out,y1_out,x2_out,y2_out)
float x1,y1,x2,y2,*x1_out,*y1_out,*x2_out,*y2_out;

/************************************************************ *
*  Clipping algorithm                                         *
*   on input,                                                 *
*           (x1,y1) and (x2,y2) are endpoints for line        *
*           (x_left,y_bottom) and (x_right,y_top) is window                     *
*   output:                                                   *
*           value is 1 for drawing, 0 for no drawing          *
*           (x1_out,y1_out),(x2_out,y2_out) are endpoints     *
*            of clipped line                                  *
***************************************************************/

{
   int istack,ix1,ix2,iy1,iy2,isum,iflag;
   float  wh,xhat,yhat,wv;
   float x_left=XMin;
   float x_right=XMax;
   float y_top=YMax;
   float y_bottom=YMin;
   istack=1;
   ix1=ix2=iy1=iy2=iflag=0;
   *y1_out=y1;
   *y2_out=y2;
   *x1_out=x1;
   *x2_out=x2;
   if(x1<x_left)ix1=-1;
   if(x1>x_right)ix1=1;
   if(x2<x_left)ix2=-1;
   if(x2>x_right)ix2=1;
   if(y2<y_bottom)iy2=-1;
   if(y2>y_top)iy2=1;
   if(y1<y_bottom)iy1=-1;
   if(y1>y_top)iy1=1;
   isum=abs(ix1)+abs(ix2)+abs(iy1)+abs(iy2);
   if(isum==0)return(1); /* both inside window so plottem' */

   if(((ix1==ix2)&&(ix1!=0))||((iy1==iy2)&&(iy1!=0)))return(0); 
   if(ix1==0) goto C2;
   wv=x_left;
   if(ix1>0) wv=x_right;
   *x1_out=wv;
   yhat=(y1-y2)*(wv-x2)/(x1-x2)+y2;
   if((yhat<=y_top)&&(yhat>=y_bottom)) {
     *y1_out=yhat;
     iflag=1;
   goto C3; }
   istack=0;
C2:
   if(iy1==0) goto C3;
   wh=y_bottom;
   if(iy1>0)wh=y_top;
   *y1_out=wh;
   xhat=(x1-x2)*(wh-y2)/(y1-y2)+x2;
   if((xhat<=x_right)&&(xhat>=x_left)) {
     *x1_out=xhat;
     iflag=1; }
   else istack=0;
C3:
   istack+=iflag;
   if((ix2==0)||(istack==0)) goto C4;
   wv=x_left;
   if(ix2>0) wv=x_right;
   *x2_out=wv;
   yhat=(y2-y1)*(wv-x1)/(x2-x1)+y1;
   if((yhat<=y_top)&&(yhat>=y_bottom)) {
   *y2_out=yhat;
   return(1);
   }
C4:
  if((iy2==0)||(istack==0))return(iflag);
  wh=y_bottom;
  if(iy2>0) wh=y_top;
  *y2_out=wh;
  xhat=(x2-x1)*(wh-y1)/(y2-y1)+x1;
  if((xhat<=x_right)&&(xhat>=x_left)) {
  *x2_out=xhat;
  return(1);
  }
  return(iflag);
}



eq_symb(x,type)
double *x;
 int type;
{
  float dx=6.0*(float)(MyGraph->xhi-MyGraph->xlo)*SYMSIZE;
  float dy=6.0*(float)(MyGraph->yhi-MyGraph->ylo)*SYMSIZE;
 int ix=MyGraph->xv[0]-1,iy=MyGraph->yv[0]-1,iz=MyGraph->zv[0]-1;
  if(MyGraph->TimeFlag)return;
  set_color(0);
  if(MyGraph->ThreeDFlag)
  {
   dx=6.0*SYMSIZE/MyGraph->dx;
   dy=6.0*SYMSIZE/MyGraph->dy;
   line_3d((float)x[ix]+dx,(float)x[iy],(float)x[iz],
           (float)x[ix]-dx,(float)x[iy],(float)x[iz]);
   line_3d((float)x[ix],(float)x[iy]+dy,(float)x[iz],
           (float)x[ix],(float)x[iy]-dy,(float)x[iz]);
  return;
  }
  draw_symbol((float)x[ix],(float)x[iy],SYMSIZE,type);
  point_abs((float)x[ix],(float)x[iy]);
}

draw_symbol( x, y, size,my_symb)
float x,y,size;
int my_symb;
{
 float dx=(float)(MyGraph->xhi-MyGraph->xlo)*size;
 float dy=(float)(MyGraph->yhi-MyGraph->ylo)*size;
 static int sym_dir[4][48] = {
 /*          box              */
    0, -6, -6,1, 12,  0,1,  0, 12,1,-12,  0,
    1,  0,-12,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,

 /*          triangle         */
    0, -6, -6,1, 12,  0,1, -6, 12,1, -6,-12,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,

 /*          cross            */
    0, -6,  0,1, 12,  0,0, -6, -6,1,  0, 12,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,
    3,  0,  0,3,  0,  0,3,  0,  0,3,  0,  0,

 /*          circle           */
    0,  6,  0,1, -1,  3,1, -2,  2,1, -3,  1,
    1, -3, -1,1, -2, -2,1, -1, -3,1,  1, -3,
    1,  2, -2,1,  3, -1,1,  3,  1,1,  2,  2,
    1,  1,  3,3,  0,  0,3,  0,  0,3,  0,  0,
    };
  int ind=0,pen=0;
  float x1=x,y1=y,x2,y2;
  float a1,b1,c1,d1;
   while(pen!=3)
   {
    x2=sym_dir[my_symb][3*ind+1]*dx+x1;
    y2=sym_dir[my_symb][3*ind+2]*dy+y1;
    pen=sym_dir[my_symb][3*ind];
    if(pen!=0) line_abs(x1,y1,x2,y2);
    x1=x2;
    y1=y2;
    ind++;
   }

}







/* freeze stuff */

draw_freeze(w)
Window w;
{
  int i,j,type=MyGraph->grtype;
  float oldxpl,oldypl,oldzpl=0.0,xpl,ypl,zpl=0.0;
  float *xv,*yv,*zv;
  /* for(i=0;i<MAXNCLINE;i++)
    draw_frozen_cline(i,w); */
  for(i=0;i<MAXFRZ;i++){
    if(frz[i].use==1&&frz[i].w==w&&frz[i].type==type){
      set_linestyle(frz[i].color);
      xv=frz[i].xv;
      yv=frz[i].yv;
      zv=frz[i].zv;
      oldxpl=xv[0];
      oldypl=yv[0];
      if(type>0)
        oldzpl=zv[0];
      for(j=0;j<frz[i].len;j++){
        xpl=xv[j];
        ypl=yv[j];
        if(type>0)
          zpl=zv[j];
        if(type==0)
          line_abs(oldxpl,oldypl,xpl,ypl);
        else
          line_3d(oldxpl,oldypl,oldzpl,xpl,ypl,zpl);
        oldxpl=xpl;
        oldypl=ypl;
        if(type>0)
          oldzpl=zpl;
      }
    }
  }
  draw_freeze_key();
/*  draw_bd(w); */
} 




delete_frz_crv(i)
     int i;
{
  if(frz[i].use==0)return;
  frz[i].use=0;
  frz[i].color=0;
  frz[i].key[0]=0;
  frz[i].w=(HWND)0;
  free(frz[i].xv);
  free(frz[i].yv);
  if(frz[i].type>0)
    free(frz[i].zv);
}
kill_frz()
{
  int i;
  for(i=0;i<MAXFRZ;i++){
    if(frz[i].use==1&&frz[i].w==draw_win)
      delete_frz_crv(i);
  }
}

create_crv(ind,color,key)
int ind,color;
char *key;
{
  int i,flag=0,type,j;
  int ix,iy,iz;

  for(i=0;i<MAXFRZ;i++){
    if(frz[i].use==0){
      ix=MyGraph->xv[ind];
      iy=MyGraph->yv[ind];
      iz=MyGraph->zv[ind];
      if(my_browser.maxrow<=2){
        err_msg("No Curve to freeze");
        return(-1);
      }
      frz[i].xv=(float *) malloc(sizeof(float)*my_browser.maxrow);
      frz[i].yv=(float *) malloc(sizeof(float)*my_browser.maxrow);
      if((type=MyGraph->grtype)>0)
        frz[i].zv=(float *)malloc(sizeof(float)*my_browser.maxrow);
      if(type>0&&frz[i].zv==NULL|| type==0&&frz[i].yv==NULL){
        err_msg("Cant allocate storage for curve");
        return(-1);
      }
      frz[i].use=1;
      frz[i].len=my_browser.maxrow;
      for(j=0;j<my_browser.maxrow;j++){
        frz[i].xv[j]=my_browser.data[ix][j];
        frz[i].yv[j]=my_browser.data[iy][j];
        if(type>0)
          frz[i].zv[j]=my_browser.data[iz][j];
      }
      frz[i].type=type;
      frz[i].w=draw_win;
      frz[i].color=color;
      strcpy(frz[i].key,key);
      return(i);
          }
  }
    err_msg("All curves used");
    return (-1);
   
}       

auto_freeze_it()
{
  if(AutoFreezeFlag==0)return;
  create_crv(0,0,"");
}        
delete_frz(HWND w)
{
    int i;
    for(i=0;i<MAXFRZ;i++){
        if(frz[i].use==1&&frz[i].w==w)
          delete_frz_crv(i);
    }
}    
init_freeze()
{
    int i;
    for(i=0;i<MAXFRZ;i++){
        sprintf(frz[i].name,"crv_%d",i);
        strcpy(frz[i].key,"");
        frz[i].color=0;
        frz[i].use=0;
    }
}   



set_key(float xp,float yp)
{
 
  MyGraph->legend_x=xp;
  MyGraph->legend_y=yp;
  MyGraph->legend_flag=1;
  draw_freeze_key();
}

draw_freeze_key()
{
  int ix,iy;
  int i,y0;
  int ix2;
  int dy=2*HChar;
  if(MyGraph->legend_flag==0)return;
  if(PSFlag)dy=-dy;
  scale_to_screen((float)MyGraph->legend_x,(float)MyGraph->legend_y,&ix,&iy);
  ix2=ix+4*HChar;
  y0=iy;
  for(i=0;i<MAXFRZ;i++){
    if(frz[i].use==1&&frz[i].w==draw_win&&strlen(frz[i].key)>0){
      set_linestyle(frz[i].color);
      line(ix,y0,ix2,y0);
      set_linestyle(0);
      put_text(ix2+HChar,y0,frz[i].key);
      y0+=dy;
    }
  }
}








        
   




