#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <stdio.h>
#include <math.h>

#include "xpplim.h"

typedef struct {
               HWND w;
                int dataflag;
                int col0,row0,ncol,nrow;
                int maxrow,maxcol;
                float **data;
                int istart,iend;
                } BROWSER;

extern BROWSER my_browser;
double evaluate();
double drand48();



extern char uvar_names[MAXODE][12];


extern int NCON,NSYM,NCON_START,NSYM_START;

extern float **storage;
extern int storind;
int hist_len,four_len;
float *my_hist[MAXODE+1];
float *my_four[MAXODE+1];
int HIST_HERE,FOUR_HERE;
extern int NEQ,NODE,NMarkov,FIX_VAR;



typedef struct {
    int nmodes,col;
} FOURIER_PAR;

FOURIER_PAR four_par;

typedef struct {
    int bins,col;
    char cond[256];
    double zlo,zhi;
} HISTOGRAM_PAR;

HISTOGRAM_PAR hist_par;
init_hist()
{
    FOUR_HERE=0;
    HIST_HERE=0;
    hist_par.col=1;
    hist_par.bins=50;
    hist_par.cond[0]=0;
    hist_par.zlo=0.0;
    hist_par.zhi=1.0;
    four_par.col=1;
    four_par.nmodes=10;
}
four_back()
{
 if(FOUR_HERE){
   my_browser.data=my_four;
   my_browser.col0=0;
   refresh_browser(four_len);
 }
}

hist_back()
{
 if(HIST_HERE){
   my_browser.data=my_hist;
   my_browser.col0=0;
   refresh_browser(hist_len);
 }
}

new_four(nmodes,col)
     int nmodes,col;
{
  int i;
  int length=nmodes+1;
  if(FOUR_HERE){
   data_back();
   free(my_four[0]);
   free(my_four[1]);
   free(my_four[2]);
   FOUR_HERE=0;
 }
  four_len=length;
  my_four[0]=(float *)malloc(sizeof(float)*length);
  my_four[1]=(float *)malloc(sizeof(float)*length);
  my_four[2]=(float *)malloc(sizeof(float)*length);
  if(my_four[2]==NULL){
   free(my_four[1]);
   free(my_four[2]);
   err_msg("Cant allocate enough memory...");
   return;
 }
 FOUR_HERE=1;
 for(i=3;i<=NEQ;i++)my_four[i]=storage[i];
 for(i=0;i<length;i++)my_four[0][i]=i;
 sft(my_browser.data[col],my_four[1],my_four[2],length,storind);
 four_back();
  ping();
}

  
new_hist(nbins,zlo,zhi,col,condition)
     int nbins;
     int col;
     double zlo,zhi;
     char *condition;
     
{
  int i,j,n=2,index;
  int command[256];
  int cond=0,flag=1;
  double z;
  double dz=(zhi-zlo)/(double)nbins;
  int length=nbins+1;
  int count=0;
  
  
  if(HIST_HERE){
    data_back();
    free(my_hist[0]);
    free(my_hist[1]);
    HIST_HERE=0;
  }
  hist_len=length;
  my_hist[0]=(float *)malloc(sizeof(float)*length);
  my_hist[1]=(float *)malloc(sizeof(float)*length);
  if(my_hist[1]==NULL){
    free(my_hist[0]);
    err_msg("Cannot allocate enough...");
    return;
  }
  HIST_HERE=1;
  for(i=2;i<=NEQ;i++)my_hist[i]=storage[i];
  for(i=0;i<length;i++){
    my_hist[0][i]=(float)(zlo+dz*i);
    my_hist[1][i]=0.0;
  }
  if(strlen(condition)==0)cond=0;
  else
    {
      if(add_expr(condition,command,&i)){
        err_msg("Bad condition. Ignoring...");
        
      }
      else {
        cond=1;
      }
    }
  /* printf(" cond=%d \n condition=%s \n,node=%d\n", 
         cond,condition,NODE);  */
  for(i=0;i<storind;i++)
    {
      flag=1;
      if(cond){
        for(j=0;j<NODE+1;j++)set_ivar(j,(double)storage[j][i]);
        for(j=0;j<NMarkov;j++)
          set_ivar(j+NODE+1+FIX_VAR,(double)storage[j+NODE+1][i]);
        z=evaluate(command);
        if(fabs(z)>0.0)flag=1;
        else flag=0;
      }
      z=(storage[col][i]-zlo)/dz;
      index=(int)z;
      if(index>=0&&index<length&&flag==1){
        my_hist[1][index]+=1.0;
        count++;
      }
    }
  NCON=NCON_START;
  NSYM=NSYM_START;
  hist_back();
  ping();
}


column_mean(int col)
{
 int i;
 char bob[100];
 double sum,sum2,ss;
 double mean,sdev;
 if(storind<=1){
   err_msg("Need at least 2 data points!");
   return;
 }

 sum=0.0;
 sum2=0.0;
 for(i=0;i<storind;i++){
   ss=storage[col][i];
   sum+=ss;
   sum2+=(ss*ss);
 }
 mean=sum/(double)storind;
 sdev=sqrt(sum2/(double)storind-mean*mean);
 sprintf(bob,"Mean=%g Std. Dev. = %g ",mean,sdev);
 err_msg(bob);
}



sft(data,ct,st,nmodes,grid)
int grid,nmodes;
float *data,*ct,*st;
{
 int i,j;
 double sums,sumc;
 double tpi=6.28318530717959;
 double dx,xi,x;
 dx=tpi/(grid);
 for(j=0;j<nmodes;j++){
   sums=0.0;
   sumc=0.0;
   xi=j*dx;
   for(i=0;i<grid;i++){
    x=i*xi;
     sumc+=(cos(x)*data[i]);
     sums+=(sin(x)*data[i]);
   }
   if(j==0){
   ct[j]=sumc/(float)grid;
   st[j]=sums/(float)grid;
 }
   else{
     ct[j]=2.*sumc/(float)grid;
   st[j]=2.*sums/(float)grid;
   }
 }
}














