#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#include <math.h>
#include "structs.h"
double atof();
#define IDPERIOD_T 100
#define IDLIST_T 101
#define IDOK_T 104
#define IDALL_T 102
#define IDNONE_T 103
#define IDCANCEL_T 106

#define PBOXFONT smallfont
#define PBCX DCURXs
#define PBCY DCURYy

#define PARAM_ID 10000
#define DELAY_ID 11000
#define IC_ID    12000
#define BC_ID    13000

#define P_OK 10000
#define P_CAN 10001
#define P_DEF 10002
#define P_GO 10003


#define D_OK 11000
#define D_CAN 11001
#define D_DEF 11002
#define D_GO 11003

#define I_OK 12000
#define I_CAN 12001
#define I_DEF 12002
#define I_GO 12003

#define B_OK 13000
#define B_CAN 13001
#define B_DEF 13002
#define B_GO 13003 



#define PARAMBOX 1
#define ICBOX 2
#define DELAYBOX 3
#define BCBOX 4
BOOL CALLBACK TorusDialogFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK ManicDialogFunc(HWND,UINT,WPARAM,LPARAM);
extern int itor[],TORUS;
extern double TOR_PERIOD;
double get_val();
extern HFONT smallfont,helv8font;
extern int DCURX8,DCURY8;
extern int DCURXs,DCURYs;
extern HINSTANCE hInst;
extern int NUPAR,NODE,NEQ,NMarkov;
extern char upar_names[200][11],uvar_names[MAXODE][12];
extern char delay_string[MAXODE][80];
extern double default_val[200];
extern double last_ic[MAXODE];
extern BC_STRUCT my_bc[MAXODE];
extern int NDELAYS;

HWND SliderWindow;
HWND SliderDismiss,SliderAdd,SliderGo;
int SliderExists=0;

SLIDER pslide[MAXSLIDER];
BoxList ICBox;
BoxList ParamBox;
BoxList DelayBox;
BoxList BCBox;



struct {
        char **value,**name;
        int ok,n;
} manset_struct;
init_sliders()
{
    int i;
    for(i=0;i<MAXSLIDER;i++){
        pslide[i].used=0;
        strcpy(pslide[i].name,uvar_names[0]);
        pslide[i].steps=100;
        pslide[i].index=0;
        pslide[i].lo=-1.0;
        pslide[i].hi=1.0;
    }
}    
        

box_buttons(wparam )
WPARAM wparam;
{
 
 switch(LOWORD(wparam)){
 case P_OK:
    set_new_params();
    return 1;
 case P_CAN:
     redraw_params();
    return 1;
 case P_DEF:
     default_params();
    return 1;
 case P_GO:
    set_new_params();
    test_run();
    return 1;
    
case D_OK:
    set_new_delays();
    return 1;
 case D_CAN:
    redraw_delays();
    return 1;
 case D_DEF:
    return 1;
 case D_GO:
    set_new_delays();
    test_run();
    return 1;
    
    case I_OK:
    set_new_ics();
     return 1;

 case I_CAN:
    redraw_ics();
    return 1;
 case I_DEF:
    return 1;
 case I_GO:
      set_new_ics();
      test_run();
    return 1;

case B_OK:
    return 1;
 case B_CAN:
    return 1;
 case B_DEF:
    return 1;
 case B_GO:
    return 1;
 
 
 }
 return 0;
} 
 
set_slide_par(i0,pos)
 int i0,pos;
{

}

get_par_slide_info(i0)
int i0;
{
  
}    


set_new_params()
{
 int i;
 char bob[256];
 double z;
 for(i=0;i<NUPAR;i++){
 GetWindowText(ParamBox.wval[i],bob,255);
 z=atof(bob);
 set_val(upar_names[i],z);
 }
 redraw_params();
}
default_params()
{
 int i;
for(i=0;i<NUPAR;i++)
set_val(upar_names[i],default_val[i]);
redraw_params();
}
 
redraw_params()
{
int i;
 double z;
 char bob[256];
 evaluate_derived();
 if(ParamBox.use) for(i=0;i<NUPAR;i++){
   get_val(upar_names[i],&z);

               sprintf(bob,"%.16g",z);
               strcpy(ParamBox.value[i],bob);  
               SetWindowText(ParamBox.wval[i],ParamBox.value[i]);
 }
 reset_sliders();
}

reset_sliders()
{
  int i,k;
  double lo,hi,z,f;
  int pos;
  char bob[100];
  if(SliderExists==0)return;
   for(i=0;i<MAXSLIDER;i++){
       if(pslide[i].used==1){
           if(pslide[i].index<NEQ){
               z=last_ic[pslide[i].index];
               
           }
           else {
                get_val(pslide[i].name,&z);
           }
           lo=pslide[i].lo;
           hi=pslide[i].hi;
           f=pslide[i].steps*(z-lo)/(hi-lo);
           pos=(int)f;
           if(pos<0)pos=0;
           if(pos>pslide[i].steps)pos=pslide[i].steps;
            sprintf(bob,"%s=%g",pslide[i].name,z);
       }
   }       
             

}
set_new_delays()
{
   int i;
 if(DelayBox.use)for(i=0;i<NODE;i++){
    GetWindowText(DelayBox.wval[i],DelayBox.value[i],79); 
    strcpy(delay_string[i],DelayBox.value[i]);
    
    }
 
} 
redraw_delays()
{
 int i;
 if(DelayBox.use)for(i=0;i<NODE;i++){
    strcpy(DelayBox.value[i],delay_string[i]);
    SetWindowText(DelayBox.wval[i],DelayBox.value[i]);
    }
 
 
}

set_new_ics()
{
int i;
 char bob[256];
 double z;
 for(i=0;i<NODE+NMarkov;i++){
 GetWindowText(ICBox.wval[i],bob,255);
 z=atof(bob);
 last_ic[i]=z;
 }
 redraw_ics();

}
redraw_ics()
{
 int i;
 char bob[256];
 for(i=0;i<NODE+NMarkov;i++){
 sprintf(bob,"%.16g",last_ic[i]);
    strcpy(ICBox.value[i],bob);  
               SetWindowText(ICBox.wval[i],ICBox.value[i]);
 }
}
        
redraw_bcs()
{

 int i;
 for(i=0;i<NODE;i++){
  strcpy(BCBox.value[i],my_bc[i].string);
               SetWindowText(BCBox.wval[i],BCBox.value[i]);
               }
}

initialize_box()
{
 
 make_box_list(&ICBox,"Initial Data",NODE+NMarkov,ICBOX,IC_ID);
 if(NUPAR>0) make_box_list(&ParamBox,"Parameters",NUPAR,PARAMBOX,PARAM_ID);
 else ParamBox.use=0;
 if(NDELAYS>0)
   make_box_list(&DelayBox,"Delay ICs", NODE,DELAYBOX,DELAY_ID);
 else 
   DelayBox.use=0;
  make_box_list(&BCBox,"Boundary Conds",NODE,BCBOX,BC_ID);
}



void alloc_box_list(b,n,id)
BoxList *b;
int n;
UINT id;
{
  double dtemp;
  int i1,i2,i;
  int nrow,ncol;
 
  /*   make a nice shape  */  
  dtemp=(double)n;
  dtemp=sqrt(dtemp);  /*  approximate square  */
  i1=(int)dtemp;   /* truncate the value   */
  if(i1>6)i1=6;  /* maximum columns   */
  i2=n/i1;  
  if(i2*i1<n)i2++; /*  make sure there is enough  */
  nrow=i2;
  ncol=i1;
  b->n=n;
  b->ID0=id;
  b->wval=(HWND *)malloc(n*sizeof(HWND));
  b->rows=nrow;
  b->cols=ncol;
  b->value=(char **)malloc(n*sizeof(char*));
     for(i=0;i<n;i++)
         b->value[i]=(char *)malloc(80*sizeof(char));
  b->use=1;
  
    
}  

  

BOOL HandleBoxListTab(MSG *m)
{
    return(IsDialogMessage(ICBox.hw,m)||
    IsDialogMessage(BCBox.hw,m)|| 
    IsDialogMessage(DelayBox.hw,m)||
    IsDialogMessage(ParamBox.hw,m));
}    
    
make_box_list(pb,title,n,type,id)
char *title;
int type,n;
UINT id;
BoxList *pb;
{
  int i,irow,icol;
  int dxmin=26*PBCX;
    int dxt=60,dxe=60;
    int xb;
    int dxall=dxt+dxe+10;
    /* int dy=18,wid=12; */
    int dy=18,wid=16;
    int sizex;
    int sizey;
    int i0=10,j0=10;
    char bob[80];
    double z;
    HWND temp,temp2;
    alloc_box_list(pb,n,id); /* defines the structure */
    sizex=dxall*pb->cols+40;
    if(sizex<(dxmin+6))sizex=dxmin+6;
    xb=(sizex-dxmin)/2;
    sizey=dy*pb->rows+60;
    pb->type=type;
    pb->hw=CreateWindow("POP",title,     
    WS_BORDER|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,CW_USEDEFAULT,CW_USEDEFAULT,
    sizex,sizey,HWND_DESKTOP,NULL,hInst,NULL);
    ShowWindow(pb->hw,SW_SHOWNORMAL);
   

    for(i=0;i<pb->n;i++){
        irow=i/pb->cols;
        icol=i%(pb->cols);
        temp=CreateWindow("static",NULL,WS_GROUP|SS_RIGHT|WS_CHILD,i0+icol*dxall,
        j0+irow*dy,dxt,wid,pb->hw,NULL,hInst,NULL);
        SendMessage(temp,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
         temp2=CreateWindow("edit",NULL,WS_TABSTOP|WS_CHILD|WS_BORDER|ES_AUTOHSCROLL,
        i0+icol*dxall+dxt+4,
        j0+irow*dy,dxe,wid,pb->hw,NULL,hInst,NULL);
        SendMessage(temp2,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
        pb->wval[i]=temp2;
        switch(type){
            case PARAMBOX:
               SetWindowText(temp,upar_names[i]);
                get_val(upar_names[i],&z);

               sprintf(bob,"%.16g",z);
               strcpy(pb->value[i],bob);  
               SetWindowText(temp2,pb->value[i]);
               break;
            case ICBOX:
               SetWindowText(temp,uvar_names[i]);
               sprintf(bob,"%.16g",last_ic[i]);
               strcpy(pb->value[i],bob);  
               SetWindowText(temp2,pb->value[i]);
               break;
            case BCBOX:
               SetWindowText(temp,"0=");
               strcpy(pb->value[i],my_bc[i].string);
               SetWindowText(temp2,pb->value[i]);
               break;
            case DELAYBOX:
                sprintf(bob,"%s:",uvar_names[i]);
                SetWindowText(temp,bob);
                strcpy(pb->value[i],delay_string[i]);
                SetWindowText(temp2,pb->value[i]);
                break;        
        }
        ShowWindow(temp,SW_SHOWNORMAL);
        ShowWindow(temp2,SW_SHOWNORMAL);
        
    }
     temp=CreateWindow("button","OK",WS_TABSTOP|WS_CHILD,xb,sizey-50,
     3*PBCX,25,pb->hw,pb->ID0,
        hInst,NULL);
         SendMessage(temp,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
        ShowWindow(temp,SW_SHOWNORMAL);
        UpdateWindow(temp);
        temp=CreateWindow("button","Cancel",WS_TABSTOP|WS_CHILD,
        xb+4*PBCX,sizey-50,7*PBCX,25,pb->hw,pb->ID0+1,
        hInst,NULL);
        SendMessage(temp,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
        ShowWindow(temp,SW_SHOWNORMAL);
        UpdateWindow(temp);

        temp=CreateWindow("button","Default",WS_CHILD|WS_TABSTOP,xb+12*PBCX,
        sizey-50,8*PBCX,25,pb->hw,pb->ID0+2,
        hInst,NULL);
        SendMessage(temp,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
        ShowWindow(temp,SW_SHOWNORMAL);
        UpdateWindow(temp);

        temp=CreateWindow("button","Go",WS_CHILD|WS_TABSTOP,xb+21*PBCX,
        sizey-50,3*PBCX,25,pb->hw,pb->ID0+3,
        hInst,NULL);
        SendMessage(temp,WM_SETFONT,(WPARAM)PBOXFONT,MAKELPARAM(TRUE,0));
        ShowWindow(temp,SW_SHOWNORMAL);
        UpdateWindow(temp);
        return TRUE;
}


find_user_name(type,oname)
int type;
char *oname;
{
 char name[25];
 int j=0,k=0,i=-1;
 for(j=0;j<strlen(oname);j++){
 if(!isspace(oname[j])){name[k]=oname[j];k++;}
}
 name[k]=0;
  
 
 for(i=0;i<NUPAR;i++)
         if((type==PARAMBOX)&&(strcasecmp(upar_names[i],name)==0))break;
 if(i<NUPAR)return(i);
 for(i=0;i<NEQ;i++)
         if((type==ICBOX)&&(strcasecmp(uvar_names[i],name)==0))break;   
   if(i<NEQ)return(i);
        return(-1);
 }




add_new_slider()
{
}

test_manic()
{
     int i;
     char bob[256];
     int n=NODE+NMarkov;
     manset_struct.name=(char **)malloc(n*sizeof(char *));
      manset_struct.value=(char **)malloc(n*sizeof(char *));
      for(i=0;i<n;i++){
          manset_struct.name[i]=(char *)malloc(12);
          manset_struct.value[i]=(char *)malloc(256);
          strcpy(manset_struct.name[i],uvar_names[i]);
          sprintf(manset_struct.value[i],"%g",last_ic[i]);
      }
       manset_struct.n=n;
     DialogBox(hInst,"MANICDIALOG",NULL,ManicDialogFunc);
     if(manset_struct.ok==1){
         for(i=0;i<n;i++)
         last_ic[i]=atof(manset_struct.value[i]);
     }
     for(i=0;i<n;i++){
         free(manset_struct.name[i]);
         free(manset_struct.value[i]);
     }
     free(manset_struct.name);
     free(manset_struct.value);
     if(manset_struct.ok==0)return;
     redraw_ics();
     test_run();
}

load_manset(int i, HWND w)
{
    if(i>=0)
    SetDlgItemText(w,101,manset_struct.value[i]);
}
save_manset(int i, HWND w)
{
     if(i>=0)
     GetDlgItemText(w,101,manset_struct.value[i],255);
}       
BOOL CALLBACK ManicDialogFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    static int iold,inew,n;
    int i;
    switch(msg){
        case WM_INITDIALOG:
        iold=0;
        n=manset_struct.n;
        manset_struct.ok=0;
        for(i=0;i<n;i++)
          SendDlgItemMessage(hwnd,100,LB_ADDSTRING,0,(LPARAM)manset_struct.name[i]);

          SendDlgItemMessage(hwnd,100,LB_SETCURSEL,iold,0L);
          load_manset(iold,hwnd);
             
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)){
                     case 100:
                     switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                            save_manset(iold,hwnd);
                              iold=SendDlgItemMessage(hwnd,100,LB_GETCURSEL,0,0L);
                            load_manset(iold,hwnd);
                             return 1;
                     }
                     return 1;
                     case 110:
                          save_manset(iold,hwnd);
                          iold++;
                          if(iold<n){
                           SendDlgItemMessage(hwnd,100,LB_SETCURSEL,iold,0L);
                           load_manset(iold,hwnd);
                           /* SetFocus(GetDlgItem(hwnd,101) ); */
                            }
                           else{
                             manset_struct.ok=1;
                          EndDialog(hwnd,0);
                           }
                                                 
                          
                      return 1;
                      case 102:
                          save_manset(iold,hwnd);
                          manset_struct.ok=1;
                          EndDialog(hwnd,0);
                          return 1;
                      case 103:
                      EndDialog(hwnd,0);
                      return 1;
                 }
    }
    return 0;
}        

 do_torus()
 {
    DialogBox(hInst,"TORUSDIALOG",NULL,TorusDialogFunc);
 }      

BOOL CALLBACK TorusDialogFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    LPINT *selval;
    int i,k,n;
    char bob[256];
    switch(msg){
        case WM_INITDIALOG:
          for(i=0;i<NEQ;i++)
              SendDlgItemMessage(hwnd,IDLIST_T,LB_ADDSTRING,0,
                    (LPARAM)uvar_names[i]);
              SendDlgItemMessage(hwnd,IDLIST_T,LB_SETSEL,0,(LPARAM)(UINT) (-1));          
          for(i=0;i<NEQ;i++){
               if(itor[i]==1)
                 SendDlgItemMessage(hwnd,IDLIST_T,LB_SETSEL,1,(LPARAM)(UINT)i);
          }
          sprintf(bob,"%g",TOR_PERIOD);
          SetDlgItemText(hwnd,IDPERIOD_T,bob);
          return 1;
      case WM_COMMAND:
      switch(LOWORD(wparam)){
          case IDNONE_T:
              SendDlgItemMessage(hwnd,IDLIST_T,LB_SETSEL,
              0,(LPARAM)(UINT) (-1));
             return 1;
          case IDALL_T:
              SendDlgItemMessage(hwnd,IDLIST_T,LB_SETSEL,
              1,(LPARAM)(UINT) (-1));
             return 1;
          case IDOK_T:
               for(i=0;i<NEQ;i++)itor[i]=0;           
               n=SendDlgItemMessage(hwnd,IDLIST_T,LB_GETSELCOUNT,0,0L);
               TORUS=0;
               if(n>0){
                   TORUS=1;
               selval=(int *)malloc(n*sizeof(int)) ;
               SendDlgItemMessage(hwnd,IDLIST_T,LB_GETSELITEMS,n,(LPARAM)selval);
               for(i=0;i<n;i++){
                   k=selval[i];
                   if(k>=0&&k<=NEQ)itor[k]=1;
                  
               }
               free(selval);
               }
               GetDlgItemText(hwnd,IDPERIOD_T,bob,255);
               TOR_PERIOD=atof(bob);
               EndDialog(hwnd,0);
               return 1;
        case IDCANCEL_T:
              EndDialog(hwnd,0);
              return 1;
      }
    }             
     return 0;
}         
