#include <math.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include "structs.h"
#include "phsplan.h"

#define MAXPOP 11
#define FIRSTCOLOR 12
#define VOLTERRA 10 
#define BACKEUL 6
#define RKQS 8
#define STIFF 7
#define GEAR 5
#define CVODE 9

#define PARAM 1
#define IC 2

extern int PAR_FOL,SHOOT;
extern char upar_names[200][11];

extern int WinColor;
extern int NODE,NEQ;
int RANGE_FLAG=0,FPRANGE_FLAG=0;
extern double last_ic[MAXODE],MyData[MAXODE],MyTime;
extern GRAPH graph[MAXPOP];
extern int NKernel,DelayFlag;
extern HWND draw_win;

extern BROWSER my_browser;

mouse_ics(float,float);
many_mouse_ics(float,float);

extern (*solver)(), (*rhs)();

extern HWND mainwnd;
extern HDC gc_graph;

extern int NMarkov,STOCH_FLAG;
extern int  color_min,color_total,color_max;
extern int PointRadius;
double LastTime;
int DelayErr;
extern int calcflag,stoprangeflag;
int SuppressBounds=0;
int MyStart;


extern double ShootIC[4][MAXODE];
extern int ShootICFlag;
extern int ShootIndex;


struct {
         char item[30];
         int steps,shoot,col,movie,index;
         double plow,phigh;
       } eq_range;

 extern struct {
         char item[30],item2[30];
         int steps,reset,oldic,index,index2,cycle,type,type2,movie;
         double plow,phigh;
         double plow2,phigh2;
         int rtype;
       } range;

set_up_eq_range()
{
 return 0;
}

range_item()
{
 int i;
 char bob[256];
 i=find_user_name(PARAM,range.item);
 if(i>-1){
   range.type=PARAM;
   range.index=i;
 }
 else {
   i=find_user_name(IC,range.item);
   if(i<=-1){
     sprintf(bob," %s is not a parameter or variable !",range.item);
     err_msg(bob);
     return(0);
   }
   range.type=IC;
   range.index=i;
 }
 if(range.rtype==0)return 1;
 i=find_user_name(PARAM,range.item2);
 if(i>-1){
   range.type2=PARAM;
   range.index2=i;
 }
 else {
   i=find_user_name(IC,range.item2);
   if(i<=-1){
     sprintf(bob," %s is not a parameter or variable !",range.item2);
     err_msg(bob);
     return(0);
   }
   range.type2=IC;
   range.index2=i;
 }
 return 1;
}

set_up_range()
{
    return 0;
}   
init_range()
{
/* init_ar_ic(); */

 eq_range.col=-1;
 eq_range.index=0;
 eq_range.shoot=0;
 eq_range.steps=10;
 eq_range.plow=0.0;
 eq_range.phigh=1.0;
 eq_range.movie=0;

 strcpy(eq_range.item,upar_names[0]);

 range.type=PARAM;
 range.index=0;
  range.type2=PARAM;
 range.index2=0;
 range.steps=20;
 range.plow=0.0;
 range.plow2=0.0;
 range.phigh=1.0;
 range.phigh2=1.0;

 range.reset=1;
 range.oldic=1;
 range.cycle=0;
 range.movie=0;
 range.rtype=0;

 strcpy(range.item,upar_names[0]);
 strcpy(range.item,upar_names[0]);
 init_shoot_range(upar_names[0]); 

}

do_eq_range()
{
 double parlo,parhi,dpar,temp;
 
 int npar,stabcol,i,j,ierr,oldtrans;
 
 char bob[50];
 double oldpar;
 double *x;
 float stabinfo;
 
 if(FFT||HIST||NKernel>0||NMarkov>0||FPRANGE_FLAG==0)return;
 x=&MyData[0];
 STORFLAG=0;
 POIMAP=0;
 oldtrans=TRANS;
 TRANS=0.0;
 set_gc(1);
 SuppressBounds=1;
 wipe_rep();
 data_back();

 parlo=eq_range.plow;
 parhi=eq_range.phigh;
 
 npar=eq_range.steps;
 dpar=(parhi-parlo)/(double)npar;
 
 stabcol=eq_range.col;

 storind=0;
 DelayErr=0;
 ENDSING=0;
 PAR_FOL=1;
 PAUSER=0;
 SHOOT=eq_range.shoot;
 reset_browser();
 get_val(eq_range.item,&oldpar);
 /* if(eq_range.movie)reset_film(); */
 for(i=0;i<=npar;i++)
   {
      /* if(eq_range.movie)clr_scrn(); */
      temp=parlo+dpar*(double)i;
      set_val(eq_range.item,temp);
      PAR_FOL=1;
      sprintf(bob,"%s=%.16g",eq_range.item,temp);
      bottom_msg(2,bob);
      evaluate_derived();
      if(DelayFlag)
        do_delay_sing(x,NEWT_ERR,EVEC_ERR,BOUND,EVEC_ITER,
                      NODE,&ierr,&stabinfo);
      else do_sing(x,NEWT_ERR,EVEC_ERR,BOUND,EVEC_ITER,
                   NODE,&ierr,&stabinfo);
      /*if(eq_range.movie)
        if(film_clip()==0)err_msg("Out of film"); */

      storage[0][storind]=temp;
      for(j=0;j<NODE;j++)storage[j+1][storind]=(float)x[j];
      for(j=NODE;j<NODE+NMarkov;j++)storage[j+1][storind]=0.0;
      if(stabcol>0)storage[stabcol-1][storind]=stabinfo;

      storind++;
      if(ENDSING==1)break;
    }
    refresh_browser(storind);
 PAR_FOL=0;
 TRANS=oldtrans;
 set_gc(0);
 SuppressBounds=0;
 set_val(eq_range.item,oldpar);
 redraw_params();
}
                                    
swap_color(col,rorw)
int *col,rorw;
{
 if(rorw)MyGraph->color[0]=*col;
 else *col=MyGraph->color[0];
}
set_cycle(flag,icol)
int flag,*icol;
{
 if(flag==0)return;
 MyGraph->color[0]=*icol+1;
 *icol=*icol+1;
  if(*icol==12)*icol=0;
} 

shoot(x,xg,evec,sgn)
double *x,*xg,*evec;
int sgn;
{
 int i;
 double t=0.0;
 for(i=0;i<NODE;i++)
 x[i]=xg[i]+sgn*evec[i]*DELTA_T*.1;
i=1;
calc_on();
 set_gc(1);
 integrate(&t,x,TEND,DELTA_T,0,NJMP,&i);
 calc_off();
 ping();
 set_gc(0);
}


do_range()

{
 char esc;
 double *x;
 char bob[50];
 int ivar=0,ivar2,res=0,oldic=0,oldrange,oldstart;
 int nit=20,i,j,itype,itype2,cycle=0,icol=2;
 int color=MyGraph->color[0];
 double t,dpar,plow=0.0,phigh=1.0,p,p2;

 double plow2,phigh2,dpar2;
 double temp,temp2;
 int ierr=0;
 int nit2;
 if(FFT||HIST||RANGE_FLAG==0)return;
  
  x=&MyData[0];
  oldstart=MyStart;
 MyStart=1;
 reset_dae();
 DelayErr=0;
 data_back();
  wipe_rep();
  MyTime=T0;
  STORFLAG=1;
  POIEXT=0;
  reset_browser();
 itype=range.type;
 
 ivar=range.index;
 res=range.reset;
 oldic=range.oldic;
 nit=range.steps;
 plow=range.plow;
 phigh=range.phigh;
 cycle=range.cycle;
 dpar=(phigh-plow)/(double)nit;
 
 
 get_ic(2,x);
 storind=0;
 PAUSER=0;
 if(range.type==PARAM)get_val(range.item,&temp);
 /* if(range.movie)reset_film(); */
 if(range.rtype>0){
      plow2=range.plow2;
 phigh2=range.phigh2;
 dpar2=(phigh2-plow2)/(double)nit;
 itype2=range.type2;
 ivar2=range.index2;
 if(range.type2==PARAM)get_val(range.item2,&temp2);
 }
 set_gc(1);
 nit2=0;
 if(range.rtype==2)nit2=nit;
 for(j=0;j<=nit2;j++){
 for(i=0;i<=nit;i++)
  {
   /* if(range.movie)clr_scrn(); */
   if(cycle)MyGraph->color[0]=icol;
   icol++;
   if(icol==12)icol=2;
   p=plow+dpar*(double)i;
   if(range.rtype==1)
    p2=plow2+dpar2*(double)i;
   if(range.rtype==2)
    p2=plow2+dpar2*(double)j;
     
   if(oldic==1){
    get_ic(1,x);
    /* if(reset_memory()==0)break; */
     if(DelayFlag){
   /* restart initial data */
   if(do_init_delay(DELAY)==0)break;
  }
  }
   t=T0;
   MyStart=1;
   POIEXT=0;
   if(res==1||STOCH_FLAG)storind=0;
   if(itype==IC)x[ivar]=p;
   else {
     set_val(range.item,p);
     re_evaluate_kernels();
   }
   if(range.rtype>0){
     if(itype2==IC)x[ivar2]=p2;
   else {
     set_val(range.item2,p2);
     re_evaluate_kernels();
   }
   }
  if(range.rtype==0)  
  sprintf(bob,"%s=%.16g  i=%d",range.item,p,i);
  else
  sprintf(bob,"%s=%.16g %s=%.16g",range.item,p,range.item2,p2);
   bottom_msg(2,bob);
  
    calc_on();      
     if(integrate(&t,x,TEND,DELTA_T,1,NJMP,&MyStart)==1){
       ierr=-1;
    calc_off();   
       break;
     }

   if(STOCH_FLAG)
     append_stoch(i,storind); 
  /* if(range.movie)
     if(film_clip()==0){err_msg("Out of film");break;}
     */
     
  
  refresh_browser(storind);
 if(storind>2)auto_freeze_it(); 
   
 }
 }
 
 if(oldic==1)get_ic(1,x);
 else get_ic(0,x);
if(range.type==PARAM)set_val(range.item,temp);
if(range.rtype>0){
    if(range.type2==PARAM)set_val(range.item2,temp2);
}    
evaluate_derived();
 MyGraph->color[0]=color;
 INFLAG=1;
 refresh_browser(storind);
 auto_freeze_it(); 
 ping();
 if(STOCH_FLAG)
   do_stats(nit,ierr); 
 calc_off();
 set_gc(0);
  
 
}


 set_gc(flag)
 int flag;
 {
  static HDC oldgc;
  
  if(flag==1){
   oldgc=gc_graph;   
   gc_graph=GetDC(draw_win);
   set_palette(gc_graph);
   }
  if(flag==0){
   ReleaseDC(draw_win,gc_graph);
   gc_graph=oldgc;
  }
 
 }

 get_more_time()
 {
      double tetemp;
  double *x;
  double dif;
  if(INFLAG==0||FFT!=0||HIST!=0)return;
  tetemp=TEND;
  wipe_rep();
  data_back();
  if(new_float("Continue until:",&tetemp)==0)return;
  x=&MyData[0];
  tetemp=fabs(tetemp);
  if(fabs(MyTime)>=tetemp)return;
  dif=tetemp-fabs(MyTime);
  /* TEND=tetemp; */
  MyStart=1;  /*  I know it is wasteful to restart, but lets be safe.... */
  calc_on();
  set_gc(1);
  integrate(&MyTime,x,dif,DELTA_T,1,NJMP,&MyStart);
  ping();
  calc_off();
  set_gc(0);
  refresh_browser(storind);
}

 
 
 test_run()
 {
 int i,si;
  double *x;
 calc_on();
 MyStart=1;
 x=&MyData[0];
 RANGE_FLAG=0;
 DelayErr=0;
 reset_dae();
 MyTime=T0;
 get_ic(2,x);

 if(DelayFlag){
      /* restart initial data */
      if(do_init_delay(DELAY)==0)return;
    }
  STORFLAG=1;
  POIEXT=0;
  storind=0;
  reset_browser();
  set_gc(1);
  usual_integrate_stuff(x);
  calc_off();
  set_gc(0);
 }

shoot_ics(int si)
{
    int i;
     double *x;
 if(ShootICFlag==0||si>ShootIndex){
     err_msg("Not Shooting data!");
     return;
 }
 calc_on();
 MyStart=1;
 x=&MyData[0];
 RANGE_FLAG=0;
 DelayErr=0;
 reset_dae();
 MyTime=T0;
 
    for(i=0;i<NODE;i++)
     last_ic[i]=ShootIC[si-1][i];
     
 get_ic(2,x); 
  STORFLAG=1;
  POIEXT=0;
  storind=0;
  reset_browser();
  set_gc(1);
  usual_integrate_stuff(x);
  calc_off();
  set_gc(0);
 }

mouse_fp(float x1,float x2)
{
   int iv,jv;
    double *x;
    char bob[256];
        iv=MyGraph->xv[0]-1;
        jv=MyGraph->yv[0]-1;
    
    if(iv<0||iv>=NODE||jv<0||jv>=NODE||MyGraph->grtype>=5||jv==iv)
     return;
    last_ic[iv]=x1;
  last_ic[jv]=x2;
  find_equilibrium(0);
}      
mouse_ics(float x1,float x2)
{
    int iv,jv;
    double *x;
    char bob[256];
        iv=MyGraph->xv[0]-1;
        jv=MyGraph->yv[0]-1;
    
    if(iv<0||iv>=NODE||jv<0||jv>=NODE||MyGraph->grtype>=5||jv==iv)
     return;
     calc_on();
 MyStart=1;
 x=&MyData[0];
 RANGE_FLAG=0;
 DelayErr=0;
 reset_dae();
 MyTime=T0;
 get_ic(1,x);
 if(DelayFlag){
      /* restart initial data */
      if(do_init_delay(DELAY)==0)return;
    }
  STORFLAG=1;
  POIEXT=0;
  storind=0;
  reset_browser();
  x[iv]=x1;
  x[jv]=x2;
  last_ic[iv]=x1;
  last_ic[jv]=x2;   
  set_gc(1);
  usual_integrate_stuff(x);
  calc_off();
  set_gc(0);
}    

many_mouse_ics(float x1,float y1)
{
    SuppressBounds=1;
    mouse_ics(x1,y1);
    SuppressBounds=0;
}
          
integr_last(int shiftflag)
{
  int i,si;
  char ch;
  double *x;
  int im,jm,oldstart,iv,jv,badmouse;
 
 if(INFLAG==0){
      ping();
      err_msg("No prior solution");
      return;
    }
  calc_on();  
  oldstart=MyStart;
  MyStart=1;
  x=&MyData[0];
  RANGE_FLAG=0;
  DelayErr=0;
  reset_dae();
  MyTime=T0;
 get_ic(0,x);
 if(shiftflag==1){
  T0=LastTime;
      MyTime=T0;
  }    
  STORFLAG=1;
  POIEXT=0;
  storind=0;
  reset_browser();
  set_gc(1); 
  if(METHOD==VOLTERRA&&oldstart==0){
      ch=(char)two_choice("Yes","No","Reset integrals?","yn",0,0,mainwnd);
      if(ch=='n')MyStart=oldstart;
    }
   usual_integrate_stuff(x);
  calc_off();
  set_gc(0);
 }
 
    
get_ic(it,x)
int it;
double *x;
{
  int i;
  switch(it){
  case 0:
    for(i=0;i<NODE+NMarkov;i++)last_ic[i]=x[i];
    break;
  case 1:
  case 2:
    for(i=0;i<NODE+NMarkov;i++)x[i]=last_ic[i];
    break;
   }
}

find_equilibrium(int type)
{
 
 
 
 int i,ierr;
 float xm,ym;
 int im,jm;
 int iv,jv;
 float stabinfo;
 double *x,oldtrans;
 
 
 x=&MyData[0];
 if(FFT||HIST||NKernel>0||NMarkov>0)return;

 STORFLAG=0;
 POIMAP=0;
 oldtrans=TRANS;
 TRANS=0.0;
 set_gc(1);
 SuppressBounds=1;
 evaluate_derived();
 switch(type){
 case 2: 
  /* do_eq_range(ww,x); */
   SuppressBounds=0;
   return;
  
 case 0:
 default:
        get_ic(2,x);
        break;
 }

 if(DelayFlag){
   do_delay_sing(x,NEWT_ERR,EVEC_ERR,BOUND,EVEC_ITER,NODE,&ierr,&stabinfo);
   
 }
 else
    do_sing(x,NEWT_ERR,EVEC_ERR,BOUND,EVEC_ITER,NODE,&ierr,&stabinfo);
 TRANS=oldtrans;
 set_gc(0);
 SuppressBounds=0;
}
 
my_abort()
{
 MSG msg;
 if(calcflag==0)return(1);
 if(stoprangeflag==0)return(2);
        if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
           GetMessage(&msg,NULL,0,0);
          TranslateMessage(&msg);
         DispatchMessage(&msg);
        }
 return 0;
 }
 
stor_full()
{

 char ch;
 if(FOREVER)goto ov;
 
 ch=(char)two_choice("YES","NO","Storage full: Overwrite?",
                     "yn",0,0,mainwnd);
 if(ch=='y')
 {
ov:
  storind=0;
  return(1);
 }
  return(0);
}

usual_integrate_stuff(x)
     double *x;
{
  int i;
  data_back();
    if(fabs(MyTime)>=TRANS&&STORFLAG==1&&POIMAP==0)
    {
      storage[0][0]=(float)MyTime;
      extra(x,MyTime,NODE,NEQ);
      for(i=0;i<NEQ;i++)storage[1+i][0]=(float)x[i];
      storind=1;
    }

  integrate(&MyTime,x,TEND,DELTA_T,1,NJMP,&MyStart);
  ping();
  INFLAG=1;
  refresh_browser(storind);
  redraw_ics();
 auto_freeze_it(); 
  
}


ode_int(y,t,istart,ishow)
double *y,*t;
int *istart,ishow;
{
 double error[MAXODE];
 int kflag,i;
 int nit,nout=NJMP;
 double tend=TEND;
 double dt=DELTA_T,tout;
  if(METHOD==0){
 nit=tend;
 dt=dt/fabs(dt);
 }
 else nit=tend/fabs(dt);
calc_on();
 if(ishow==1){
 integrate(t,y,tend,dt,1,nout,istart);
 calcflag=0;
 return(1);
}
 evaluate_derived();
 if(METHOD!=GEAR&&METHOD!=RKQS&&METHOD!=STIFF&&METHOD!=CVODE){
   kflag=solver(y,t,dt,nit,NODE,istart,WORK);
   if(kflag<0){
     ping();
     calcflag=0;
     if(RANGE_FLAG)return(0);
     switch(kflag)
            {
             case -1: err_msg(" Singular Jacobian "); break;
             case -2: err_msg("Too many iterates");break;
              }
           
            return(0);
   }
 }
 else
   {
           tout=*t+tend*dt/fabs(dt);
           switch(METHOD){
           case GEAR:
             if(*istart==1)*istart=0;
             gear(NODE,t,tout,y,HMIN,HMAX,TOLER,2,error,
                  &kflag,istart,WORK,IWORK);
             if(kflag<0)
               {
                 ping();
                 calcflag=0;
                 if(RANGE_FLAG)return(0);
                 switch(kflag)
                   {
                   case -1: err_msg("kflag=-1: minimum step too big"); break;
                   case -2: err_msg("kflag=-2: required order too big");break;
                   case -3: err_msg("kflag=-3: minimum step too big");break;
                   case -4: err_msg("kflag=-4: tolerance too small");break;
                   }
                 
                 return(0);
               }
             break;
#ifdef CVODE_YES
           case CVODE:
             cvode(istart,y,t,NODE,tout,&kflag,&TOLER,&ATOLER);
             if(kflag<0){
               cvode_err_msg(kflag);
               calcflag=0;
               return(0);
             }
             end_cv();
             break;
#endif
           case RKQS:
           case STIFF:
             adaptive(y,NODE,t,tout,TOLER,&dt,
                      HMIN,WORK,&kflag,NEWT_ERR,METHOD,istart);
             if(kflag){
               ping();
               calcflag=0;
               if(RANGE_FLAG)return(0);
               switch(kflag){
               case 2: err_msg("Step size too small"); break;
               case 3: err_msg("Too many steps"); break;         
               case -1: err_msg("singular jacobian encountered"); break;
               case 1: err_msg("stepsize is close to 0"); break;
               case 4:  err_msg("exceeded MAXTRY in stiff"); break;
               }
               return(0);
             }
             break;
           }
         }
  calcflag=0;       
  return(1);
}



integrate(t,x,tend,dt, count, nout,start)
double *t, *x, tend,dt;
int count,nout, *start;
{
 float oldxpl[MAXPERPLOT],oldypl[MAXPERPLOT],oldzpl[MAXPERPLOT];
 float xpl[MAXPERPLOT],ypl[MAXPERPLOT],zpl[MAXPERPLOT];
 float xv[MAXODE+1],xvold[MAXODE+1];
 float oldperiod=0.0;
 double error[MAXODE];
 double xprime[MAXODE],oldxprime[MAXODE],hguess=dt;
 int kflag;
 int perflag=0;
 int *IXPLT,*IYPLT,*IZPLT;
 int NPlots,ip;
 int rval=0;
 double oldx[MAXODE],oldt,dint,sect,sect1,tout,tzero=*t;
 float tscal=tend,tstart=*t,tv;
 float dp_time,xp_time;
 int esc;
 char error_message[50];
 int ieqn,koff,i,pflag=0;
 int icount=0;
 int nit;
 int cwidth;
 int prog_inc,pstep=0;
 ResetProgressBar();

 LastTime=*t;
 evaluate_derived();
  NPlots=MyGraph->nvars;

  
 IXPLT=MyGraph->xv;
 IYPLT=MyGraph->yv;
 IZPLT=MyGraph->zv;

 if((METHOD==GEAR)&&(*start==1))*start=0;
 if(METHOD==0){
 nit=tend;
 dt=dt/fabs(dt);
 }
 else nit=tend/fabs(dt);
 nit=(nit+nout-1)/nout;
 if(nit==0)return(rval);
 prog_inc=abs(nit)/100;
 if(prog_inc==0)prog_inc=1; 
 extra(x,*t,NODE,NEQ); /* Note this takes care of initializing Markov variables */
 xv[0]=(float)*t;
 for(ieqn=1;ieqn<=NEQ;ieqn++)xv[ieqn]=(float)x[ieqn-1];
 for(ip=0;ip<NPlots;ip++){
 oldxpl[ip]=xv[IXPLT[ip]];
 oldypl[ip]=xv[IYPLT[ip]];
 oldzpl[ip]=xv[IZPLT[ip]];
 }

 if(POIMAP)
 {
 oldt=*t;
 for(ieqn=0;ieqn<NEQ;ieqn++)oldx[ieqn]=x[ieqn];
 }
 if(dt<0.0)tscal=-tend;
 if(tscal==0.0)tscal=1.0;
 while(1)
 {

           switch(METHOD){
           case GEAR:
             {
               tout=tzero+dt*(icount+1);
               if(fabs(dt)<fabs(HMIN)){
                 LastTime=*t;
                 return(1);
               }
               gear(NODE,t,tout,x,HMIN,HMAX,TOLER,2,error,&kflag,start,WORK,IWORK);
               stor_delay(x);
               if(DelayErr){
                 DelayErr=0;
                  err_dae();
                 LastTime=*t;
                 return(1);
                
               }
               if(kflag<0)
                 {
                   ping();
                   if(RANGE_FLAG){
                     LastTime=*t;
                     return(1);
                   }
                   switch(kflag)
                     {
                     case -1: err_msg("kflag=-1: minimum step too big"); break;
                     case -2: err_msg("kflag=-2: required order too big");break;
                     case -3: err_msg("kflag=-3: minimum step too big");break;
                     case -4: err_msg("kflag=-4: tolerance too small");break;
                     }
                   
                   LastTime=*t;
                   return(1);
                 }
             }
             break;

           case CVODE:
              tout=tzero+dt*(icount+1);
             if(fabs(dt)<fabs(HMIN)){
               LastTime=*t;
               end_cv();
               return(1);
             }
             ccvode(start,x,t,NODE,tout,&kflag,&TOLER,&ATOLER);
             stor_delay(x);
               if(DelayErr){
                 DelayErr=0;
                  err_dae();
                 LastTime=*t;
                 return(1);
                
               }
             if(kflag<0){
               ping();
               if(RANGE_FLAG){
                 LastTime=*t;
                 return(1);
               }
               cvode_err_msg(kflag);
               LastTime=*t;
               return(1);
             }

             break;

           case RKQS:
           case STIFF:
             tout=tzero+dt*(icount+1);
             if(fabs(dt)<fabs(HMIN)){
               LastTime=*t;
               return(1);
             }
             adaptive(x,NODE,t,tout,TOLER,&hguess,
                      HMIN,WORK,&kflag,NEWT_ERR,METHOD,start);
             stor_delay(x);
               if(DelayErr){
                 DelayErr=0;
                  err_dae();
                 LastTime=*t;
                 return(1);
                
               }
             if(kflag){
               ping();
               if(RANGE_FLAG){
                 LastTime=*t;
                 return(1);
               }
               switch(kflag){
               case 2: err_msg("Step size too small"); break;
               case 3: err_msg("Too many steps"); break;         
               case -1: err_msg("singular jacobian encountered"); break;
               case 1: err_msg("stepsize is close to 0"); break;
               case 4:  err_msg("exceeded MAXTRY in stiff"); break;
               }
               LastTime=*t;
               return(1);
             }

             break;
           default: {

             kflag=solver(x,t,dt,nout,NODE,start,WORK);
              
             if(kflag<0)
               {
                 ping();
                 if(RANGE_FLAG)break;
                 switch(kflag)
                   {
                   case -1: err_msg("Singular Jacobian "); break;
                   case -2: err_msg("Too many iterates ");break;
                   }
           
                 LastTime=*t;
                 return(1);
               }
           }
           
           }
             
           extra(x,*t,NODE,NEQ);
        /*  DO MARKOV CHAIN HERE   */ 
        update_markov(x,*t,fabs(dt)*nout);  


 
           
          if (TORUS == 1) {
        for (ieqn = 0; ieqn < NEQ; ieqn++) {
                if (itor[ieqn] == 1) {
                        if (x[ieqn] > TOR_PERIOD) {
                                x[ieqn] -= TOR_PERIOD;
                                for (ip = 0; ip < NPlots; ip++) {
                                        if (ieqn == IYPLT[ip]-1)
                                        oldypl[ip] -= (float) TOR_PERIOD;
                                        if (ieqn == IXPLT[ip]-1)
                                        oldxpl[ip] -= (float) TOR_PERIOD;
                                if ((ieqn == IZPLT[ip]-1) && (PLOT_3D == 1))
                                        oldzpl[ip] -= (float) TOR_PERIOD;
                                }
                        }
                        if (x[ieqn] < 0) {
                                x[ieqn] += TOR_PERIOD;
                                for (ip = 0; ip < NPlots; ip++) {
                                        if (ieqn == IYPLT[ip]-1)
                                        oldypl[ip] += (float) TOR_PERIOD;
                                        if (ieqn == IXPLT[ip]-1)
                                        oldxpl[ip] += (float) TOR_PERIOD;
                                if ((ieqn == IZPLT[ip]-1) &&
                                    (MyGraph->ThreeDFlag == 1))
                                        oldzpl[ip] += (float) TOR_PERIOD;
                                }
                        }
                      }
              }
      }
           xvold[0]=xv[0];
           for(ieqn=1;ieqn<(NEQ+1);ieqn++)
           {
            xvold[ieqn]=xv[ieqn];
            
            xv[ieqn]=(float)x[ieqn-1];
            if(fabs(x[ieqn-1])>BOUND)
            {
              
             if(RANGE_FLAG||SuppressBounds) break;
             sprintf(error_message," %s out of bounds at t = %f ",
             uvar_names[ieqn-1],*t);
             err_msg(error_message);
             rval=1;

             break;
            }
           }
                        
        /*   This is where the progresser goes   */
         pstep++;
         if(pstep>=prog_inc){
          pstep=0;
          StepProgressBar();
          }
          esc=my_abort();
          if(esc==1)
          break;
          if(esc==2){rval=1;ENDSING=1;break;}
            
           
                   

           if(DelayErr){ err_dae();rval=1;ENDSING=1;DelayErr=0;break;}
         /*  printf(" NEQ=%d ieqn = %d \n",NEQ,ieqn); */
           if(ieqn<(NEQ+1))break;
           tv=(float)*t;
           xv[0]=tv;
 if((POIMAP==2)&&!(POIVAR==0))
 {
  pflag=0;
  if((oldx[POIVAR-1]<x[POIVAR-1])&&!(POIEXT<0))POIEXT=1;
  if((oldx[POIVAR-1]>x[POIVAR-1])&&!(POIEXT>0))POIEXT=-1;
  if(  ( !(oldx[POIVAR-1]<x[POIVAR-1]) && (POIEXT>0) )||
       ( !(oldx[POIVAR-1]>x[POIVAR-1]) && (POIEXT<0) )
    )
  {
     if(POISGN*POIEXT>=0)
      {
        /*  We will interpolate to get a good local extremum   */
        
        rhs(*t,x,xprime,NEQ);
        rhs(oldt,oldx,oldxprime,NEQ);
        dint=xprime[POIVAR-1]/(xprime[POIVAR-1]-oldxprime[POIVAR-1]);
        tv=(1-dint)**t+dint*oldt;
        xv[0]=tv;
        for(i=1;i<=NEQ;i++)xv[i]=dint*oldx[i-1]+(1-dint)*x[i-1];
        pflag=1;
        
      }
      POIEXT=-POIEXT;
   }
  goto poi;
 }



 if(POIMAP==1||POIMAP==3)
 {
    if(POIVAR==0)

     {
     sect1=fmod(fabs(oldt),fabs(POIPLN));
     sect=fmod(fabs(*t),fabs(POIPLN));
     if(sect<sect1)
     {
     dint=sect/(POIPLN+sect-sect1);
     i=(int)(fabs(*t)/fabs(POIPLN));
     tv=(float)POIPLN*i;
     xv[0]=tv;
     for(i=1;i<=NEQ;i++)xv[i]=(float)(dint*oldx[i-1]+(1-dint)*x[i-1]);
     pflag=1;
     }
     else pflag=0;
    }

    else

    {
     if(!(POISGN<0))
     {
     if((oldx[POIVAR-1]<POIPLN)&&!(x[POIVAR-1]<POIPLN))
     {
      dint=(x[POIVAR-1]-POIPLN)/(x[POIVAR-1]-oldx[POIVAR-1]);
      tv=(1-dint)**t+dint*oldt;
      xv[0]=tv;
      for(i=1;i<=NEQ;i++)xv[i]=dint*oldx[i-1]+(1-dint)*x[i-1];
      pflag=1;
      goto poi;

     }
     else pflag=0;
     }
    if(!(POISGN>0))
     {
       if((oldx[POIVAR-1]>POIPLN)&&!(x[POIVAR-1]>POIPLN))
       {
        dint=(x[POIVAR-1]-POIPLN)/(x[POIVAR-1]-oldx[POIVAR-1]);
        tv=(1-dint)**t+dint*oldt;
        xv[0]=tv;
        for(i=1;i<=NEQ;i++)xv[i]=dint*oldx[i-1]+(1-dint)*x[i-1];
        pflag=1;
       }
       else pflag=0;
     }
    }
poi:    for(i=0;i<NEQ;i++)oldx[i]=x[i];
    oldt=*t;
    if(pflag==0)goto out;
  }

         
/*         Plotting and storing data      */
if(POIMAP==3&&pflag==1){
   if(oldperiod==0.0){
     pflag=0; /* this is the first hit !! */
     oldperiod=*t;
     goto out;
   }
   xv[0]=*t-oldperiod;
   oldperiod=*t;
 }
     

          for(ip=0;ip<NPlots;ip++){
           xpl[ip]=xv[IXPLT[ip]];
           ypl[ip]=xv[IYPLT[ip]];
           zpl[ip]=xv[IZPLT[ip]];
          }
          if(!(fabs(*t)<TRANS))
          {
              if(MyGraph->ColorFlag)
                comp_color(xv,xvold,NODE,(float)fabs(dt*NJMP));
   
              do_plot(oldxpl,oldypl,oldzpl,xpl,ypl,zpl);
             /* XFlush(display); */ 
          }
           for(ip=0;ip<NPlots;ip++){
           oldxpl[ip]=xpl[ip];
           oldypl[ip]=ypl[ip];
           oldzpl[ip]=zpl[ip];
           }

           if((STORFLAG==1)&&(count!=0)&&(storind<MAXSTOR)&&!(fabs(*t)<TRANS))
           {
           for(ieqn=0;ieqn<=NEQ;ieqn++)
                 storage[ieqn][storind]=xv[ieqn];
            storind++;
            if(!(storind<MAXSTOR))
            if(stor_full()==0)break;
            if((pflag==1)&&(SOS==1))break;
         }


out:
           icount++;
           if(icount>=nit&&count!=0)break;

 }
       LastTime=*t;

       if(METHOD==CVODE)
         end_cv();
      
       return(rval);
  }




    do_plot(oldxpl,oldypl, oldzpl,xpl,  ypl, zpl)
   float *oldxpl, *oldypl, *oldzpl,*xpl,  *ypl,*zpl;
{
        int ip,np=MyGraph->nvars;
        
        for(ip=0;ip<np;ip++){
           if(MyGraph->ColorFlag==0){

             set_linestyle(MyGraph->color[ip]);
             
           }
/*         if(MyGraph->line[ip]<0)
             continue;  */
           if(MyGraph->line[ip]<=0)
           {
            PointRadius=-MyGraph->line[ip];
           if(MyGraph->ThreeDFlag==0) point_abs(xpl[ip],ypl[ip]);
           else point_3d(xpl[ip],ypl[ip],zpl[ip]);
           }
           else
           {
            if(MyGraph->ThreeDFlag==0){
            
              line_abs(oldxpl[ip],oldypl[ip],xpl[ip],ypl[ip]);
            }
            else line_3d(oldxpl[ip],oldypl[ip],oldzpl[ip],
                         xpl[ip],ypl[ip],zpl[ip]);
           }
       }
}



/*
 old restore is in restore.c

*/

get_plot_point(int i1,float *x,float *y,float *z,int *ix,int *iy)
{
  int ok=1; 
  int ZSHFT,YSHFT,XSHFT;
  int kxoff,kyoff,kzoff;
  int iiXPLT,iiYPLT,iiZPLT;
  float xp,yp;
  XSHFT=MyGraph->xshft;
  YSHFT=MyGraph->yshft;
  ZSHFT=MyGraph->zshft;
  if(i1<ZSHFT)i1=ZSHFT;
  if(i1<YSHFT)i1=YSHFT;
  if(i1<XSHFT)i1=XSHFT;
  
  
     kxoff=i1-XSHFT;
     kzoff=i1-ZSHFT;
     kyoff=i1-YSHFT;

    iiXPLT=MyGraph->xv[0];
    iiYPLT=MyGraph->yv[0];
    iiZPLT=MyGraph->zv[0];

    *x=my_browser.data[iiXPLT][kxoff];
    *y=my_browser.data[iiYPLT][kyoff];
    *z=my_browser.data[iiZPLT][kzoff];
     xp=*x;
     yp=*y;
   if(MyGraph->ThreeDFlag)
        if(threed_proj(*x,*y,*z,&xp,&yp)==0)
         return 0;  /* out of range */
   return scale_em(xp,yp, ix,iy);
        
     
}
    
    
restore(i1,i2)
     int i1,i2;
{
  int ip,np=MyGraph->nvars;
  int ZSHFT,YSHFT,XSHFT;
  int i,j,kxoff,kyoff,kzoff;
  int iiXPLT,iiYPLT,iiZPLT;
  float oldxpl,oldypl,oldzpl,xpl,ypl,zpl;
  float v1[MAXODE+1],v2[MAXODE+1];
  XSHFT=MyGraph->xshft;
  YSHFT=MyGraph->yshft;
  ZSHFT=MyGraph->zshft;
  if(i1<ZSHFT)i1=ZSHFT;
  if(i1<YSHFT)i1=YSHFT;
  if(i1<XSHFT)i1=XSHFT;
  if(storind<2)return;
   for(ip=0;ip<np;ip++){
     kxoff=i1-XSHFT;
     kzoff=i1-ZSHFT;
     kyoff=i1-YSHFT;

    iiXPLT=MyGraph->xv[ip];
    iiYPLT=MyGraph->yv[ip];
    iiZPLT=MyGraph->zv[ip];
    set_linestyle(MyGraph->color[ip]);
    oldxpl=my_browser.data[iiXPLT][kxoff];
    oldypl=my_browser.data[iiYPLT][kyoff];
    oldzpl=my_browser.data[iiZPLT][kzoff];
    for(i=i1;i<i2;i++){
      {
        xpl=my_browser.data[iiXPLT][kxoff];
        ypl=my_browser.data[iiYPLT][kyoff];
        zpl=my_browser.data[iiZPLT][kzoff];
      }
      
      if(TORUS==1)
      {
        if (fabs(oldxpl-xpl)>(float)(.5*TOR_PERIOD))oldxpl=xpl;
        if (fabs(oldypl-ypl)>(float)(.5*TOR_PERIOD))oldypl=ypl;
        if (fabs(oldzpl-zpl)>(float)(.5*TOR_PERIOD))oldzpl=zpl;
      }
      if(MyGraph->ColorFlag!=0&&i>i1){
          for(j=0;j<=NEQ;j++){
            v1[j]=my_browser.data[j][i];
            v2[j]=my_browser.data[j][i-1];
          }
          comp_color(v1,v2,NODE,
                     (float)fabs(my_browser.data[0][i]-my_browser.data[0][i+1]));
        }     /* ignored by postscript */
     /* if(MyGraph->line[ip]<0)
        goto noplot; */
      if(MyGraph->line[ip]<=0){
        PointRadius=-MyGraph->line[ip];
        if(MyGraph->ThreeDFlag==0)point_abs(xpl,ypl);
        else point_3d(xpl,ypl,zpl);
      }
      else {
        if(MyGraph->ThreeDFlag==0)
          line_abs(oldxpl,oldypl,xpl,ypl);
        else
          line_3d(oldxpl,oldypl,oldzpl,xpl,ypl,zpl);
      }
    noplot:
      oldxpl=xpl;
      oldypl=ypl;
      oldzpl=zpl;
      kxoff++;
      kyoff++;
      kzoff++;
    }
  }
}


/*  Sets the color according to the velocity or z-value */
comp_color( v1,v2,n, dt)
 float *v1, *v2;
int n;
float dt;
{
 int i,cur_color;
 float sum;
 float min_scale=(float)(MyGraph->min_scale);
 float color_scale=(float)(MyGraph->color_scale);
 /* lprintf(" cf =%d \n",MyGraph->ColorFlag); */
 if(MyGraph->ColorFlag==2){
   sum=v1[MyGraph->ColorValue];
   /* printf(" %d:sum=%g \n",MyGraph->zv[0],sum); */
 }
 else
   {
     for(i=0,sum=0.0;i<n;i++)sum+=(float)fabs((double)(v1[i+1]-v2[i+1]));
     sum=sum/(dt);
    /* lprintf(" %g %g %g \n",sum,min_scale,color_scale); */
   }
 cur_color=(int)((sum-min_scale)*(float)color_total/color_scale);
/*  printf("min=%f max=%f col = %d val = %f \n",min_scale,color_scale,
        cur_color,sum); */  
 if(cur_color<0)cur_color=0;
 if(cur_color>=color_total)cur_color=color_total-1;
  cur_color+=FIRSTCOLOR;
 set_color(cur_color);
}
