#include <stdio.h>
#define DALLOC(a) (double *)malloc((a)*sizeof(double))
lprintf(char *fmt,...);
 winprintf(char *fmt,...);
#define MAXBCRV 25
typedef struct diagram {
  int npt,line,pointtype,actpar[50],isp,mode;
  double *x,*p,*f,*rr,*ri,t;
  double bifval[5],norm;
  int ifirst,icolor;
  char text[256];
  struct diagram *prev;
  struct diagram *next;
} DIAGRAM;
double lbf_norm(double *);

typedef struct {
    char name[100];
    int exist;
    DIAGRAM d;
} LBFCRVS;

extern LBFCRVS lbfcrv[MAXBCRV];
extern DIAGRAM *bifd;

int CurrentCrv;
int DiagramStart;
typedef struct 
{
  int phot[5];
  double plo[5],phi[5];
  int mode,line,dir,n,m,l;
  double lbfnum[30],norm;
} LBFCTL;

extern LBFCTL lbfctl;
int nbifcrv;
int crvlist[MAXBCRV];
init_lbf_crvs()
{
    int i;
    for(i=0;i<MAXBCRV;i++){
        lbfcrv[i].exist=0;
        sprintf(lbfcrv[i].name,"bifcrv%d",i);
    }
    nbifcrv=0;
}
        
set_lbf_crv(int i)
{
    bifd=&lbfcrv[i].d;
    CurrentCrv=i;
}
start_new_crv()
{
    int i;
    for(i=0;i<MAXBCRV;i++){
        if(lbfcrv[i].exist==0){
            bifd=&lbfcrv[i].d;
            lbfcrv[i].exist=1;
            CurrentCrv=i;
            crvlist[nbifcrv]=i;
            nbifcrv++;
            start_diagram(lbfctl.n,lbfctl.m,lbfctl.l);
            return i;
        }
    }
    err_msg("Cant find any more free curves");
    return -1;
}
start_diagram(n,m,l)
     int n,m,l;
{
 
  bifd->prev=NULL;
  bifd->next=NULL;
  bifd->x=DALLOC(n);
  bifd->rr=DALLOC(n);
  bifd->ri=DALLOC(n);
  if(l>0)bifd->f=DALLOC(l);
  bifd->p=DALLOC(m);
  
 DiagramStart=1;
}


edit_start(npt,line,pointtype,actpar,isp,
  x,p,f,rr,ri,t,bifval,ifirst,icolor,text)
  int npt,line,pointtype,*actpar,isp;
  double *x,*p,*f,*rr,*ri,t;
  double *bifval;
  int ifirst,icolor;
  char *text;  
    
{
  if(bifd==NULL)return;  
  edit_diagram(bifd,npt,line,pointtype,actpar,isp,
  x,p,f,rr,ri,t,bifval,ifirst,icolor,text);
  
}

nodiagram()
{
    if(bifd->next==NULL)return 1;
    return 0;
}
edit_diagram(d,npt,line,pointtype,actpar,isp,
  x,p,f,rr,ri,t,bifval,ifirst,icolor,text)
  DIAGRAM *d;
  int npt,line,pointtype,*actpar,isp;
  double *x,*p,*f,*rr,*ri,t;
  double *bifval;
  int ifirst,icolor;
  char *text;  
{
  int i;
  d->norm=lbf_norm(x);
  d->mode=lbfctl.mode;
  d->npt=npt;
  d->line=line;
  d->pointtype=pointtype;
  d->isp=isp;
  d->ifirst=ifirst;
  d->icolor=icolor;
  strcpy(d->text,text);
  for(i=0;i<lbfctl.m;i++){
      d->p[i]=p[i];
      d->actpar[i]=actpar[i];
  }
  for(i=0;i<5;i++)
     d->bifval[i]=bifval[i];
  for(i=0;i<lbfctl.l;i++)
  d->f[i]=f[i];
  d->t=t;
  
  for(i=0;i<lbfctl.n;i++){
    d->x[i]=x[i];
    d->rr[i]=rr[i];
    d->ri[i]=ri[i];
  
   }
}
  
add_diagram(npt,line,pointtype,actpar,isp,
  x,p,f,rr,ri,t,bifval,ifirst,icolor,text)
  int npt,line,pointtype,*actpar,isp;
  double *x,*p,*f,*rr,*ri,t;
  double *bifval;
  int ifirst,icolor;
  char *text;  
{
 DIAGRAM *d,*dnew;
 int i;
 int n=lbfctl.n,m=lbfctl.m,l=lbfctl.l;
 d=bifd;
 if(d==NULL)return;
 while(d->next != NULL){
   d=(d->next);
 }
 d->next=(DIAGRAM *)malloc(sizeof(DIAGRAM));
 dnew=d->next;
 dnew->next=NULL;
 dnew->prev=d;
  dnew->x=DALLOC(n);
  dnew->rr=DALLOC(n);
  dnew->ri=DALLOC(n);
  if(l>0)dnew->f=DALLOC(l);
  dnew->p=DALLOC(m);

 edit_diagram(dnew,npt,line,pointtype,actpar,isp,
  x,p,f,rr,ri,t,bifval,ifirst,icolor,text);
 
}

get_next_crv()
{
  int j;
  for(j=0;j<MAXBCRV;j++){
      if(lbfcrv[j].exist==1){
        bifd=&lbfcrv[j].d;
        CurrentCrv=j;
        return 1;
      }
  }
 
  return 0;
}  

kill_all_diagrams()
{
    int i;
    for(i=0;i<MAXBCRV;i++)
        kill_diagram(i);

   
}        
kill_diagram(int i)
{
  DIAGRAM *d,*dnew;
  int ilast;
  if(lbfcrv[i].exist==0)return;
  d=&lbfcrv[i].d;
  while(d->next != NULL){  /*  Move to the end of the tree  */
    d=d->next;
  }
  while(d->prev != NULL ){
   dnew=d->prev;
   d->next=NULL;
   d->prev=NULL;
   free(d->x);
   free(d->p);
   free(d->rr);
   free(d->ri);
   if(lbfctl.l>0)free(d->f);
   free(d);
   d=dnew;
 }
  d=&lbfcrv[i].d;
  d->next=NULL;
  d->prev=NULL;
  free(d->x);
  free(d->p);
  if(lbfctl.l>0)free(d->f);
  free(d->rr);
  free(d->ri);
  lbfcrv[i].exist=0;
  sprintf(lbfcrv[i].name,"bifcrv%d",i);
  if(d==bifd){
 
  bifd=NULL;
 
  ilast=get_next_crv();

  }
  
  if(ilast==0){
      
  start_new_crv();
 
  }
  reset_bifcrvlst();
  
  
}

reset_bifcrvlst()
{
    int i;
    nbifcrv=0;
    for(i=0;i<MAXBCRV;i++){
        if(lbfcrv[i].exist==1){
            crvlist[nbifcrv]=i;
            nbifcrv++;
        }
    }


}




    

redraw_diagram()
{
  DIAGRAM *d,*dnew;
  int type,flag=0;
  draw_bif_axes();
  d=bifd;
  if(d->next==NULL)return;
  while(1){
    
    add_point(d->isp,d->mode,d->pointtype,d->line,
    d->x,d->p,d->f,d->rr,d->ri,d->ifirst,d->icolor);
    d=d->next;
    if(d==NULL)break;
  }
}

write_pts(FILE *fp)
{
  
  DIAGRAM *d,*dnew;
 
  double x,y;

  
  d=bifd;
  if(d->next==NULL)return;
  while(1){
    
     auto_xy_plot(&x,&y,d->x,d->p,d->f); 
    fprintf(fp,"%g %g %g %d %d %d\n",
            x,y,d->norm,d->isp,d->pointtype,d->mode);
    d=d->next;
    if(d==NULL)break;
  }
  fclose(fp);
}




bound_diagram(xlo,xhi,ylo,yhi)
     double *xlo,*xhi,*ylo,*yhi;
{
  DIAGRAM *d,*dnew;
 double x,y;
  d=bifd;
  if(d->next==NULL)return;
  *xlo=1.e16;
  *ylo=*xlo;
  *xhi=-*xlo;
  *yhi=-*ylo;
  while(1){
    
   auto_xy_plot(&x,&y,d->x,d->p,d->f);
  if(x<*xlo)*xlo=x;
    if(x>*xhi)*xhi=x;
    if(y<*ylo)*ylo=y;
    if(y>*yhi)*yhi=y;
    d=d->next;
    if(d==NULL)break;
  }
}



