#include <math.h>
#include <stdio.h>
#include <windows.h>
#include <windowsx.h>
#include <string.h>

#include <ctype.h>
#define MAXBCRV 50

#include "lbf_pp.h"

#include "xpplim.h"
#define NFMAX 50
#define NPARMAX 50
#define NRVC 251
#define ROP_OFF R2_NOT
#define ROP_ON R2_NOT
#define Window HWND

extern char color_list[12][20];
extern int calcflag;
extern float **storage;
extern int storind;
extern double constants[];
extern int PointType;

extern WNDCLASS wclauto;
extern int DiagramStart;
extern int NoBreakLine;
#define MB(a) MessageBox(NULL,a,"",MB_OK)
LRESULT CALLBACK WindowFunc(HWND ,UINT ,WPARAM ,LPARAM );
extern HFONT smallfont,helv8font;

extern double last_ic[];

extern int NODE, NEQ,NUPAR;

extern char upar_names[200][11],uvar_names[MAXODE][12];

extern int DCURXs,DCURYs;



extern HINSTANCE hInst;
#define PARAM_BOX 1

int parindex[NPARMAX];
lprintf(char *fmt,...);
 winprintf(char *fmt,...);
int AutoLineWid=1;
int AutoLineColor=0;
int AutoChsColor=0;

extern int CurrentCrv;
/*  FOR PLOTTING STUFF --
    0..n-1 n..n+m-1 n+m..n+m+l-1 are plot variables
*/

int TraverseOn=0;
double Point_x,Point_y;
typedef struct  {
  Window main;
  Window canvas,stab,info;
  Window traverse,left,right,home,jump,grab,esc;
  Window abort;
  HDC dc;
  int exist;
  double xmin,xmax,ymin,ymax;
  int ixplot,iyplot;
  double lastx,lasty;
  int wid,hgt,x0,y0,st_wid;
}BIFUR;

BIFUR Auto;


typedef struct diagram {
  int npt,line,pointtype,actpar[50],isp,mode;
  double *x,*p,*f,*rr,*ri,t;
  double bifval[5],norm;
  int ifirst,icolor;
  char text[256];
  struct diagram *prev;
  struct diagram *next;
} DIAGRAM;


typedef struct {
    char name[100];
    int exist;
    DIAGRAM d;
} LBFCRVS;

LBFCRVS lbfcrv[MAXBCRV];
DIAGRAM *bifd;

int nbfcrv=0;

typedef struct 
{
  int phot[5];
  double plo[5],phi[5];
  int mode,line,dir,n,m,l;
  double lbfnum[30],norm;
} LBFCTL;

LBFCTL lbfctl;

int FirstPoint;

double HopfFreq;



typedef short int shortint;
typedef short int shortlogical;

lbf_main()  
{
 
 
 
 lprintf(" LOCBIF starts ... \n");
  FirstPoint=1;
 calcflag=1;
 initdata_(); /* calls getinitval_ */
 
 locbif_();
 calcflag=0;
 lprintf(" LOCBIF ends ... \n");
 DeleteFile("storef.dat");
 DeleteFile("init.dat");
 DeleteFile("storef1.dat");
 DeleteFile("ts.dat");
 DeleteFile("result"); 
 
redraw_params();
redraw_ics();
 
}
/* this is only done once! */

init_lbfctl()
{
    int i;
    if(Auto.exist==1)return;
    if(NODE>49)return;
    setlbfusual();
    lbfctl.norm=1000;
    lbfctl.n=NODE;
    lbfctl.line=3;
    lbfctl.mode=1;
    if(NUPAR>NPARMAX)lbfctl.m=NPARMAX;
    else lbfctl.m=NUPAR;
    lbfctl.l=NEQ-NODE;
    for(i=0;i<5;i++){
        lbfctl.phot[i]=-1;
        lbfctl.phi[i]=10.0;
        lbfctl.plo[i]=-10.0;
    }
    init_lbf_crvs();
    start_new_crv();
    lbfctl.mode=1;
 lbfctl.line=3;
 lbfctl.dir=1;
 lbfctl.phot[0]=0;
 Auto.ixplot=lbfctl.n;
 Auto.iyplot=0;
    make_lbf_window();
}

/* this checks stability and if it is an eq pt,
   replaces the evals with exp(lambda)
  */ 
check_lbf_stab(double *er,double *ei,int hopf)
{
    int i;
    double r,c,s;
    double ar,ai,ang;
    double minreal=1;
    int np=0;
    HopfFreq=0.0;
    for(i=0;i<lbfctl.n;i++){
        if(lbfctl.mode==1){
            ar=fabs(er[i]);
            ai=fabs(ei[i]);
            
            if(er[i]>0)np++;
            if(er[i]>20)r=exp(20);
            else r=exp(er[i]);
            c=cos(ei[i]);
            s=sin(ei[i]);
            er[i]=r*c;
            ei[i]=r*s;
        }
        else {
           
            c=cos(ei[i]*3.1415926/180);
            s=sin(ei[i]*3.1415926/180);
            ang=fabs(ei[i])*3.1415926/180;
            r=er[i];
            er[i]=r*c;
            ei[i]=r*s;
            r=er[i]*er[i]+ei[i]*ei[i];
            ar=fabs(sqrt(r)-1);
            ai=ang;
            if(r>1)np++;
        }
        if(hopf){
          if(ar<Epszer&&ar<minreal&&ai>5*Epszer){
                minreal=ar;
                HopfFreq=ai;
            }
        }
                
    }
    return np;
}
double lbf_norm(double *x)
{
    double s=0;
    int i;
    for(i=0;i<lbfctl.n;i++)
        s+=fabs(x[i]);
    return s;
}        
lbf_user_stop(nx,x,p,istop,ier)
     shortint nx;
     shortint *istop,*ier;
     double *x,*p;
{
  int i;
  int in;
  if( byeauto_()==1)*istop=1;
 if(lbf_norm(x)>lbfctl.norm)*istop=1;
  for(i=0;i<5;i++){
      in=lbfctl.phot[i];
      if(in>=0){
          if(p[in]>lbfctl.phi[i]||p[in]<lbfctl.plo[i])
          *istop=1;
      }
  }
 
}


lbf_rhs(t,x,f,p)
 double t,*x,*f,*p;
{
  int i;
  int in;
  
  for(i=0;i<5;i++){
      if((in=lbfctl.phot[i])>=0)
    constants[parindex[in]]=p[in];
  }
  evaluate_derived();
  
  my_rhs(t,x,f,lbfctl.n);

}


   
lbf_fun(t,x,p,ifn,funres)
     double t,*x,*p,*funres;
      shortint ifn;
{
 int i,in;
  double y[MAXODE];
  if(ifn<0){
  *funres=0.0;
  return;
}
  for(i=0;i<5;i++){
      if((in=lbfctl.phot[i])>=0)
    constants[parindex[in]]=p[in];
  }
  evaluate_derived();
  for(i=0;i<lbfctl.n;i++)
    y[i]=x[i];
   extra(y, t,lbfctl.n,lbfctl.n+lbfctl.l);
   *funres=y[lbfctl.n+ifn];
}


getinitval_(vnames,pnames,fnames,
                mflag, n, m, l, line, idir, ipact,rpc,rvc)
     char vnames[50][11],pnames[50][11],fnames[50][11];
      shortint *mflag,*n,*m,*l,*line,*ipact,*idir;
     double *rpc,*rvc;
{
 int i,in;
 lprintf(" Initializing ...\n");


  
 /* number of variables */


 *n=lbfctl.n;

 /* register names */

 for(i=0;i<*n;i++)
   strcpy(vnames[i],uvar_names[i]);


/* number of parameters */

 *m=lbfctl.m;

 /* register names and get indices */

 for(i=0;i<*m;i++){
   strcpy(pnames[i],upar_names[i]);
   in=get_param_index(pnames[i]);
   parindex[i]=in;
   
 }
 
 /* functions */

 
 *l=lbfctl.l;
 for(i=0;i<lbfctl.l;i++)
   strcpy(fnames[i],uvar_names[i+NODE]);
 
 /* initial data */
 
 for(i=0;i<lbfctl.n;i++)
   rvc[i]=last_ic[i];
 


 /* initial values of the parameters */

 for(i=0;i<lbfctl.m;i++){
   rvc[NFMAX+i]=constants[parindex[i]];
  
 }



 for(i=0;i<NPARMAX;i++){
   ipact[i]=0;
   if(i==lbfctl.phot[0]||i==lbfctl.phot[1]
       ||i==lbfctl.phot[2]||i==lbfctl.phot[3]
       ||i==lbfctl.phot[4])ipact[i]=1;
 }
/* lprintf("active: %d %d %d \n",ipact[0],ipact[1],ipact[2]); */




 

 /* mode   1- ep 2 -fp 3 lc 4 ps */
   lprintf(" %d %d %d %d | %d %d %d \n %s %s\n ",parindex[0],lbfctl.mode,lbfctl.line,lbfctl.dir,
          *n,*m,*l,vnames[0],pnames[0]);
 *mflag=lbfctl.mode;
  
 *line=lbfctl.line;
 *idir=lbfctl.dir;
rvc[NRVC-1]=0.0;
 /*********************************************/

/* this sets the numerical parameters */
 for(i=0;i<30;i++)rpc[i]=lbfctl.lbfnum[i];

 
}


deblank(char *t,int len,int tol)
{
    int i;
    int cnt=0;
   
    for(i=0;i<len;i++){
        if(t[i]==32)
            cnt++;
        else
           cnt=0;    
        
          if(cnt>=tol){
               
                t[i-cnt+2]=0;
                return;
            }
            
       
      
    }
}

/* the following treat the output */

lbf_output(text,n,m,l,x,p,g,t,rr,ri,bifval,line,actpar,pointtype,
           npt,iend,textlen)
     char *text;
     int textlen;
     shortint n,m,l,npt,iend,line,pointtype;
      shortlogical *actpar;
     double t,*x,*p,*g,*rr,*ri,*bifval;
{
  char rtext[256],ss[100];
  int i,nstab,hopf;
  int lt,pt;
  double er[50],ei[50],per=0.0;
  int newact[50];
  /*  printf(" tl=%d \n",textlen); */
  deblank(text,textlen,9);
  for(i=0;i<textlen;i++)rtext[i]=text[i];
  rtext[textlen]=0;
  lprintf("|%s| \n",rtext);
  lprintf(" pt=%d x=%g  p1=%g  bv=%g \n",
         pointtype,x[0],p[0],bifval[0]);
  /* lprintf(" active %d %d %d \n",actpar[0],actpar[1],actpar[2]);  */ 
  for(i=0;i<n;i++){
               er[i]=rr[i];
               ei[i]=ri[i];
  }
  hopf=0;
  lt=line;
  pt=pointtype;
  switch(line){
      case 3:
      switch(pointtype){
          case 321:
          case 322:
          case 323:
          case 324:
           hopf=1;
 
           break;
      }
      break;
  }
 
  nstab=check_lbf_stab(er,ei,hopf);
  if(HopfFreq>0){per=6.2831853/HopfFreq;
  sprintf(ss,"  T=%g",per);
  strcat(rtext,ss);
  }
  for(i=0;i<NPARMAX;i++)newact[i]=actpar[i];
  if(DiagramStart){
    edit_start(npt,line,pointtype,newact,nstab,
  x,p,g,er,ei,per,bifval,1,AutoChsColor,rtext);
   DiagramStart=0;
    }
  else
    add_diagram(npt,line,pointtype,newact,nstab,
  x,p,g,er,ei,per,bifval,FirstPoint,AutoChsColor,rtext);
  add_point(nstab,lbfctl.mode,pointtype,line,x,p,g,
  er,ei,FirstPoint,AutoChsColor);
  FirstPoint=0;
 /* lprintf(" active2 %d %d %d \n",actpar[0],actpar[1],actpar[2]);  */  
}  


/* error messages */ 
lbf_diag(text,n,m,l,x,p,g,t,rr,ri,bifval,iend,textlen)
     char *text;
     int textlen;
     shortint n,m,l,iend;
     double t,*x,*p,*g,*rr,*ri,*bifval;
{
  char rtext[256];
  int i;
  /*  printf(" tl=%d \n",textlen); */

  for(i=0;i<textlen;i++)rtext[i]=text[i];
  rtext[textlen]=0;
  lprintf("!%s \n",rtext);
  winprintf("Error: %s",rtext);
  
}



add_point(int isp,int mode,int pointtype,int ltype,double *u,
double *p,double *f,double *rr,double *ri,
int ifirst, int icolor)
{
     int ix,iy;
     int oldcolor;
     static double x2,y2;
     double x,y;
     auto_xy_plot(&x,&y,u,p,f);
     ix=IXVal(x);
     iy=IYVal(y);
     
   
  
   if(ifirst){
       x2=x;
       y2=y;
   }
   else {
       AutoColor(icolor);
       if(isp<=0&&ltype==3)LineWidth(2);
       else LineWidth(1);
       DLINE(x,y,x2,y2);
       x2=x;
       y2=y;
   }
 
   AutoColor(0);
     if(pointtype!=0){
         LineWidth(1);
         ALINE(ix-4,iy,ix+5,iy);
        ALINE(ix,iy-4,ix,iy+5);
     }
   plot_stab(rr,ri,lbfctl.n);
  
}

  
button_in_lbf(HWND w,short x, short y)
{
    double rx,ry;
    char txt[256],xlabel[20],ylabel[20];
    if(w!=Auto.canvas)return 0;
    ry=Auto.ymin+(Auto.ymax-Auto.ymin)*(1.-(double)(y-Auto.y0)/(double)Auto.hgt);
    rx=Auto.xmin+(Auto.xmax-Auto.xmin)*((double)(x-Auto.x0)/(double)Auto.wid);
      if(TraverseOn!=0){
       Point_x=rx;
       Point_y=ry;
       auto_button_stuff(APOINT);
       
      }
      else{

          clear_auto_info();
      get_auto_str(xlabel,ylabel);
    sprintf(txt,"%s=%g " ,xlabel,rx);
       auto_info_txt(2,4+DCURYs,txt);
    sprintf(txt,"%s=%g",ylabel,ry);
       auto_info_txt(2,6+2*DCURYs,txt);
      }
     return 1;
}

auto_button_stuff(int cmd)
{
    static int ix,iy;
    int i,j,na,l,hot[5],keep;
    double dist,dmin,xd,yd;
    static DIAGRAM *d,*dnew;
    DIAGRAM *dnear;
     if(nodiagram())return;
   if(TraverseOn==0&&cmd!=ATRAV)return;
   
    switch(cmd){
        case ATRAV:
           if(TraverseOn==1)
           return;
           SetFocus(Auto.main);
           TraverseOn=1;
            d=bifd;         
            traverse_out(d,&ix,&iy);
           break;
        case ALEFT:
        SetFocus(Auto.main);
         dnew=d->prev;
        if(dnew==NULL)dnew=bifd;
        XORCross(ix,iy);
        d=dnew;
        traverse_out(d,&ix,&iy);
        break;
        case ARIGHT:
        SetFocus(Auto.main);
         dnew=d->next;
        if(dnew==NULL)dnew=bifd;
        XORCross(ix,iy);
        d=dnew;
        traverse_out(d,&ix,&iy);
        break;
        case AJUMP:
        SetFocus(Auto.main);
         XORCross(ix,iy);
         i=1;
        while(i==1){
          dnew=d->next;
          if(dnew==NULL)dnew=bifd;
          d=dnew;
          if(d->pointtype!=0)i=0;
        }
        traverse_out(d,&ix,&iy);
        break;
        case ABJUMP:
        SetFocus(Auto.main);
        i=1;
         XORCross(ix,iy);
        while(i==1){
          dnew=d->prev;
          if(dnew==NULL){dnew=bifd;i=0;}
          d=dnew;
          if(d->pointtype!=0)i=0;
        }
        traverse_out(d,&ix,&iy);
        break;
        case APOINT:
         d=bifd;
          auto_xy_plot(&xd,&yd,d->x,d->p,d->f);
             dmin=fabs(Point_x-xd)+fabs(Point_y-yd);
             dnear=d;
         XORCross(ix,iy);
         i=1;
         while(i==1){
             auto_xy_plot(&xd,&yd,d->x,d->p,d->f);
             dist=fabs(Point_x-xd)+fabs(Point_y-yd);
             if(dist<dmin){
                 dmin=dist;
                 dnear=d;
             }
             dnew=d->next;
             if(dnew==NULL){i=0;}
             else
             d=dnew;
         }
          d=dnear;
          traverse_out(d,&ix,&iy);
          break;   
         
        case AHOME:
        SetFocus(Auto.main);
        XORCross(ix,iy);
           d=bifd;         
            traverse_out(d,&ix,&iy);
         break;   
        case AGRAB:
        XORCross(ix,iy);
            TraverseOn=0;
    lbfctl.line=d->line;
    na=0; /* get new list of hot parameters */
    for(i=0;i<50;i++){
        if(d->actpar[i]==1){
            hot[na]=i;
            na++;
       
        }
    }
    /* now keep all the ones that are the same
       and get rid of the ones that are not
    */   
     for(i=0;i<5;i++){
        keep=0; 
        l=lbfctl.phot[i];
        if(l>=0){
            for(j=0;j<na;j++){
                if(l==hot[j]){
                    keep=1;
                    hot[j]=-1;
                }
            }
            if(keep==0)lbfctl.phot[i]=-1;
        }
     }
    
  /* finally add any more that are needed */
  for(j=0;j<na;j++){
      
      if(hot[j]>=0){
          keep=1;
          for(i=0;i<5;i++){
              if(lbfctl.phot[i]==-1&&keep==1){
                lbfctl.phot[i]=hot[j];
                keep=0;
              }
                
          }
      }
  }
 
    for(i=0;i<lbfctl.n;i++){
    
      set_ivar(i+1,d->x[i]);
    }
    get_ic(0,d->x);
   
    for(i=0;i<lbfctl.m;i++)
      constants[parindex[i]]=d->p[i];
      redraw_params();
      redraw_ics();
            break;
        case AESC:
        XORCross(ix,iy);
            TraverseOn=0;
            redraw_params();
            redraw_ics();
            break;
       
    }
}
    

info_out(DIAGRAM *d)
{
    char text[256],s[70];
    int nv=3,i;
    clear_auto_info();
    strcpy(text,d->text);
    auto_info_txt(2,2,text);
/*     if(d->t>0)sprintf(s," T= %g",d->t);
    auto_info_txt(2+30*DCURYs,2,s); */
    if(lbfctl.n<3)nv=lbfctl.n;
   sprintf(text,"nrm=%g,",d->norm);
   for(i=0;i<nv;i++){
       sprintf(s,"%s=%g ",uvar_names[i],d->x[i]);
       strcat(text,s);
   }  
    auto_info_txt(2,4+DCURYs,text);
    strcpy(text,":");
    for(i=0;i<5;i++){
        nv=lbfctl.phot[i];
        if(nv>=0){
        sprintf(s,"%s=%g ",upar_names[nv],d->p[nv]);
        strcat(text,s);
        }
    }
     auto_info_txt(2,6+2*DCURYs,text);        
}
traverse_out(d,ix,iy)
     int *ix,*iy;
     DIAGRAM *d;
{
    double x,y;
    
    auto_xy_plot(&x,&y,d->x,d->p,d->f);
    *ix=IXVal(x);
    *iy=IYVal(y);
    XORCross(*ix,*iy);
  plot_stab(d->rr,d->ri,lbfctl.n);
  info_out(d);
}
     
     
auto_key_stuff(HWND hw,WPARAM wparam)
  {
    
    if(hw!=Auto.main) return 0;
 
    if(TraverseOn==0)return 0;
    
    switch(wparam){
    case VK_LEFT:
    auto_button_stuff(ALEFT);
    break;
    case VK_RIGHT:
     auto_button_stuff(ARIGHT);
    break;
    case VK_HOME:
     auto_button_stuff(AHOME);
    break;
   case VK_PRIOR:
     auto_button_stuff(ABJUMP);
    break;
    case VK_NEXT:
     auto_button_stuff(AJUMP);
    break;
    case VK_ESCAPE:
     auto_button_stuff(AESC);
    break;
    case VK_SPACE:
    auto_button_stuff(AGRAB);
    break;
    }
    return 1;

  }


  





/* INTERFACE STUFF  */

/*  Running stuff */
/* Equilibria */
BOOL CALLBACK LBFEQDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,k;
 char text[256];
 switch(message){
     case WM_INITDIALOG:
     strcpy(text,"none");
     for(k=0;k<3;k++){
        SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)text);
       for(i=0;i<lbfctl.m;i++)
          SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
     SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_SETCURSEL,lbfctl.phot[k]+1,0L);
     set_vd(hdwnd,LBFEQ_P1LO+2*k,lbfctl.plo[k]);
     set_vd(hdwnd,LBFEQ_P1HI+2*k,lbfctl.phi[k]);
             
     }
     SendDlgItemMessage(hdwnd,LBFEQ_LINE+lbfctl.line,BM_SETCHECK,1,0);
     set_vi(hdwnd,LBFEQ_DIR,lbfctl.dir);
     return 1;
     case WM_COMMAND:
     switch(LOWORD(wparam)){
         case IDCANCEL:
         EndDialog(hdwnd,0);
         break;
         case IDOK:
         lbfctl.mode=1;
         for(k=0;k<3;k++){

      lbfctl.phot[k]=SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_GETCURSEL,0,0L)-1;
     get_vd(hdwnd,LBFEQ_P1LO+2*k,&lbfctl.plo[k]);
     get_vd(hdwnd,LBFEQ_P1HI+2*k,&lbfctl.phi[k]);
             
     }
     k=0;
     for(i=1;i<=13;i++){
                       if(SendDlgItemMessage(hdwnd,LBFEQ_LINE+i,BM_GETCHECK,0,0))
                       k=i;
                   }
     lbfctl.line=k;              
     get_vi(hdwnd,LBFEQ_DIR,&lbfctl.dir);
         EndDialog(hdwnd,0);
         lbf_main();
         break;
     }
     return 1;
 }
 return 0;     
}
 /* Fixed pts of maps */
BOOL CALLBACK LBFFPDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,k;
 char text[256];
 switch(message){
     case WM_INITDIALOG:
     strcpy(text,"none");
     for(k=0;k<3;k++){
        SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)text);
       for(i=0;i<lbfctl.m;i++)
          SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
     SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_SETCURSEL,lbfctl.phot[k]+1,0L);
     set_vd(hdwnd,LBFEQ_P1LO+2*k,lbfctl.plo[k]);
     set_vd(hdwnd,LBFEQ_P1HI+2*k,lbfctl.phi[k]);
             
     }
     SendDlgItemMessage(hdwnd,LBFEQ_LINE+lbfctl.line,BM_SETCHECK,1,0);
     set_vi(hdwnd,LBFEQ_DIR,lbfctl.dir);
     return 1;
     case WM_COMMAND:
     switch(LOWORD(wparam)){
         case IDCANCEL:
         EndDialog(hdwnd,0);
         break;
         case IDOK:
         lbfctl.mode=2;
         for(k=0;k<3;k++){

      lbfctl.phot[k]=SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_GETCURSEL,0,0L)-1;
     get_vd(hdwnd,LBFEQ_P1LO+2*k,&lbfctl.plo[k]);
     get_vd(hdwnd,LBFEQ_P1HI+2*k,&lbfctl.phi[k]);
             
     }
     k=0;
     for(i=1;i<=16;i++){
                       if(SendDlgItemMessage(hdwnd,LBFEQ_LINE+i,BM_GETCHECK,0,0))
                       k=i;
                   }
     lbfctl.line=k;              
     get_vi(hdwnd,LBFEQ_DIR,&lbfctl.dir);
         EndDialog(hdwnd,0);
         lbf_main();
         break;
     }
     return 1;
 }
 return 0;     
}
 /* Periodically forced */

BOOL CALLBACK LBFPSDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
int i,k;
 char text[256];
 switch(message){
     case WM_INITDIALOG:
     strcpy(text,"none");
     for(k=0;k<3;k++){
        SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)text);
       for(i=0;i<lbfctl.m;i++)
          SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
     SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_SETCURSEL,lbfctl.phot[k]+1,0L);
     set_vd(hdwnd,LBFEQ_P1LO+2*k,lbfctl.plo[k]);
     set_vd(hdwnd,LBFEQ_P1HI+2*k,lbfctl.phi[k]);
             
     }
     SendDlgItemMessage(hdwnd,LBFEQ_LINE+lbfctl.line,BM_SETCHECK,1,0);
     set_vi(hdwnd,LBFEQ_DIR,lbfctl.dir);
     return 1;
     case WM_COMMAND:
     switch(LOWORD(wparam)){
         case IDCANCEL:
         EndDialog(hdwnd,0);
         break;
         case IDOK:
         lbfctl.mode=4;
         for(k=0;k<3;k++){

      lbfctl.phot[k]=SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_GETCURSEL,0,0L)-1;
     get_vd(hdwnd,LBFEQ_P1LO+2*k,&lbfctl.plo[k]);
     get_vd(hdwnd,LBFEQ_P1HI+2*k,&lbfctl.phi[k]);
             
     }
     k=0;
     for(i=1;i<=16;i++){
                       if(SendDlgItemMessage(hdwnd,LBFEQ_LINE+i,BM_GETCHECK,0,0))
                       k=i;
                   }
     lbfctl.line=k;              
     get_vi(hdwnd,LBFEQ_DIR,&lbfctl.dir);
         EndDialog(hdwnd,0);
         lbf_main();
         break;
     }
     return 1;
 }
 return 0;     


 
}
/* Limit cycles */ 
BOOL CALLBACK LBFLCDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,k;
 char text[256];
 switch(message){
     case WM_INITDIALOG:
  
     strcpy(text,"none");
     for(k=0;k<4;k++){
        SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)text);
       for(i=0;i<lbfctl.m;i++)
          SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
     SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_SETCURSEL,lbfctl.phot[k]+1,0L);
     set_vd(hdwnd,LBFEQ_P1LO+2*k,lbfctl.plo[k]);
     set_vd(hdwnd,LBFEQ_P1HI+2*k,lbfctl.phi[k]);
             
     }
     SendDlgItemMessage(hdwnd,LBFEQ_LINE+lbfctl.line,BM_SETCHECK,1,0);
     set_vi(hdwnd,LBFEQ_DIR,lbfctl.dir);
     return 1;
     case WM_COMMAND:
     switch(LOWORD(wparam)){
         case IDCANCEL:
         EndDialog(hdwnd,0);
         break;
         case IDOK:
         lbfctl.mode=3;
         for(k=0;k<4;k++){

      lbfctl.phot[k]=SendDlgItemMessage(hdwnd,LBFEQ_P1+k,LB_GETCURSEL,0,0L)-1;
     get_vd(hdwnd,LBFEQ_P1LO+2*k,&lbfctl.plo[k]);
     get_vd(hdwnd,LBFEQ_P1HI+2*k,&lbfctl.phi[k]);
             
     }
     k=0;
     for(i=1;i<=16;i++){
                       if(SendDlgItemMessage(hdwnd,LBFEQ_LINE+i,BM_GETCHECK,0,0))
                       k=i;
                   }
     lbfctl.line=k;              
     get_vi(hdwnd,LBFEQ_DIR,&lbfctl.dir);
         EndDialog(hdwnd,0);
     
         lbf_main();
         break;
     }
     return 1;
 }
 return 0;     
}
/* Add/edit new curves */
 
BOOL CALLBACK LBFAddDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i;
 char temp[100];
 static int crvlst[25],nc,iold;
switch(message){
    case WM_INITDIALOG:
    iold=0;
    nc=0;
   
     for(i=0;i<25;i++){
       if(lbfcrv[i].exist){
           crvlst[nc]=i;
           if(nc==0)SetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[i].name);
           nc++;
             SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_ADDSTRING,0,
             (LPARAM)lbfcrv[i].name);
             
       }
      }
      SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_SETCURSEL,0,0L);
      
      
    return 1;
    case WM_COMMAND:
    switch(LOWORD(wparam)){
        case LBFADD_NEW:
        i=start_new_crv();
        if(i<0)break;
        crvlst[nc]=i;
        nc++;
         GetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[iold].name,99);
                           
        SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_ADDSTRING,0,
             (LPARAM)lbfcrv[i].name);
        SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_SETCURSEL,nc-1,0L);
        SetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[i].name);
        iold=i;        
        break;
        case LBFADD_LIST:
          switch(HIWORD(wparam)){
                           case LBN_SELCHANGE:
                           GetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[iold].name,99);
                           iold=SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_GETCURSEL,
                                 0,0L);
                           SetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[iold].name);
                             return 1;
          }    
        break;
        case IDCANCEL:
        EndDialog(hdwnd,0);
             break;
        case IDOK:
         iold=SendDlgItemMessage(hdwnd,LBFADD_LIST,LB_GETCURSEL,
                                 0,0L);
          GetDlgItemText(hdwnd,LBFADD_NAME,lbfcrv[iold].name,99);
           set_lbf_crv(iold);                                          
          EndDialog(hdwnd,0);
             break;
    }
    return 1;
}
return 0;    
}

/* deleting curves */
BOOL CALLBACK LBFDelDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i;
 char temp[100];
 static int crvlst[25],nc;
switch(message){
    case WM_INITDIALOG:
     nc=0;
      for(i=0;i<25;i++){
       if(lbfcrv[i].exist){
           crvlst[nc]=i;
           nc++;
             SendDlgItemMessage(hdwnd,LBFDEL_LIST,LB_ADDSTRING,0,
             (LPARAM)lbfcrv[i].name);
       }
      }
      return 1;
        case WM_COMMAND:
        switch(LOWORD(wparam)){
            case IDCANCEL:
             EndDialog(hdwnd,0);
             break;
             case LBFDEL_DEL:
             i=SendDlgItemMessage(hdwnd,LBFDEL_LIST,LB_GETCURSEL,0,0L);
             if(i<0){MessageBox(NULL,"Select a curve first","!!",MB_OK);
                      break;
             } 
             if(MessageBox(NULL,"Delete this diagram?","!!",MB_YESNO)==IDYES)
             kill_diagram(crvlst[i]);
             EndDialog(hdwnd,0);
             break;
             case LBFDEL_ALL:
             if(MessageBox(NULL,"Delete all diagrams?","!!",MB_YESNO)==IDYES)
             kill_all_diagrams();
             EndDialog(hdwnd,0);
             break;
        }
        return 1;
}
return 0;

}


/* plot parameters */ 
BOOL CALLBACK LBFPlotDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,n=lbfctl.n,m=lbfctl.m,l=lbfctl.l;
 char temp[100];
 switch(message){
      case WM_INITDIALOG:
               for(i=0;i<12;i++)
    SendDlgItemMessage(hdwnd,LBFPLT_COLOR,LB_ADDSTRING,0,
             (LPARAM)color_list[i]);
             
    SendDlgItemMessage(hdwnd,LBFPLT_COLOR,LB_SETCURSEL,0,0L);       
      for(i=0;i<n;i++){
           strcpy(temp,uvar_names[i]);
            SendDlgItemMessage(hdwnd,LBFPLT_XAX,CB_ADDSTRING,0,
             (LPARAM)temp);
             SendDlgItemMessage(hdwnd,LBFPLT_YAX,CB_ADDSTRING,0,
             (LPARAM)temp);
      }
       for(i=0;i<m;i++){
           strcpy(temp,upar_names[i]);
            SendDlgItemMessage(hdwnd,LBFPLT_XAX,CB_ADDSTRING,0,
             (LPARAM)temp);
             SendDlgItemMessage(hdwnd,LBFPLT_YAX,CB_ADDSTRING,0,
             (LPARAM)temp);
      }
       for(i=0;i<l;i++){
           strcpy(temp,uvar_names[i+n]);
            SendDlgItemMessage(hdwnd,LBFPLT_XAX,CB_ADDSTRING,0,
             (LPARAM)temp);
             SendDlgItemMessage(hdwnd,LBFPLT_YAX,CB_ADDSTRING,0,
             (LPARAM)temp);
      }
      SendDlgItemMessage(hdwnd,LBFPLT_XAX,CB_SETCURSEL,Auto.ixplot,0L);
       SendDlgItemMessage(hdwnd,LBFPLT_YAX,CB_SETCURSEL,Auto.iyplot,0L);
       SendDlgItemMessage(hdwnd,LBFPLT_AUTOSCALE,BM_SETCHECK,0,0L);
     set_vd(hdwnd,LBFPLT_XMIN,Auto.xmin);
     set_vd(hdwnd,LBFPLT_YMIN,Auto.ymin);
     set_vd(hdwnd,LBFPLT_XMAX,Auto.xmax);
     set_vd(hdwnd,LBFPLT_YMAX,Auto.ymax);
     return 1;
   case WM_COMMAND:
    switch(LOWORD(wparam)){
        case LBFPLT_AUTOSCALE:
        if(SendDlgItemMessage(hdwnd,LBFPLT_AUTOSCALE,BM_GETCHECK,0,0L))
        {
         auto_fit();
         set_vd(hdwnd,LBFPLT_XMIN,Auto.xmin);
         set_vd(hdwnd,LBFPLT_YMIN,Auto.ymin);
         set_vd(hdwnd,LBFPLT_XMAX,Auto.xmax);
         set_vd(hdwnd,LBFPLT_YMAX,Auto.ymax);
        }
        break;
        case IDCANCEL:
        EndDialog(hdwnd,0);
        redraw_diagram();
        break;
        case IDOK:
        AutoChsColor=SendDlgItemMessage(hdwnd,LBFPLT_COLOR,LB_GETCURSEL,0,0L);
      
        if(AutoChsColor<0)AutoChsColor=0;
      
        Auto.ixplot=SendDlgItemMessage(hdwnd,
                    LBFPLT_XAX,CB_GETCURSEL,0,0L);
        Auto.iyplot=SendDlgItemMessage(hdwnd,
                    LBFPLT_YAX,CB_GETCURSEL,0,0L);
        get_vd(hdwnd,LBFPLT_XMIN,&Auto.xmin);
         get_vd(hdwnd,LBFPLT_YMIN,&Auto.ymin);
         get_vd(hdwnd,LBFPLT_XMAX,&Auto.xmax);
         get_vd(hdwnd,LBFPLT_YMAX,&Auto.ymax);
        EndDialog(hdwnd,0);
         redraw_diagram();
        break;
    }
    return 1;
 }
 return 0;                           

}
/*  numerical parameters */

BOOL CALLBACK LBFNumDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 int i,k,meth;
switch(message){
      case WM_INITDIALOG:
        for(i=0;i<20;i++)
         set_vd(hdwnd,100+i,lbfctl.lbfnum[i]);
         for(i=21;i<24;i++)
         set_vd(hdwnd,100+i,lbfctl.lbfnum[i]);
         meth=(int)lbfctl.lbfnum[20];
         SendDlgItemMessage(hdwnd,120,LB_ADDSTRING,0,(LPARAM)"DP5a");
         SendDlgItemMessage(hdwnd,120,LB_ADDSTRING,0,(LPARAM)"DP5b");
         SendDlgItemMessage(hdwnd,120,LB_ADDSTRING,0,(LPARAM)"DP5c");
         SendDlgItemMessage(hdwnd,120,LB_ADDSTRING,0,(LPARAM)"RK4");
         SendDlgItemMessage(hdwnd,120,LB_ADDSTRING,0,(LPARAM)"STIFF");
         switch(meth){
             case -1:
              k=4;
              break;
             case 1:
             case 2:
             case 3:
             case 4:
             k=meth-1;
              break;
         }
         SendDlgItemMessage(hdwnd,120,LB_SETCURSEL,k,0L);
         return 1;
      case WM_COMMAND:
        switch(LOWORD(wparam)){
            case IDOK:
            for(i=0;i<20;i++)
                get_vd(hdwnd,100+i,&lbfctl.lbfnum[i]);
             for(i=21;i<24;i++)
         get_vd(hdwnd,100+i,&lbfctl.lbfnum[i]);
             i=  SendDlgItemMessage(hdwnd,120,LB_GETCURSEL,0,0L);
             if(i>=0){
                 if(i==4)lbfctl.lbfnum[20]=-1;
                 else
                 lbfctl.lbfnum[20]=i+1;
             } 
             EndDialog(hdwnd,0);
             break;
             case IDCANCEL:
             EndDialog(hdwnd,0);
             break;
        }
        return 1;
}
return 0;
}
             
           










setlbfusual()
    
{

   H0crv =.10000000000000000  ;
   Hmxcrv= 1.0000000000000000   ;
   Angcrv= 10.000000000000000    ;
   DHcrv = .10000000000000000E-06 ; 
   Dhjac = .10000000000000000E-06  ; 
   Maxit = 7.0000000000000000    ;
   Modit = 2.0000000000000000 ;
   Epscrv= .10000000000000000E-03;  
   Epscrs= .10000000000000000E-02;
   Epszer= .10000000000000000E-02 ;
   Epsext= .10000000000000000E-02  ; 
   Iprsng= 1.0000000000000000    ;
   Algcrv= 2.0000000000000000   ;


  Itmap = 1.0000000000000000  ;
  Tint  = 1.000000000000000  ;  
   H0int = .10000000000000000   ; 
   Hmxint= 10.000000000000000  ;
   Dhint = .10000000000000000E-06;
   Epsint= .10000000000000000E-05;  
   Epsrel= .10000000000000000E-08 ;
   Solver= 1.0000000000000000 ;   
   Isec  = 1.0000000000000000  ;
   Irhs  = .00000000000000000   ;
   Iorbit= .00000000000000000    ;


  Join  = 1.0000000000000000 ; 
   Sound = .00000000000000000 ;  
   Flash = 50.000000000000000  ;  
   Messng= 0.0000000000000000  ;
   Maxnpt= 200.000000000000000  ;
   Init  = 0.0000000000000000   ; 

}



make_lbf_window()
{
    
    int ymargin=4*DCURYs;
    int xmargin=12*DCURXs;
    HINSTANCE hh=hInst;

     Auto.main= CreateWindow(
          "AUTO", "Its LOCBIF!",
               WS_OVERLAPPEDWINDOW,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          450,
          300,
          HWND_DESKTOP,
          NULL,hInst,NULL);
    if(Auto.main==NULL){
            MB("Couldnt create");
            return 0;
    }  
    Auto.traverse=CreateWindow("button","Traverse",WS_CHILD,
    10,5,80,20,Auto.main,A_TRAV_ID,hh,NULL);
    Auto.left=CreateWindow("button","<<",WS_CHILD,
    10,30,25,20,Auto.main,A_LEFT_ID,hh,NULL);
    Auto.right=CreateWindow("button",">>",WS_CHILD,
    65,30,25,20,Auto.main,A_RIGHT_ID,hh,NULL);
    Auto.jump=CreateWindow("button","Jump",WS_CHILD,
    10,55,35,20,Auto.main,A_JUMP_ID,hh,NULL);
    Auto.esc=CreateWindow("button","Esc",WS_CHILD,
    55,80,35,20,Auto.main,A_ESC_ID,hh,NULL);
    Auto.home=CreateWindow("button","Home",WS_CHILD,
    55,55,35,20,Auto.main,A_HOME_ID,hh,NULL);
    Auto.grab=CreateWindow("button","Grab",WS_CHILD,
    10,80,35,20,Auto.main,A_GRAB_ID,hh,NULL);
    Auto.abort=CreateWindow("button","ABORT",WS_CHILD,
    10,110,80,20,Auto.main,A_ABORT_ID,hh,NULL);

       ShowWindow(Auto.main,SW_SHOWNORMAL);
     UpdateWindow(Auto.main);
      SendMessage(Auto.traverse,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.traverse,SW_SHOWNORMAL);
     UpdateWindow(Auto.traverse);
     SendMessage(Auto.left,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.left,SW_SHOWNORMAL);
     UpdateWindow(Auto.left);
     SendMessage(Auto.right,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.right,SW_SHOWNORMAL);
     UpdateWindow(Auto.right);
     SendMessage(Auto.jump,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.jump,SW_SHOWNORMAL);
     UpdateWindow(Auto.jump);
     SendMessage(Auto.esc,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.esc,SW_SHOWNORMAL);
     UpdateWindow(Auto.esc);
     SendMessage(Auto.grab,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.grab,SW_SHOWNORMAL);
       
     UpdateWindow(Auto.grab);
     SendMessage(Auto.abort,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.abort,SW_SHOWNORMAL);
     UpdateWindow(Auto.abort);
     SendMessage(Auto.home,WM_SETFONT,(WPARAM)helv8font,MAKELPARAM(TRUE,0));
       ShowWindow(Auto.home,SW_SHOWNORMAL);
     UpdateWindow(Auto.home);


   Auto.stab=CreateWindow("POP",NULL,WS_CHILD|WS_BORDER,10,140,80,80,
                    Auto.main,NULL,hh,NULL);
   Auto.info= CreateWindow("POP",NULL,WS_CHILD|WS_BORDER,100,5,340,40,
                    Auto.main,NULL,hh,NULL);
   Auto.canvas=CreateWindow("POP",NULL,WS_CHILD|WS_BORDER,100,50,340,185,
                    Auto.main,NULL,hh,NULL);
   Auto.wid=340-xmargin;
   
   Auto.hgt=185-ymargin;
   Auto.st_wid=80;
   Auto.x0=10*DCURXs;
   Auto.y0=2*DCURYs;                 
      ShowWindow(Auto.stab,SW_SHOWNORMAL);
     UpdateWindow(Auto.stab);
         ShowWindow(Auto.info,SW_SHOWNORMAL);
     UpdateWindow(Auto.info);
         ShowWindow(Auto.canvas,SW_SHOWNORMAL);
     UpdateWindow(Auto.canvas);
  Auto.xmin=-1.0;
  Auto.ymin=-1.0;
  Auto.xmax=1.0;
  Auto.ymax=1.0;
                                                   
  Auto.exist=1;

 Auto.dc=GetDC(Auto.canvas);
  if(Auto.dc==NULL)MB("Couldnt get auto dc");
  set_palette(Auto.dc);
  return 1;
     
}
AutoColor(int col)
{
    AutoLineColor=col;
}    

get_lbf_name(int i,char *name)
{
   if(i<lbfctl.n){
       strcpy(name,uvar_names[i]);
        return;
   }
   if(i<lbfctl.n+lbfctl.m){
       strcpy(name,upar_names[i-lbfctl.n]);
       return;
   }
   strcpy(name,uvar_names[i-lbfctl.m]);
}
get_auto_str(xlabel,ylabel)
char *xlabel,*ylabel;
{
   get_lbf_name(Auto.ixplot,xlabel);
   get_lbf_name(Auto.iyplot,ylabel);

}
draw_ps_axes()
{
 char sx[20],sy[20];
 set_scale(Auto.xmin,Auto.ymin,Auto.xmax,Auto.ymax);
 get_auto_str(sx,sy);
 Box_axis(Auto.xmin,Auto.xmax,Auto.ymin,Auto.ymax,sx,sy);
}

expose_lbf(HWND w)
{
    if(w==Auto.canvas){
        
        redraw_diagram();
    }
}
draw_bif_axes()
{
 int i;
 int x0=Auto.x0,y0=Auto.y0,ii,i0;
 int x1=x0+Auto.wid,y1=y0+Auto.hgt;
 int oldcolor;
 char junk[20],xlabel[20],ylabel[20];
 
 clear_auto_plot();
 
 AutoColor(0);
 ALINE(x0,y0,x1,y0);
 ALINE(x1,y0,x1,y1);
 ALINE(x1,y1,x0,y1);
 ALINE(x0,y1,x0,y0);
 sprintf(junk,"%g",Auto.xmin);
 ATEXT(x0,y1+2,junk);
 sprintf(junk,"%g",Auto.xmax);
 ii=strlen(junk)*DCURXs;
 ATEXT(x1-ii,y1+2,junk);
 sprintf(junk,"%g",Auto.ymin);
 ii=strlen(junk);
 i0=9-ii;
 if(i0<0)i0=0;
 ATEXT(i0*DCURXs,y1,junk);
 sprintf(junk,"%g",Auto.ymax);
 ii=strlen(junk);
 i0=9-ii;
 if(i0<0)i0=0;
 ATEXT(i0*DCURXs,y0,junk);
 get_auto_str(xlabel,ylabel);
 ATEXT((x0+x1)/2,y1+2,xlabel);
 ATEXT(10*DCURXs,DCURYs,ylabel);
 
}

int byeauto_()
   
{
  MSG msg;
 if(calcflag==0)return 1;
  if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)){
           GetMessage(&msg,NULL,0,0);
          TranslateMessage(&msg);
         DispatchMessage(&msg);
        } 
 
 return 0;


}

int IXVal(x)
     double x;
{
  double temp=(double)Auto.wid*(x-Auto.xmin)/(Auto.xmax-Auto.xmin);
  return ((int) temp+Auto.x0);
}

int IYVal(y)
     double y;
{
  double temp=(double)Auto.hgt*(y-Auto.ymin)/(Auto.ymax-Auto.ymin);
  return(Auto.hgt-(int)temp+Auto.y0);
}

DLINE(double a,double b,double c,double d)
{
    ALINE(IXVal(a),IYVal(b),IXVal(c),IYVal(d));
}

ATEXT(int a,int b,char *c)
{
SetBkMode(Auto.dc,TRANSPARENT);
SelectObject(Auto.dc,smallfont);
TextOut(Auto.dc,a,b,c,strlen(c));
}

clear_auto_plot()
{
      ClearWindow(Auto.canvas,Auto.dc);
}       

ALINE(int a,int b,int c,int d)
{
HPEN pen;
 HPEN oldpen;
 
 pen=CreatePen(0,AutoLineWid,PALETTEINDEX(AutoLineColor));
 if(pen==NULL)lprintf("no pen created \n");
 oldpen=SelectObject(Auto.dc,pen);
 MoveToEx(Auto.dc,a,b,NULL);
 LineTo(Auto.dc,c,d);
 SelectObject(Auto.dc,oldpen);
 DeleteObject(pen);
}
           

LineWidth(wid)
     int wid;
{
AutoLineWid=wid;
}
EvalCross(int ix,int iy)
{
    HDC dc;
    dc=GetDC(Auto.stab);
    MoveToEx(dc,ix-2,iy,NULL);
     LineTo(dc,ix+3,iy);
    MoveToEx(dc,ix,iy-2,NULL);
    LineTo(dc,ix,iy+3);
    ReleaseDC(Auto.stab,dc);
}    
    
EvalCircle(int x,int y,int r)
{
    HDC dc;
    dc=GetDC(Auto.stab);
    ClearWindow(Auto.stab,dc);
    Ellipse(dc,x-r,y-r,x+r,y+r);
    ReleaseDC(Auto.stab,dc);
}

XORCross(x,y)
     int x,y;
{
  LineWidth(2);
   SetROP2(Auto.dc,R2_NOT);
   ALINE(x-8,y,x+8,y);
  ALINE(x,y+8,x,y-8);
   SetROP2(Auto.dc,R2_COPYPEN);

 LineWidth(1);
}    
    
Circle(int x,int y, int r)
{
    
  Ellipse(Auto.dc,x-r,y-r,x+r,y+r);
}
FillCircle(x,y,r)
     int x,y;
     int r;
{
 
 SelectObject(Auto.dc,GetStockObject(BLACK_BRUSH));   
  Ellipse(Auto.dc,x-r,y-r,x+r,y+r);
 SelectObject(Auto.dc,GetStockObject(HOLLOW_BRUSH));
} 



plot_stab(evr,evi,n)
     int n;
     double *evr,*evi;
{
  int i,ix,iy;
  int r=Auto.st_wid;
  int r2=r/2;
  double x,y;
  LineWidth(0);
  clr_stab();
  for(i=0;i<n;i++){
    x=evr[i];
    if(x<-1.95)x=-1.95;
    if(x>1.95)x=1.95;
    y=evi[i];
    if(y<-1.95)y=-1.95;
    if(y>1.95)y=1.95;
    x=r*(x+2.0)/4.0;
    y=r-r*(y+2.0)/4.0;
    ix=(int)x;
    iy=(int)y;
    EvalCross(ix,iy);
  }
}
    



clr_stab()
{
  int r=Auto.st_wid/4,x=Auto.st_wid/2;
  EvalCircle(x,x,r);
}


ArrangeAutoWnd()
  {

     int w,h;
     int wt,ht;
     int xoff=100,yioff=5,yoff=50;
   int ymargin=4*DCURYs;
    int xmargin=12*DCURXs;
     GetWindowDimensions(Auto.main,&w,&h);
     wt=w-xoff-5;
     ht=h-yoff-5;
     MoveWindow(Auto.info,xoff,yioff,wt,40,TRUE);
     MoveWindow(Auto.canvas,xoff,yoff,wt,ht,TRUE);
     Auto.wid=wt-xmargin;
    
     Auto.hgt=ht-ymargin;
  /*  ReleaseDC(Auto.canvas,Auto.dc);
    Auto.dc=GetDC(Auto.canvas); */
  }    
          

resize_auto(HWND w,int cx,int cy)
{
   
    if(Auto.exist==0)return 0;
    if(w!=Auto.main)return 0;
    ArrangeAutoWnd();
    return 1;
}
         

auto_fit()
{
  double xlo=Auto.xmin,xhi=Auto.xmax,ylo=Auto.ymin,yhi=Auto.ymax;

  bound_diagram(&xlo,&xhi,&ylo,&yhi);
  Auto.xmin=xlo;
  Auto.xmax=xhi;
  Auto.ymin=ylo;
  Auto.ymax=yhi;
}
  
auto_zoom(i1,j1,i2,j2)
     int i1,j1,i2,j2;
{
  int temp;
  double x1,y1,x2,y2;
  if(i1>i2){temp=i1;i1=i2;i2=temp;}
  if(j2>j1){temp=j1;j1=j2;j2=temp;}
  x1=Auto.xmin+(double)(i1-Auto.x0)*(Auto.xmax-Auto.xmin)/(double)Auto.wid;
  x2=Auto.xmin+(double)(i2-Auto.x0)*(Auto.xmax-Auto.xmin)/(double)Auto.wid;
  y1=Auto.ymin+(double)(Auto.hgt+Auto.y0-j1)*(Auto.ymax-Auto.ymin)/(double)Auto.hgt;
  y2=Auto.ymin+(double)(Auto.hgt+Auto.y0-j2)*(Auto.ymax-Auto.ymin)/(double)Auto.hgt;
  Auto.xmin=x1;
  Auto.ymin=y1;
  Auto.xmax=x2;
  Auto.ymax=y2;

}  

double lbf_val_from_ind(int i,double *u,double *p,double *f)
{
    if(i<lbfctl.n)
           return u[i];
   if(i<lbfctl.n+lbfctl.m)
       return p[i-lbfctl.n];
    return f[i-lbfctl.n-lbfctl.m];   
}
auto_xy_plot(x,y,u,p,f)
        double *x,*y;
        double *u,*p,*f;
{
    *x=lbf_val_from_ind(Auto.ixplot,u,p,f);
    *y=lbf_val_from_ind(Auto.iyplot,u,p,f);
}


clear_auto_info()
{
  HDC dc;
    dc=GetDC(Auto.info);
ClearWindow(Auto.info,dc);
ReleaseDC(Auto.info,dc);
}  

auto_info_txt(x,y,s)
int x,y;
char *s;
{
    HDC dc;
    dc=GetDC(Auto.info);

SelectObject(dc,smallfont);
TextOut(dc,x,y,s,strlen(s));
ReleaseDC(Auto.info,dc);
}




lbf_copy_to_clip()
{
    RECT rect;
    HDC memdc;
    HBITMAP hbm;
    int w,h;
    GetClientRect(Auto.canvas,&rect);
    w=rect.right;
    h=rect.bottom;
    memdc=CreateCompatibleDC(Auto.dc);
    hbm=CreateCompatibleBitmap(Auto.dc,w,h);
    SelectObject(memdc,hbm);
    BitBlt(memdc,0,0,w,h,Auto.dc,0,0,SRCCOPY);
    if(OpenClipboard(NULL)!=0){
         EmptyClipboard();
         SetClipboardData(CF_BITMAP,hbm);
         CloseClipboard(); }
    else {
        err_msg("Couldn't open clipboard!");
    }
    DeleteDC(memdc);
  
}     
         
