
/* continuation parameters */

#define H0crv lbfctl.lbfnum[0]   /* initial step size */
#define Hmxcrv lbfctl.lbfnum[1]  /* maximal step size */
#define Angcrv lbfctl.lbfnum[2]  /* step size control parameter */
#define    DHcrv  lbfctl.lbfnum[3] /* numerical jacobian increment for curve */
#define    Dhjac lbfctl.lbfnum[4]  /* numerical jacobian increment for ODE */
#define    Maxit lbfctl.lbfnum[5] /* maximum number of newton iterates */
#define    Modit lbfctl.lbfnum[6]  /* number of newton steps with Jacobi reevaluation */
#define    Epscrv lbfctl.lbfnum[7] /* newton tolerance */
#define    Epscrs lbfctl.lbfnum[8]  /* self crossing tolerance */
#define    Epszer lbfctl.lbfnum[9]  /* root zero tolerance */
#define    Epsext lbfctl.lbfnum[10]  /* extremal tolerance */
#define    Iprsng lbfctl.lbfnum[11] /* ordering number of active parameters */
#define    Algcrv lbfctl.lbfnum[12] /* type of stepsize control +/- 1,2,3 */

/* orbit parameters */

#define  Itmap  lbfctl.lbfnum[13] /* iteration number -- period for maps etc! */ 
#define    Tint lbfctl.lbfnum[14] /* time between outputs -- Tmax=Itmap*Tint 
                            set this to the period for periodic
                            forcing */
#define    H0int lbfctl.lbfnum[15] /* initial step size for integrator */
#define    Hmxint lbfctl.lbfnum[16] /* maximum integration step size */ 
#define    Dhint  lbfctl.lbfnum[17] /* numerical jacobi for stiff integrator */
#define    Epsint lbfctl.lbfnum[18] /* absolute tolerance */
#define    Epsrel lbfctl.lbfnum[19] /* relative tolerance */
#define    Solver lbfctl.lbfnum[20]  /* solver - 1,2,3 4 nonstiff; -1 stiff */
#define    Isec   lbfctl.lbfnum[21]  /* 0 means let LBF choose secant for poincare map
                              1..n is variable -1..-L is a user function
                              */
#define    Irhs   lbfctl.lbfnum[22] /* for DAE's number of algebraic rhs - first IRHS */
#define    Iorbit lbfctl.lbfnum[23] /* +1 for complete trajectory, -1 for poincare map
                            for periodically forced */ 


/* dont even screw with these! */ 
#define   Join   lbfctl.lbfnum[24] 
#define   Sound  lbfctl.lbfnum[25] 
#define   Flash  lbfctl.lbfnum[26] 
#define   Messng lbfctl.lbfnum[27] 
#define   Maxnpt lbfctl.lbfnum[28] /* 'cept maybe this one -- max number pts per calc */
#define   Init   lbfctl.lbfnum[29]



/*  interface parameters */

#define A_TRAV_ID 15000
#define A_LEFT_ID 15001
#define A_RIGHT_ID 15002
#define A_JUMP_ID 15003
#define A_HOME_ID 15004
#define A_GRAB_ID 15005
#define A_ESC_ID 15006
#define A_ABORT_ID 15007

#define ATRAV 0
#define ALEFT 1
#define ARIGHT 2
#define AJUMP 3
#define AHOME 4
#define AGRAB 5
#define AESC 6
#define ABJUMP 7

#define APOINT 10

#define LBF_WRITEPTS 6006

#define LBF_SAVE 6001
#define LBF_LOAD 6002

#define LBF_NEWCRV 6101
#define LBF_DELCRV 6103
#define LBF_COPY 6102


#define LBF_RUN 6050

#define LBF_PLOT 6030
#define LBF_REDRAW 6029

#define LBF_NUM 6020

#define LBF_CTLEQ 6011
#define LBF_CTLFP 6012
#define LBF_CTLPS 6013
#define LBF_CTLLC 6014




#define LBFCRV_CRV 100
#define LBFCRV_COL 101
#define LBFCRV_NAME 102
#define LBFCRV_NEW 103
#define LBFCRV_DEL 104
#define LBFCRV_ALL 105

#define LBFPLT_XAX 100
#define LBFPLT_YAX 101
#define LBFPLT_XMIN 102
#define LBFPLT_XMAX 103
#define LBFPLT_YMIN 104
#define LBFPLT_YMAX 105
#define LBFPLT_AUTOSCALE 106
#define LBFPLT_COLOR 107

#define LBFEQ_LINE 100
#define LBFEQ_P1 120
#define LBFEQ_P1LO 130
#define LBFEQ_P1HI 131
#define LBFEQ_P1 120
#define LBFEQ_DIR 150

#define LBFADD_LIST 100
#define LBFADD_NEW 101
#define LBFADD_CHS 102

#define LBFADD_NAME 104

#define LBFDEL_LIST 100
#define LBFDEL_DEL 101
#define LBFDEL_ALL 102

