#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "xpplim.h"
#include "globals.h"
#include "structs.h"
#define BMAXCOL 20
#define BR_PAGE 20 
#define B_DIG 12   /* number of digits etc for browser numbers */
double atof();
extern int *my_ode[];

extern char *ode_names[MAXODE];

extern char uvar_names[MAXODE][12];
extern int NEQ,MAXSTOR,NMarkov,FIX_VAR;
extern int NEQ_MIN;
extern int NODE,NJMP;
float **storage;
extern int storind;
double evaluate();
float *old_rep;
int REPLACE=0,R_COL=0;

extern double last_ic[MAXODE],DELTA_T;

extern int NSYM,NSYM_START,NCON,NCON_START;

extern int DCURX,DCURY,DCURXs,DCURYs,DCURX8,DCURY8;
extern HFONT smallfont,stdfont,helv8font;
extern HINSTANCE hInst;

BROWSER my_browser;
BOOL CALLBACK BAddFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK BDelFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK BFindFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK BReplaceFunc(HWND,UINT,WPARAM,LPARAM);
struct {
    double value;
    int col,ok;
} bfind_struct;

struct {
    char value[256];
    int col,ok;
} breplace_struct;

struct {
    char value[256],var[20];
    int ok,col;
} badd_struct;

struct {
    int ok,col;
} bdel_struct;

init_browser(HWND w)
{
 my_browser.w=w;
 my_browser.dataflag=0;
 my_browser.data=storage;
 my_browser.maxcol=NEQ+1;
 my_browser.maxrow=0;
 my_browser.col0=0;
 my_browser.row0=0;
 my_browser.istart=0;
 my_browser.iend=0;
 lprintf(" Making browser neq=%d \n",NEQ);
 }

 refresh_browser(length)
 int length;
{
 my_browser.dataflag=1;
 my_browser.maxrow=length;
 my_browser.iend=length;
 redraw_browser(my_browser);
}
 reset_browser()
{
  my_browser.maxrow=0;
  my_browser.dataflag=0;
}




find_variable(s,col)
char *s;
int *col;
{
 *col=-1;
  if(strcasecmp("T",s)==0){
   *col=0;
    return;
   }
  *col=find_user_name(2,s);
  if(*col>-1)*col=*col+1; 
 } 
   
 

   

/* Puts a little box around text and redraws it  */

boxname(char *s,int x,int y,int cwid,int hgt,HDC hdc)
{
    int wid=strlen(s)*cwid+4;
    Rectangle(hdc,x,y,x+wid,y+hgt);
     SelectObject(hdc,helv8font); 
    TextOut(hdc,x+2,y+2,s,strlen(s));
}



resize_my_browser()
{
    resize_browser(&my_browser);
}
resize_browser(BROWSER *b)
{
    RECT rect;
  
  int w,h,hreal;
  int dcol=B_DIG*DCURX8,drow=DCURY8+6;
  int i0,i1;
  int newrow,newcol;
 GetClientRect(b->w,&rect);
 h=rect.bottom;
 w=rect.right;
  hreal=h;
 
 i0=w/dcol;
 
 if(i0>b->maxcol)i0=b->maxcol;

 
 newcol=i0;
 h=hreal-10;
 i0=h/drow-1;
 
 if(i0>b->maxrow)i0=b->maxrow;

 newrow=i0;

b->ncol=newcol;
b->nrow=newrow;

}
   
paintbrowser(HWND hwnd,HDC hdc)
{
  resize_my_browser();  
  draw_a_browser(my_browser,hdc,hwnd);
}  

redraw_browser(BROWSER b)
{
   HDC hdc;
   hdc=GetDC(b.w);
   draw_a_browser(b,hdc,b.w);
   ReleaseDC(b.w,hdc);
}
     
draw_a_browser(BROWSER b,HDC hdc,HWND hw)
{

  int i,i0=5,j,j0=5,iv;
  int x0;
 
  RECT rect;
 char s[20];
 int dcol=DCURX8*B_DIG;
 int wid=DCURX8*10+4,hgt=DCURY8+3;
 int drow=(DCURY8+6);
 int nacr,ndwn,x,y;
 if(b.dataflag==0)return;  /*   no data  */
 
 /* Clear window   */
 
 ClearWindow(hw,hdc);
 GetClientRect(hw,&rect);
 
 /* Draw the little box names  */
 nacr=(rect.right-10)/dcol;
 if(nacr>b.maxcol)nacr=b.maxcol;
 ndwn=(rect.bottom-10)/drow-1;
 if(ndwn>=b.maxrow)ndwn=b.maxrow;
 lprintf(" bcol=%d\n",b.col0); 
 lprintf(" names: %s %s \n",uvar_names[0],uvar_names[1]);
 boxname("Time",i0,j0,DCURX8,hgt,hdc);
 for(i=1;i<nacr;i++)
 {
     iv=i-1+b.col0;
     if(iv<(b.maxcol-1))
     boxname(uvar_names[iv],i0+i*dcol,j0,DCURX8,hgt,hdc);
 }   
 
 /*  Now we draw all the numbers  */
  SelectObject(hdc,helv8font);
 for(i=0;i<ndwn;i++){
     iv=i+b.row0;
     y=(i+1)*drow+j0;
     x=i0;
     if(iv<b.maxrow){
         sprintf(s,"%g",b.data[0][iv]);
         TextOut(hdc,x,y,s,strlen(s));
     
     for(j=1;j<nacr;j++){
         x=i0+j*dcol;
         if((j+b.col0)<b.maxcol){
         sprintf(s,"%g",b.data[j+b.col0][iv]);
         TextOut(hdc,x,y,s,strlen(s));}
     }
     }
 }   
 
}

BOOL HandleBrowser(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  int pos=my_browser.row0,hpos=my_browser.col0,maxr=my_browser.maxrow-1,maxc=my_browser.maxcol;
  HDC hdc;
  HWND w;
  int i;
  LPDRAWITEMSTRUCT lpdis;
  char str[80];
  
  switch(msg){
 
   case WM_KEYDOWN:
      
       if(hwnd!=my_browser.w)return 0;
       switch(wparam){
           case VK_HOME:
                SendMessage(hwnd,WM_VSCROLL,SB_TOP,0L);
                return 1;
           case VK_END:
                SendMessage(hwnd,WM_VSCROLL,SB_BOTTOM,0L);
                return 1;
            case VK_UP:
                SendMessage(hwnd,WM_VSCROLL,SB_LINEUP,0L);
                return 1;
            case VK_DOWN:
                SendMessage(hwnd,WM_VSCROLL,SB_LINEDOWN,0L);
                return 1;
            case VK_PRIOR:
                SendMessage(hwnd,WM_VSCROLL,SB_PAGEDOWN,0L);
                return 1;
            case VK_NEXT:
                SendMessage(hwnd,WM_VSCROLL,SB_PAGEUP,0L);
                return 1;
             case VK_LEFT:
                SendMessage(hwnd,WM_HSCROLL,SB_LINELEFT,0L);
                return 1;
             case VK_RIGHT:
                SendMessage(hwnd,WM_HSCROLL,SB_LINERIGHT,0L);
                return 1;
       }
       
     return 0;                                                                      
   case WM_VSCROLL:
    if(maxr<=0)
       return 1;
    w=hwnd;
    if(w!=my_browser.w)return 0; 
    SetScrollRange(w,SB_VERT,0,maxr,1);
    switch(LOWORD(wparam)){
        case SB_TOP:
            pos=0;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
        case SB_BOTTOM:
            pos=maxr;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;    
        case SB_LINEDOWN:
            pos++;
            if(pos>maxr)pos=maxr;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
         case SB_LINEUP:
            pos--;
            if(pos<0)pos=0;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
         case SB_THUMBPOSITION:
            pos=HIWORD(wparam);
            SetScrollPos(w,SB_VERT,pos,1);
 
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
  /*        case SB_THUMBTRACK:
            pos=HIWORD(wparam);
            SetScrollPos(w,SB_VERT,pos,1);
 
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;       */    /*  May not want this */
         case SB_PAGEUP:
            pos+=BR_PAGE;
            if(pos>=maxr)pos=maxr;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
         case SB_PAGEDOWN:
            pos-=BR_PAGE;
            if(pos<0)pos=0;
            SetScrollPos(w,SB_VERT,pos,1);
            my_browser.row0=pos;
            redraw_browser(my_browser);
            return 1;
                     
     }
  
    case WM_HSCROLL:
     if(maxc<=0)
       return 1;
        w=hwnd;
         if(w!=my_browser.w)return 0;  
        SetScrollRange(w,SB_HORZ,0,maxc,1);
        switch(LOWORD(wparam)){
                case SB_LINELEFT:
                hpos--;
                if(hpos<0)hpos=0;
                SetScrollPos(w,SB_HORZ,hpos,1);
                my_browser.col0=hpos;
                
                redraw_browser(my_browser);
                return 1;
                case SB_LINERIGHT:
                i=my_browser.col0+my_browser.ncol;
                if(i<=my_browser.maxcol)hpos++;
                
                SetScrollPos(w,SB_HORZ,hpos,1);
                my_browser.col0=hpos;
                  
                redraw_browser(my_browser);
                return 1;

                
                case SB_THUMBPOSITION:
                hpos=HIWORD(wparam);
                if((hpos+my_browser.ncol)>my_browser.maxcol)
                    hpos=my_browser.maxcol-my_browser.ncol; 
                 SetScrollPos(w,SB_HORZ,hpos,1);
            
                 my_browser.col0=hpos;
                  
                 redraw_browser(my_browser);
            return 1;
        }
  }             
  return 0;
  }

get_br_row()
{
 data_get(&my_browser);
}    
save_br_data()
{
    data_write(&my_browser);
}

load_br_data()
{
     data_read(&my_browser);
}         
data_read(b)
BROWSER *b;
{
 
 int rev,status;
 char fil[256];
 char ch;
 FILE *fp;
 char junk[256];
 int i,j,k;
 int len,count=0,white=1;
 float z;
 int ok;
 fil[0]=0;
 opensave(0,hInst,fil,"Import data");
 /*sprintf(junk,"file=%s",fil);
 err_msg(junk); */
 if(strlen(fil)==0){
     err_msg("No file selected");
     return;
 }

 
 fp=fopen(fil,"r");
        if(fp==NULL){
            err_msg("Cannot open file to read!");
                                     
                                     return;
                                     }
 /*  Now we establish the width of the file and read it.
      If there are more columns than available we
      ignore them.
     
     if there are fewer rows we read whats necessary
     if there are more rows then read until we 
     are done or MAX_STOR_ROW.
     This data can be plotted etc like anything else
    */
    
 do
   {
    fscanf(fp,"%c",&ch);
    if( !isspace((int)ch)&&(white) )
    {
     white=0;
     ++count;
     }
     if( isspace((int)ch) &&(1-white)) white=1;
   } while(ch != '\n');
 rewind(fp);
 len=0;
 while(!feof(fp))
 {
  for(k=0;k<count;k++)
  {
   fscanf(fp,"%f ",&z);
   if(k<b->maxcol)b->data[k][len]=z;
   }
   ++len;
   if(len>=MAXSTOR)break;
  }
  fclose(fp);
  refresh_browser(len);
  storind=len;
 /*  b->maxrow=len;
 draw_data(*b); */
}
   


data_write(b)
BROWSER *b;
{
  
 int rev,status;
 char fil[256];
 FILE *fp;
 int i,j;
 int ok;
 fil[0]=0;
 opensave(1,hInst,fil,"Save data");
 if(strlen(fil)==0){
     err_msg("No file selected");
     return;
 }

 
 fp=fopen(fil,"w");
 if(fp==NULL){
     err_msg("Cannot open file to write");
     return;
 }
 for(i=b->istart;i<b->iend;i++){
        for(j=0;j<b->maxcol;j++)fprintf(fp,"%.8g ",b->data[j][i]);
        fprintf(fp,"\n");
        }
 fclose(fp);
}
 
 

data_get(b)
BROWSER *b;
{
 int i,in=b->row0;
 set_ivar(0,(double)storage[0][in]);
 for(i=0;i<NODE;i++)
 {
  last_ic[i]=(double)storage[i+1][in];
  set_ivar(i+1,last_ic[i]);
 } 
 for(i=0;i<NMarkov;i++)last_ic[i+NODE]=(double)storage[i+NODE+1][in];
 for(i=NODE+NMarkov;i<NEQ;i++)set_val(uvar_names[i],storage[i+1][in]);

 redraw_ics();
}





browser_find()
{
    int row;

 DialogBox(hInst,"BFINDDIALOG",NULL,BFindFunc);
 if(bfind_struct.ok==0)return;
 find_value(bfind_struct.col,bfind_struct.value,&row,my_browser);
 if(row>=0){
            my_browser.row0=row;
            redraw_browser(my_browser);
           }
    
}    


find_value(col,val,row,b)
int col,*row;
double val;
BROWSER b;
{
 int n=b.maxrow;
 int i;
 int ihot=0;
 float err,errm;
 errm=fabs(b.data[col][0]-val);
 for(i=b.row0;i<n;i++){
 err=fabs(b.data[col][i]-val);
 if(err<errm){
        ihot=i;
        errm=err;
        }
  }
 *row=ihot;
}

BOOL CALLBACK BFindFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    int i;
    char temp[256];
    switch(msg){
        case WM_INITDIALOG:
           SendDlgItemMessage(hwnd,100,CB_ADDSTRING,0,
             (LPARAM)"t");
           for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp);
            SendDlgItemMessage(hwnd,100,CB_ADDSTRING,0,
             (LPARAM)temp);
           }
           sprintf(temp,"%g",bfind_struct.value);
          SetDlgItemText(hwnd,101,temp);
          SendDlgItemMessage(hwnd,100,CB_SETCURSEL,bfind_struct.col,0L);
          bfind_struct.ok=0;
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)){
                     case 102:
                     
                      i=SendDlgItemMessage(hwnd,100,CB_GETCURSEL,0,0L);
                      if(i>=0){
                          GetDlgItemText(hwnd,101,temp,255);
                          bfind_struct.value=atof(temp);
                          bfind_struct.col=i;
                          bfind_struct.ok=1;
                      }
                      EndDialog(hwnd,0);
                      return 1;
                      case 103:
                      EndDialog(hwnd,0);
                      return 1;
                 }
    }
    return 0;
}        

browser_replace()
{
    char var[20];

        DialogBox(hInst,"BREPLACEDIALOG",NULL,BReplaceFunc);
        if(breplace_struct.ok==0)return;
        if(breplace_struct.col==0)
          strcpy(var,"t");
        else
          strcpy(var,uvar_names[breplace_struct.col-1]);
   
    replace_column(var,breplace_struct.value,my_browser.data,my_browser.maxrow);
    redraw_browser(my_browser);
}



BOOL CALLBACK BReplaceFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    int i;
    char temp[256];
    switch(msg){
        case WM_INITDIALOG:
           SendDlgItemMessage(hwnd,100,CB_ADDSTRING,0,
             (LPARAM)"t");
           for(i=0;i<NEQ;i++){
           sprintf(temp,"%s",uvar_names[i]);
           strlwr(temp);
            SendDlgItemMessage(hwnd,100,CB_ADDSTRING,0,
             (LPARAM)temp);
           }
        
          SetDlgItemText(hwnd,101,breplace_struct.value);
          SendDlgItemMessage(hwnd,100,CB_SETCURSEL,breplace_struct.col,0L);
          breplace_struct.ok=0;
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)){
                     case 102:
                     
                      i=SendDlgItemMessage(hwnd,100,CB_GETCURSEL,0,0L);
                      if(i>=0){
                          GetDlgItemText(hwnd,101,breplace_struct.value,255);
                          if(strlen(breplace_struct.value)>0){
                               breplace_struct.col=i;
                                breplace_struct.ok=1;
                          }
                      }
                      EndDialog(hwnd,0);
                      return 1;
                      case 103:
                      EndDialog(hwnd,0);
                      return 1;
                 }
    }
    return 0;
}        


replace_column(var,form,dat,n)
char *form,*var;
float **dat;
int n;
{
 int com[200],i,j;
 char bob[256];
 int intflag=0;
 int dif_var=-1;
 float old,dt,derv;
 float sum=0.0;
 if(n<2)return;
 
 dt=NJMP*DELTA_T;
/* first check for derivative or integral symbol */
i=0;
while(i<strlen(form)){
  if(!isspace(form[i]))break;
  i++;
  }
 if(form[i]=='&'){ intflag=1; form[i]=' ';}
 if(form[i]=='@'){
   form[i]=' ';
   find_variable(form,&dif_var);
   if(dif_var<0){
     err_msg("No such variable");
     return;
   }
   
 }
   

/*  first compile formula ... */


 if(dif_var<0){
   if(add_expr(form,com,&i)){
     NCON=NCON_START;
     NSYM=NSYM_START;
     err_msg("Illegal formula...");
     return;
   }
 }
/* next check to see if column is known ... */
 
 find_variable(var,&i);
 if(i<0){
   err_msg("No such column...");
   NCON=NCON_START;
   NSYM=NSYM_START;
   return;
 }
 R_COL=i;   

 /* Okay the formula is cool so lets allocate and replace  */

 wipe_rep();
 old_rep=(float *)malloc(sizeof(float)*n);
 REPLACE=1;
 for(i=0;i<n;i++)
 {
   old_rep[i]=dat[R_COL][i];
   if(dif_var<0){
     for(j=0;j<NODE+1;j++)set_ivar(j,(double)dat[j][i]);
     for(j=NODE;j<NEQ;j++)set_val(uvar_names[j],(double)dat[j+1][i]);
     if(intflag){
       sum+=(float)evaluate(com);
       dat[R_COL][i]=sum*dt;
     }
     else dat[R_COL][i]=(float)evaluate(com);
   }
   else {
     if(i==0)derv=(dat[dif_var][1]-dat[dif_var][0])/dt;
     if(i==(n-1))derv=(dat[dif_var][i]-old)/dt;
     /* if(i>0&&i<(n-1))derv=(dat[dif_var][i+1]-old)/(2*dt); */
     if(i>0&&i<(n-1))derv=(dat[dif_var][i+1]-dat[dif_var][i])/dt;
     old=dat[dif_var][i];
     dat[R_COL][i]=derv;
   }
 }
 NCON=NCON_START;
 NSYM=NSYM_START;

}



 wipe_rep()
 {
    if(!REPLACE)return;
    free(old_rep);
    REPLACE=0;
  }

browser_unreplace()
{
 int i,n=my_browser.maxrow;
 if(!REPLACE)return;
 for(i=0;i<n;i++)my_browser.data[R_COL][i]=old_rep[i];
 wipe_rep();
 
 }

 check_for_stor(data)
     float **data;
{
 if(data!=storage){
   err_msg("Only data can be in browser");
   return(0);
 }
   else return(1);
 
}
browser_delcol()
{
  char var[20];  
 if(NEQ<=NEQ_MIN)return;
  if(check_for_stor(my_browser.data)==0)return;
  DialogBox(hInst,"BDELDIALOG",NULL,BDelFunc);
  if(bdel_struct.ok==0)return;
  strcpy(var,uvar_names[bdel_struct.col+NEQ_MIN]); 
  del_stor_col(var,&my_browser);  
}

  
browser_addcol()
{
     if(check_for_stor(my_browser.data)==0)return;
    DialogBox(hInst,"BADDDIALOG",NULL,BAddFunc);
    if(badd_struct.ok==0)return;
  add_stor_col(badd_struct.var,badd_struct.value,&my_browser);   
}





add_stor_col(name,formula,b)
     char *name,*formula;
     BROWSER *b;
{
  int com[400],i,j;
  
  if(add_expr(formula,com,&i)){
    err_msg("Bad Formula .... ");
    return(0);
  }
  if((my_ode[NEQ+FIX_VAR]=(int *)malloc(400))==NULL){
     err_msg("Cant allocate formula space");
     return(0);
   }
  if((storage[NEQ+1]=(float *)malloc(MAXSTOR * sizeof(float)))==NULL){
    err_msg("Cant allocate space ....");
    free(my_ode[NEQ]);
    return(0);
  }
  if((ode_names[NEQ]=(char *)malloc(80))==NULL){
    err_msg("Cannot allocate space ...");
    free(my_ode[NEQ]);
    free(storage[NEQ+1]);
    return(0);
  }
  strcpy(ode_names[NEQ],formula);
  strupr(ode_names[NEQ]);
  for(j=0;j<=i;j++)
    my_ode[NEQ+FIX_VAR][j]=com[j];
  strcpy(uvar_names[NEQ],name);
  strupr(uvar_names[NEQ]);
  for(i=0;i<b->maxrow;i++)
    storage[NEQ+1][i]=0.0;   /*  zero it all   */
  for(i=0;i<b->maxrow;i++){
    for(j=0;j<NODE+1;j++)set_ivar(j,(double)storage[j][i]);
    for(j=NODE;j<NEQ;j++)set_val(uvar_names[j],(double)storage[j+1][i]); 
    storage[NEQ+1][i]=(float)evaluate(com);
  }
  add_var(uvar_names[NEQ],0.0);  /*  this could be trouble .... */
  NEQ++;
  b->maxcol=NEQ+1;
  redraw_browser(*b);  
  return(1);
}

del_stor_col(var,b)
BROWSER *b;
char *var;
{
  int nc;
  int i,j;
  
  find_variable(var,&nc);
  if(nc<0) {
    err_msg("No such column....");
    return;
  }
  if(nc<=NEQ_MIN){ /* NEQ_MIN = NODE+NAUX */
    err_msg("Can't delete that column");
    return;
  }
/*  printf(" nc=%d NEQ= %d\n",nc,NEQ); */
  if(nc<NEQ){
    for(j=nc;j<NEQ;j++){
      for(i=0;i<b->maxrow;i++)
        storage[j][i]=storage[j+1][i];
      for(i=0;i<400;i++)
        my_ode[j-1+FIX_VAR][i]=my_ode[j+FIX_VAR][i];
      strcpy(uvar_names[j-1],uvar_names[j]);
      strcpy(ode_names[j-1],ode_names[j]);
    }
  }
  free(storage[NEQ+1]);
  free(ode_names[NEQ]);
  free(my_ode[NEQ+FIX_VAR]);
  NEQ--;
  b->maxcol=NEQ+1;
  redraw_browser(*b);  
}
  


BOOL CALLBACK BDelFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    int i;
    switch(msg){
        case WM_INITDIALOG:
          for(i=NEQ_MIN;i<NEQ;i++)
           SendDlgItemMessage(hwnd,100,CB_ADDSTRING,0,(LPARAM)uvar_names[i]);
           SendDlgItemMessage(hwnd,100,CB_SETCURSEL,0,0L);
           bdel_struct.ok=0;
   
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)){
                     case 102:
                      i=SendDlgItemMessage(hwnd,100,CB_GETCURSEL,0,0L);
                      if(i>=0){
                          bdel_struct.col=i;
                          bdel_struct.ok=1;
                      }
                         
                      EndDialog(hwnd,0);
                      return 1;
                      case 103:
                      EndDialog(hwnd,0);
                      return 1;
                 }
    }
    return 0;
}        

   
  
BOOL CALLBACK BAddFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
   
    
    switch(msg){
        case WM_INITDIALOG:
          
        
          SetDlgItemText(hwnd,100,badd_struct.var);
            SetDlgItemText(hwnd,101,badd_struct.value);
        
          badd_struct.ok=0;
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)){
                     case 102:
                          GetDlgItemText(hwnd,100,badd_struct.var,19);
                          GetDlgItemText(hwnd,101,badd_struct.value,255);
                          if(strlen(badd_struct.value)&&
                              strlen(badd_struct.var)>0){
                              
                                badd_struct.ok=1;
                          }
                     
                      EndDialog(hwnd,0);
                      return 1;
                      case 103:
                      EndDialog(hwnd,0);
                      return 1;
                 }
    }
    return 0;
}        

  


                               
